-- ***************
-- local functions
-- ***************

show_device = function(ix, number, ingoing, outgoing)
    put('<tr>')
        put('<td align="Left"><p>' ..number.. '</p></td>') 
        put('<td align="Left"><p><input ' .. disabled_string .. ' type="checkbox" name="bluetoothincoming_std_'..ix..'" value="ON"')
        if ingoing == 1 or ingoing == 3 then
            put(' checked')
        end
        put('>' ..current_dictionary("standard")..'</p></td>')
        if CS_SUPPORT ~= "CS_STANDARD" then
            put('<td align="Left"><p><input ' .. disabled_string .. ' type="checkbox" name="bluetoothincoming_prem_'..ix..'" value="ON"')
            if ingoing > 1 then
                put(' checked')
            end
            put('>' ..current_dictionary("3.1kHz audio").. '</p></td>\n')
            
            put('<td align="left"></td>')
            
            if outgoing == 1 then
                put('<td align="Left"><p><input ' .. disabled_string .. ' type="radio" name="bluetoothoutgoing_'..ix..'" value="a">' ..current_dictionary("standard").. '</p></td>')
                put('<td align="Left"><p><input ' .. disabled_string .. ' type="radio" name="bluetoothoutgoing_'..ix..'" value="b" checked>' ..current_dictionary("3.1kHz audio").. '</p></td>\n')
            elseif outgoing == 0 then
                put('<td align="Left"><p><input ' .. disabled_string .. ' type="radio" name="bluetoothoutgoing_'..ix..'" value="a" checked>' ..current_dictionary("standard").. '</p></td>')
                put('<td align="Left"><p><input ' .. disabled_string .. ' type="radio" name="bluetoothoutgoing_'..ix..'" value="b">' ..current_dictionary("3.1kHz audio").. '</p></td>\n')
            else
                put('<td align="Left"><p>' ..current_dictionary("unknown").. ' ' .. outgoing .. '</p></td>\n')
            end
        else
            put('<td align="left" colspan="2"></td>')
        end 
    put('</tr>')
end

-- ********************
-- Initiate static data
-- ********************

namestd = profiles_if.get_profile_name(0)
name32 = profiles_if.get_profile_name(1)
name64 = profiles_if.get_profile_name(2)
name128 = profiles_if.get_profile_name(3)
name1 = profiles_if.get_profile_name(4)
name2 = profiles_if.get_profile_name(5)
name3 = profiles_if.get_profile_name(6)
name256 = profiles_if.get_profile_name(7)

if streaming == "STREAMING_32_256" then
    names = {namestd,name32,name64,name128,name1,name2,name3,name256}
else
    names = {namestd,name32,name64,name128,name1,name2,name3}
end

default_apn = msg_if.lua_read_usim_apn("apn",0)
acl_apn = msg_if.lua_read_usim_apn("acl",0)
if default_apn == "" then
    default_apn = acl_apn
end

-- *****************
-- get current state
-- *****************

status = msg_if.lua_read_interface_status("bluetooth")

--********************* Get and set Bluetooth params **********************************--
    num_of_handset = 0
    dev_no = {}
    ingoing_stat = {}
    outgoing_stat = {}
    id_no = {}
    
    -- Get parms from C
    bluetooth_dev, bluetooth_passkey, bluetooth_visibility,  bluetooth_enaflag = bt_if.get_bt_device()
    if bluetooth_enaflag == 0 then
        status = 1
    else
        status = 0
    end       

    -- Get parms from usif
    if cgilua.cgi["bluetooth_dev_name"]  ~= nil then
        bluetooth_dev = cgilua.cgi["bluetooth_dev_name"]
    end    
    if cgilua.cgi["bluetooth_passkey_name"]  ~= nil then
        bluetooth_passkey = cgilua.cgi["bluetooth_passkey_name"]
    end    
    if cgilua.cgi["bluetooth_visibility_name"]  ~= nil then
        bluetooth_visibility = tonumber(cgilua.cgi["bluetooth_visibility_name"])
    end
    if cgilua.cgi["radio_onoff_bluetooth"] ~= nil then
        if cgilua.cgi["radio_onoff_bluetooth"] == "enabled" then
            bluetooth_enaflag = 1
        elseif cgilua.cgi["radio_onoff_bluetooth"] == "disabled" then
            bluetooth_enaflag = 0
        end
    end
    if cgilua.cgi["bluetooth_country"] ~= nil then
        bluetooth_country = tonumber(cgilua.cgi["bluetooth_country"])
    end

    num_of_handset= bt_if.get_pabx_list_cnt()
    for i = 0, num_of_handset-1 do
        id_no[i], dev_no[i], ingoing_stat[i], outgoing_stat[i]= bt_if.get_pabx_list_record(i)
    end
    bt_if.rel_pabx_list()

    --print('lua:: A bluetooth_dev: ' ..bluetooth_dev)  
    --print('lua:: A bluetooth_passkey: ' ..bluetooth_passkey)  
    --print('lua:: A bluetooth_visibility: ' ..bluetooth_visibility)  

    --print('lua:: A bluetooth_enaflag: ' ..bluetooth_enaflag)  
    
    if cgilua.cgi["submit"] ~= nil then
        --print('lua:: "Apply" pressed ')  
        -- Set parms in C
        bt_if.set_bt_device(bluetooth_dev, bluetooth_passkey, bluetooth_visibility, bluetooth_enaflag)
        bt_if.set_bt_country(bluetooth_country)
         
        -- Get parms from C   
        bluetooth_dev, bluetooth_passkey, bluetooth_visibility,  bluetooth_enaflag = bt_if.get_bt_device()
        if bluetooth_enaflag == 0 then
            status = 1
        else
            status = 0
        end        
    end
    bluetooth_country = bt_if.get_bt_country()
    if hasWLAN == TT_TRUE then
        wlan_cc = msg_if.lua_get_wlan_country()
        if wlan_cc ~= "" then
            if wlan_cc == "FR" and bluetooth_country ~= 0 then
                error_msg = current_dictionary("country does not match")
            elseif wlan_cc ~= "FR" and bluetooth_country == 0 then
                error_msg = current_dictionary("country does not match")
            end
        end
    end

    
    --print('lua:: B bluetooth status: ' ..status)  


    --print('lua:: B bluetooth_dev: ' ..bluetooth_dev)  
    --print('lua:: B bluetooth_passkey: ' ..bluetooth_passkey)  
    --print('lua:: B bluetooth_visibility: ' ..bluetooth_visibility)  
    
    for i = 0, num_of_handset-1 do
        bt_outgoing= "bluetoothoutgoing_" .. i
        if cgilua.cgi[bt_outgoing] ~= nil then
            if cgilua.cgi[bt_outgoing] == "a" then
                outgoing_stat[i]= 0
            end
            if cgilua.cgi[bt_outgoing] == "b" then
                outgoing_stat[i]= 1
            end
        end
    end
    
    for i = 0, num_of_handset-1 do
        bt_incoming_std= "bluetoothincoming_std_" .. i
        bt_incoming_prem= "bluetoothincoming_prem_" .. i
        if cgilua.cgi[bt_incoming_std] ~= nil and cgilua.cgi[bt_incoming_prem] ~= nil then
            ingoing_stat[i]= 3
            bt_if.set_pabx_list_record(id_no[i], outgoing_stat[i], ingoing_stat[i])
        elseif cgilua.cgi[bt_incoming_prem] ~= nil then
            ingoing_stat[i]= 2
            bt_if.set_pabx_list_record(id_no[i], outgoing_stat[i], ingoing_stat[i])
        elseif cgilua.cgi[bt_incoming_std] ~= nil then
            ingoing_stat[i]= 1
            bt_if.set_pabx_list_record(id_no[i], outgoing_stat[i], ingoing_stat[i])
        else
            if cgilua.cgi["submit"] ~= nil then
                ingoing_stat[i]= 1
                bt_if.set_pabx_list_record(id_no[i], outgoing_stat[i], ingoing_stat[i])
            end
        end
    end

    if cgilua.cgi["submit"] ~= nil then
        num_of_handset= bt_if.get_pabx_list_cnt()
        for i = 0, num_of_handset-1 do
            id_no[i], dev_no[i], ingoing_stat[i], outgoing_stat[i]= bt_if.get_pabx_list_record(i)
        end
        bt_if.rel_pabx_list()
    end

    bt_lan_apn= ""
    bt_dun_apn= ""
    bt_lan_hcomp_status= bt_if.get_header_comp(0)
    bt_dun_hcomp_status= bt_if.get_header_comp(1)
    bt_lan_apn_info= bt_if.get_apn_info(0)
    bt_dun_apn_info= bt_if.get_apn_info(1)
    bt_lan_ip4a1, bt_lan_ip4a2, bt_lan_ip4a3, bt_lan_ip4a4, bt_lan_apn, bt_lan_username, bt_lan_password= bt_if.get_pdp_context(0)
    bt_dun_ip4a1, bt_dun_ip4a2, bt_dun_ip4a3, bt_dun_ip4a4, bt_dun_apn, bt_dun_username, bt_dun_password= bt_if.get_pdp_context(1)
    bt_lan_pri, sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10 = bt_if.get_profile_list(0)
    bt_lan_sec= {sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10}
    bt_dun_pri, sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10 = bt_if.get_profile_list(1)
    bt_dun_sec= {sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10}
    
    if cgilua.cgi["bt_lan_hcomp"] ~= nil then
        if cgilua.cgi["bt_lan_hcomp"] == "enabled" then
            bt_if.set_header_comp(0, 1)
            bt_lan_hcomp_status= 1
        elseif cgilua.cgi["bt_lan_hcomp"] == "disabled" then
            bt_if.set_header_comp(0, 0)
            bt_lan_hcomp_status= 0
        end
    end

    if cgilua.cgi["bt_dun_hcomp"] ~= nil then
        if cgilua.cgi["bt_dun_hcomp"] == "enabled" then
            bt_if.set_header_comp(1, 1)
            bt_dun_hcomp_status= 1
        elseif cgilua.cgi["bt_dun_hcomp"] == "disabled" then
            bt_if.set_header_comp(1, 0)
            bt_dun_hcomp_status= 0
        end
    end
    
    if cgilua.cgi["bt_lan_apn_in"] ~= nil then
        if cgilua.cgi["bt_lan_apn_in"] == "V1" then
            common_apn_info = bt_if.get_apn_info(4)
            if common_apn_info == 1 then
                bt_lan_apn = default_apn
            elseif common_apn_info == 2 then
                bt_lan_apn = ""
            elseif common_apn_info == 3 then
                c1, c2, c3, c4, bt_lan_apn, c5, c6 = msg_if.lua_get_pdp_context("common")
            end
            bt_if.set_apn_info(0,0)
        elseif cgilua.cgi["bt_lan_apn_in"] == "V2" then
            bt_if.set_apn_info(0,1)
            bt_lan_apn= default_apn
        elseif cgilua.cgi["bt_lan_apn_in"] == "V3" then
            bt_if.set_apn_info(0,2)
            bt_lan_apn = ""
        elseif cgilua.cgi["bt_lan_apn_in"] == "V4" then
            bt_if.set_apn_info(0,3)
            if cgilua.cgi["bt_lan_apn_text"] ~= nil then
                bt_lan_apn = cgilua.cgi["bt_lan_apn_text"]
            end
        end
        bt_lan_apn_info= bt_if.get_apn_info(0)
    end

    if cgilua.cgi["bt_dun_apn_in"] ~= nil then
        if cgilua.cgi["bt_dun_apn_in"] == "V1" then
            common_apn_info = bt_if.get_apn_info(4)
            if common_apn_info == 1 then
                bt_dun_apn = default_apn
            elseif common_apn_info == 2 then
                bt_dun_apn = ""
            elseif common_apn_info == 3 then
                c1, c2, c3, c4, bt_dun_apn, c5, c6 = msg_if.lua_get_pdp_context("common")
            end
            bt_if.set_apn_info(1,0)
        elseif cgilua.cgi["bt_dun_apn_in"] == "V2" then
            bt_if.set_apn_info(1,1)
            bt_dun_apn= default_apn
        elseif cgilua.cgi["bt_dun_apn_in"] == "V3" then
            bt_if.set_apn_info(1,2)
            bt_dun_apn = ""
        elseif cgilua.cgi["bt_dun_apn_in"] == "V4" then
            bt_if.set_apn_info(1,3)
            if cgilua.cgi["bt_dun_apn_text"] ~= nil then
                bt_dun_apn = cgilua.cgi["bt_dun_apn_text"]
            end
        end
        bt_dun_apn_info= bt_if.get_apn_info(1)
    end
    
    if cgilua.cgi["bt_lan_usernamePdp"] ~= nil then
        bt_lan_username = cgilua.cgi["bt_lan_usernamePdp"]
    end
    if cgilua.cgi["bt_lan_passwordPdp"] ~= nil then
        bt_lan_password = cgilua.cgi["bt_lan_passwordPdp"] 
    end
    if cgilua.cgi["bt_dun_usernamePdp"] ~= nil then
        bt_dun_username = cgilua.cgi["bt_dun_usernamePdp"]
    end
    if cgilua.cgi["bt_dun_passwordPdp"] ~= nil then
        bt_dun_password = cgilua.cgi["bt_dun_passwordPdp"] 
    end

    if cgilua.cgi["BT_LAN_TCPIP"] ~= nil then
        if cgilua.cgi["BT_LAN_TCPIP"] == "V1" then
            bt_if.set_pdp_context(0,bt_lan_apn,0,0,0,0,bt_lan_username,bt_lan_password)
        elseif cgilua.cgi["BT_LAN_TCPIP"] == "V2" then
            if cgilua.cgi["BT_LAN_IP_A1"] ~= nil and cgilua.cgi["BT_LAN_IP_A2"] ~= nil and cgilua.cgi["BT_LAN_IP_A3"] ~= nil and cgilua.cgi["BT_LAN_IP_A4"] ~= nil then
                bt_if.set_pdp_context(0,bt_lan_apn,cgilua.cgi["BT_LAN_IP_A1"],cgilua.cgi["BT_LAN_IP_A2"],cgilua.cgi["BT_LAN_IP_A3"],cgilua.cgi["BT_LAN_IP_A4"],bt_lan_username,bt_lan_password)    
            else
                error_msg = current_dictionary("please enter a static ip address")
            end  
        end
        bt_lan_ip4a1, bt_lan_ip4a2, bt_lan_ip4a3, bt_lan_ip4a4, bt_lan_apn, bt_lan_username, bt_lan_password= bt_if.get_pdp_context(0)
    end 

    if cgilua.cgi["BT_DUN_TCPIP"] ~= nil then
        if cgilua.cgi["BT_DUN_TCPIP"] == "V1" then
            bt_if.set_pdp_context(1,bt_dun_apn,0,0,0,0,bt_dun_username,bt_dun_password)
        elseif cgilua.cgi["BT_DUN_TCPIP"] == "V2" then
            if cgilua.cgi["BT_DUN_IP_A1"] ~= nil and cgilua.cgi["BT_DUN_IP_A2"] ~= nil and cgilua.cgi["BT_DUN_IP_A3"] ~= nil and cgilua.cgi["BT_DUN_IP_A4"] ~= nil then
                bt_if.set_pdp_context(1,bt_dun_apn,cgilua.cgi["BT_DUN_IP_A1"],cgilua.cgi["BT_DUN_IP_A2"],cgilua.cgi["BT_DUN_IP_A3"],cgilua.cgi["BT_DUN_IP_A4"],bt_dun_username,bt_dun_password)    
            else
                error_msg = current_dictionary("please enter a static ip address")
            end  
        end
        bt_dun_ip4a1, bt_dun_ip4a2, bt_dun_ip4a3, bt_dun_ip4a4, bt_dun_apn, bt_dun_username, bt_dun_password= bt_if.get_pdp_context(1)
    end

    if cgilua.cgi["bt_lan_primaryconnectionclass"] ~= nil then
        if tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[1] then
            bt_lan_pri = 0
        elseif tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[2] then
            bt_lan_pri = 1
        elseif tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[3] then
            bt_lan_pri = 2
        elseif tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[4] then
            bt_lan_pri = 3
        elseif tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[5] then
            bt_lan_pri = 4
        elseif tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[6] then
            bt_lan_pri = 5
        elseif tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[7] then
            bt_lan_pri = 6
        elseif tostring(cgilua.cgi["bt_lan_primaryconnectionclass"]) == names[8] then
            bt_lan_pri = 7
        else
            bt_lan_pri = 255
        end
    end
    if cgilua.cgi["bt_dun_primaryconnectionclass"] ~= nil then
        if tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[1] then
            bt_dun_pri = 0
        elseif tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[2] then
            bt_dun_pri = 1
        elseif tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[3] then
            bt_dun_pri = 2
        elseif tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[4] then
            bt_dun_pri = 3
        elseif tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[5] then
            bt_dun_pri = 4
        elseif tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[6] then
            bt_dun_pri = 5
        elseif tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[7] then
            bt_dun_pri = 6
        elseif tostring(cgilua.cgi["bt_dun_primaryconnectionclass"]) == names[8] then
            bt_dun_pri = 7
        else
            bt_dun_pri = 255
        end
    end

    trace(0, 1, string.format("lua - bt_lan_pri: %d, bt_dun_pri: %d", bt_lan_pri, bt_dun_pri))

    if cgilua.cgi["bt_lan_secondaryconnectionclass"] ~= nil then
        bt_lan_sec= {255,255,255,255,255,255,255,255}
        for i = 1,table.getn(names) do
            if tostring(cgilua.cgi["bt_lan_secondaryconnectionclass"]) == names[i] then
                bt_lan_sec[1] = i-1
            end 
        end
    end
    if cgilua.cgi["bt_dun_secondaryconnectionclass"] ~= nil then
        bt_dun_sec= {255,255,255,255,255,255,255,255}
        for i = 1,table.getn(names) do
            if tostring(cgilua.cgi["bt_dun_secondaryconnectionclass"]) == names[i] then
                bt_dun_sec[1] = i-1
            end 
        end
    end

    if cgilua.cgi["bt_lan_primaryconnectionclass"] ~= nil then
        bt_if.set_profile_list(0,bt_lan_pri,bt_lan_sec[1],bt_lan_sec[2],bt_lan_sec[3],bt_lan_sec[4],bt_lan_sec[5],bt_lan_sec[6],bt_lan_sec[7],bt_lan_sec[8])
        bt_lan_pri, bt_lan_sec[1],bt_lan_sec[2],bt_lan_sec[3],bt_lan_sec[4],bt_lan_sec[5],bt_lan_sec[6],bt_lan_sec[7], sec8, sec9, sec10= bt_if.get_profile_list(0)
    end
    if cgilua.cgi["bt_dun_primaryconnectionclass"] ~= nil then
        bt_if.set_profile_list(1,bt_dun_pri,bt_dun_sec[1],bt_dun_sec[2],bt_dun_sec[3],bt_dun_sec[4],bt_dun_sec[5],bt_dun_sec[6],bt_dun_sec[7],bt_dun_sec[8])
        bt_dun_pri, bt_dun_sec[1],bt_dun_sec[2],bt_dun_sec[3],bt_dun_sec[4],bt_dun_sec[5],bt_dun_sec[6],bt_dun_sec[7], sec8, sec9, sec10= bt_if.get_profile_list(1)
    end

--********************* End Bluetooth parms ***********************************--

-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_bluetooth")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end


--print('APN ok? ' .. apn)

--print html
put(start_of_content)
put('<p id="errortext">' .. error_msg .. '</p>')
put('<p><table border="'..border_on..'" cellpadding="0" align="left">')

    put('<form name="settings_interfaces" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')
    --******************  Bluetooth page: *******************************************--
    put('\n')
    put('<tr>')
        put('<th align="left" colspan="3"><p class="menutext">' .. current_dictionary("interface status") .. '</p></th>')
    put('</tr>')                    
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("bluetooth interface") .. '</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_onoff_bluetooth" value="enabled"' ..checked_text(status == 0).. '>'.. current_dictionary("enabled") ..'</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_onoff_bluetooth" value="disabled" onclick="show_disable_warning()" ' ..checked_text(status == 1).. '>'..current_dictionary("disabled").. '</p></td>')
        put('\n')
    put('</tr>')                    
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("country").. ' </p></td>')
        put('<td align="left" colspan="2"><p><select ' .. disabled_string .. ' size="1" name="bluetooth_country"></p>')
            put('<option value="0"' .. option_text(bluetooth_country==0) .. '>' ..current_dictionary("france").. '</option>\n')
            put('<option value="1"' .. option_text(bluetooth_country==1) .. '>' ..current_dictionary("country_other").. '</option>\n')
        put('</select></td>')                
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("device name").. ' </p></td>')
        put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" name="bluetooth_dev_name" maxlength="32" size="32" value="' ..bluetooth_dev.. '"></p></td>')
        put('\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("default passkey").. ' </p></td>')
        put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" name="bluetooth_passkey_name" maxlength="16" size="16" value="' ..bluetooth_passkey.. '"></p></td>')
        put('\n')          
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("visibility").. ' </p></td>')
        put('<td align="left" colspan="2"><p><select ' .. disabled_string .. ' size="1" name="bluetooth_visibility_name"></p>')
            put('<option value="0"' .. option_text(bluetooth_visibility==0) .. '>' ..current_dictionary("hide").. '</option>\n')
            put('<option value="1"' .. option_text(bluetooth_visibility==1) .. '>' ..current_dictionary("show").. '</option>\n')
        put('</select></td>')                
    put('</tr>')
    put('<tr>')
        put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("bluetooth voice devices") .. '&nbsp;</p></th>\n') 
    put('</tr>')
    put('<tr>')
        put('<th align="left"><p>' ..current_dictionary("Phone") .. '</p></th>') 
        put('<th align="left" colspan="3"><p>' ..current_dictionary("incoming calls") .. '</p></th>')
        if CS_SUPPORT ~= "CS_STANDARD" then                 
            put('<th align="left" colspan="2"><p>' ..current_dictionary("outgoing calls") .. '</p></th>\n') 
        end
    put('</tr>')
    for i = 0, num_of_handset-1 do
        show_device(i, dev_no[i], ingoing_stat[i], outgoing_stat[i])
    end        
    put('<tr>')
        put('<td align="left">&nbsp;</td>')
    put('</tr>')
    if hasBtLan == TT_TRUE then
        put('<tr>')
            put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("bluetooth lan devices")..'</p></th>') 
        put('</tr>')
        put('<tr>')
             put('<td align="left"><p>' ..current_dictionary("ip header compression").. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_lan_hcomp" value="enabled"' ..checked_text(bt_lan_hcomp_status == 1)..'>' .. current_dictionary("enabled") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_lan_hcomp" value="disabled"' ..checked_text(bt_lan_hcomp_status == 0).. '>'.. current_dictionary("disabled") .. '</p></td>\n')
        put('</tr>')
        if bt_lan_ip4a1 == 0 and bt_lan_ip4a2 == 0 and bt_lan_ip4a3 == 0 and bt_lan_ip4a4 == 0 then
            dynamic= 0
        else
            dynamic= 1
        end
        put('<tr>')
            put('<th align="left" colspan="3"><p class="menutext">TCP/IP</p></th>\n')
        put('</tr>')  
        put('<tr>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" value="V1" name="BT_LAN_TCPIP"' ..checked_text(dynamic == 0).. '>' ..current_dictionary("dynamic ip address").. '</p></td>\n')
        put('</tr>')        
        put('<tr>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" value="V2" name="BT_LAN_TCPIP"' ..checked_text(dynamic == 1).. '>' ..current_dictionary("static ip address").. '</p></td>')
            if dynamic == 0 then
                put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A1" size="3">.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A2" size="3">.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A3" size="3">.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A4" size="3"></p></td>\n')
            else
                put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A1" size="3" value=' .. bt_lan_ip4a1 .. '>.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A2" size="3" value=' .. bt_lan_ip4a2 .. '>.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A3" size="3" value=' .. bt_lan_ip4a3 .. '>.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_LAN_IP_A4" size="3" value=' .. bt_lan_ip4a4 .. '></p></td>\n')
            end
        put('</tr>')
        put('<tr>')
            put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("apn").. '</p></th>\n')
        put('</tr>')        
        put('<tr>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" value="V1" name="bt_lan_apn_in"' ..checked_text(bt_lan_apn_info == 0).. '>' ..current_dictionary("common").. '</p></td>\n')
        put('</tr>') 
        put('<tr>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_lan_apn_in" value="V2"' ..checked_text(bt_lan_apn_info == 1).. '>' ..current_dictionary("sim default").. '</p></td>\n')
        put('</tr>') 
        put('<tr>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_lan_apn_in" value="V3"' ..checked_text(bt_lan_apn_info == 2).. '>' ..current_dictionary("network assigned").. '</p>\</td>\n')
        put('</tr>') 
        put('<tr>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_lan_apn_in" value="V4"' ..checked_text(bt_lan_apn_info == 3).. '>' ..current_dictionary("user defined").. '</p></td>')
            put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" name="bt_lan_apn_text" size="28" value="' .. bt_lan_apn ..'"></p></td>\n')
        put('</tr>') 
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("username").. '</p></td>')
            put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" name="bt_lan_usernamePdp" value="' .. bt_lan_username ..'"></p></td>')
        put('</tr>') 
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("password").. '</p></td>')
            put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="password" name="bt_lan_passwordPdp" value="' .. bt_lan_password .. '"></p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("profiles").. '</p></th>\n')
        put('</tr>')  
        put('<tr>')
            put('<td valign="top" align="left"><p>' ..current_dictionary("primary") .. '</p></td>')
            put('<td align="left" colspan="2"><select ' .. disabled_string .. ' size="7" name="bt_lan_primaryconnectionclass">')
                put('<option ' ..selected_text(bt_lan_pri == 0).. '>' ..names[1].. '</option>\n')
                put('<option ' ..selected_text(bt_lan_pri == 1).. '>' ..names[2]..'</option>\n')
                put('<option ' ..selected_text(bt_lan_pri == 2).. '>' ..names[3]..'</option>\n')
                if streaming ~= "STREAMING_32_64" then 
                    put('<option ' ..selected_text(bt_lan_pri == 3).. '>' ..names[4]..'</option>\n')
                end
                if streaming == "STREAMING_32_256" then 
                    put('<option ' ..selected_text(bt_lan_pri == 7).. '>' ..names[8]..'</option>\n')
                end
                put('<option ' ..selected_text(bt_lan_pri == 4).. '>' ..names[5].. '</option>\n')
                put('<option ' ..selected_text(bt_lan_pri == 5).. '>' ..names[6].. '</option>\n')
                if streaming ~= "STREAMING_32_256" then 
                    put('<option ' ..selected_text(bt_lan_pri == 6).. '>' ..names[7].. '</option>\n')
                end
            put('</select></td>\n')
        put('</tr>') 
        put('<tr>')
            put('<td valign="top" align="left"><p>' ..current_dictionary("secondary") .. '</p></td>')
            put('<td align="left" colspan="2"><p><select ' .. disabled_string .. ' size="8" name="bt_lan_secondaryconnectionclass" >')
            --Option none only for use with ONE secondary context        
            put('<option ' ..selected_text(bt_dun_sec[1] == 255).. '>' .. current_dictionary("none") .. '</option>\n')
            --streaming 32,64,128
            for i = 1,4 do
                if streaming == "STREAMING_32_64" and i == 4 then 
                   break   
                end
                not_selected= 1
                for j = 1,table.getn(bt_lan_sec) do
                    if bt_lan_sec[j]+1 == i then
                        not_selected = 0
                    end
                end
                put('<option ' ..selected_text(not_selected == 0).. '>' .. names[i] .. '</option>\n')
            end
            if streaming == "STREAMING_32_256" then
                not_selected= 1
                for j = 1,table.getn(bt_lan_sec) do
                    if bt_lan_sec[j]+1 == 8 then
                        not_selected = 0
                    end
                end
                put('<option ' ..selected_text(not_selected == 0).. '>' .. names[8] .. '</option>\n')
            end
            for i = 5,7 do
                if streaming == "STREAMING_32_256" and i == 7 then 
                    break
                end
                not_selected= 1
                for j = 1,table.getn(bt_lan_sec) do
                    if bt_lan_sec[j]+1 == i then
                        not_selected = 0
                    end
                end
                put('<option ' ..selected_text(not_selected == 0).. '>' .. names[i] .. '</option>\n')
            end
            put('</select></p></td>\n')
        put('</tr>') 
        put('<tr>')
            put('<td align="left">&nbsp;</td>')
        put('</tr>')
    end  
    put('<tr>')
        put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("bluetooth dialup network devices")..'</p></th>\n') 
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>&nbsp;' ..current_dictionary("ip header compression").. '</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_dun_hcomp" value="enabled"' ..checked_text(bt_dun_hcomp_status == 1)..'>' .. current_dictionary("enabled") .. '</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_dun_hcomp" value="disabled"' ..checked_text(bt_dun_hcomp_status == 0).. '>'.. current_dictionary("disabled") .. '</p></td>\n')
    put('</tr>')
    if bt_dun_ip4a1 == 0 and bt_dun_ip4a2 == 0 and bt_dun_ip4a3 == 0 and bt_dun_ip4a4 == 0 then
        dynamic= 0
    else
        dynamic= 1
    end
    put('<tr>')
        put('<th align="left" colspan="3"><p class="menutext">TCP/IP</p></th>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" value="V1" name="BT_DUN_TCPIP"' ..checked_text(dynamic == 0).. '>' ..current_dictionary("dynamic ip address").. '</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" value="V2" name="BT_DUN_TCPIP"' ..checked_text(dynamic == 1).. '>' ..current_dictionary("static ip address").. '</p></td>')
        if dynamic == 0 then
            put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A1" size="3">.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A2" size="3">.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A3" size="3">.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A4" size="3"></p></td>\n')
        else
            put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A1" size="3" value=' .. bt_dun_ip4a1 .. '>.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A2" size="3" value=' .. bt_dun_ip4a2 .. '>.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A3" size="3" value=' .. bt_dun_ip4a3 .. '>.<input ' .. disabled_string .. ' type="text" maxlength="3" name="BT_DUN_IP_A4" size="3" value=' .. bt_dun_ip4a4 .. '></p></td>\n')
        end
    put('</tr>')
    put('<tr>')
        put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("apn").. '</p></th>\n')
    put('</tr>') 
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" value="V1" name="bt_dun_apn_in"' ..checked_text(bt_dun_apn_info == 0).. '>' ..current_dictionary("common").. '</p></td>\n')
    put('</tr>') 
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_dun_apn_in" value="V2"' ..checked_text(bt_dun_apn_info == 1).. '>' ..current_dictionary("sim default").. '</p></td>\n')
    put('</tr>') 
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_dun_apn_in" value="V3"' ..checked_text(bt_dun_apn_info == 2).. '>' ..current_dictionary("network assigned").. '</p>\</td>\n')
    put('</tr>') 
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="bt_dun_apn_in" value="V4"' ..checked_text(bt_dun_apn_info == 3).. '>' ..current_dictionary("user defined").. '</p></td>')
        put('<td align="left" colspan="3"><p><input ' .. disabled_string .. ' type="text" name="bt_dun_apn_text" size="28" value="' .. bt_dun_apn ..'"></p></td>\n')
    put('</tr>') 
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("username").. '</p></td>')
        put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" name="bt_dun_usernamePdp" value="' .. bt_dun_username ..'"></p></td>')
    put('</tr>') 
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("password").. '</p></td>')
        put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="password" name="bt_dun_passwordPdp" value="' .. bt_dun_password .. '"></p></td>\n')
    put('</tr>')
    put('<tr>')
            put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("profiles").. '</p></th>\n')
    put('</tr>')  
    put('<tr>')
        put('<td align="left" valign="top"><p>' ..current_dictionary("primary") .. '</p></td>')
        put('<td align="left" colspan="2"><select ' .. disabled_string .. ' size="7" name="bt_dun_primaryconnectionclass">')
            put('<option ' ..selected_text(bt_dun_pri == 0).. '>' ..names[1].. '</option>\n')
            put('<option ' ..selected_text(bt_dun_pri == 1).. '>' ..names[2]..'</option>\n')
            put('<option ' ..selected_text(bt_dun_pri == 2).. '>' ..names[3]..'</option>\n')
            if streaming ~= "STREAMING_32_64" then
                put('<option ' ..selected_text(bt_dun_pri == 3).. '>' ..names[4]..'</option>\n')
            end
            if streaming == "STREAMING_32_256" then
                put('<option ' ..selected_text(bt_dun_pri == 7).. '>' ..names[8]..'</option>\n')
            end
            put('<option ' ..selected_text(bt_dun_pri == 4).. '>' ..names[5].. '</option>\n')
            put('<option ' ..selected_text(bt_dun_pri == 5).. '>' ..names[6].. '</option>\n')
            if streaming ~= "STREAMING_32_256" then
                put('<option ' ..selected_text(bt_dun_pri == 6).. '>' ..names[7].. '</option>\n')
            end
        put('</select></td>\n')
    put('</tr>') 
    put('<tr>')
        put('<td align="left" valign="top"><p>' ..current_dictionary("secondary") .. '</p></td>')
        put('<td align="left" colspan="2"><p><select ' .. disabled_string .. ' size="8" name="bt_dun_secondaryconnectionclass">')
        --Option none only for use with ONE secondary context        
        put('<option ' ..selected_text(bt_dun_sec[1] == 255).. '>' .. current_dictionary("none") .. '</option>\n')
        --streaming 32,64,128
        for i = 1,4 do
            if streaming == "STREAMING_32_64" and i == 4 then 
                break   
            end
            not_selected= 1
            for j = 1,table.getn(bt_dun_sec) do
                if bt_dun_sec[j]+1 == i then
                    not_selected = 0
                end
            end
            put('<option ' ..selected_text(not_selected == 0).. '>' .. names[i] .. '</option>\n')
        end
        --streaming 256
        if streaming == "STREAMING_32_256" then 
            not_selected= 1
            for j = 1,table.getn(bt_dun_sec) do
                if bt_dun_sec[j]+1 == 8 then
                    not_selected = 0
                end
            end
            put('<option ' ..selected_text(not_selected == 0).. '>' .. names[8] .. '</option>\n')
        end

        --user defined
        for i = 5,7 do
            if streaming == "STREAMING_32_256" and i == 7 then 
                break
            end 
            not_selected= 1
            for j = 1,table.getn(bt_dun_sec) do
                if bt_dun_sec[j]+1 == i then
                    not_selected = 0
                end
            end
            put('<option ' ..selected_text(not_selected == 0).. '>' .. names[i] .. '</option>\n')
        end

        put('</select></p></td>\n')
    put('</tr>') 
    
    --*********************************** End Bluetooth page: *******************************************--
    
    --submit button
    put('<tr>')
        put('<td align="left" colspan="3"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>')
put('</form></table></p>\n')



put(end_of_content)

