test = false   -- true: test mode, false: 'real' mode where parameters are stored and retrived through C function calls

error_msg = ""
debug_msg = ""

--print('lua, page_title:'..page_title)

status_text = function(status_enum)
    if status_enum == 0 then
        ret_text = "Unpaired"
    elseif status_enum == 1 then
        ret_text = "Paired"
    elseif status_enum == 2 then
        ret_text = "Connected"
    elseif status_enum == 3 then
        ret_text = "Requesting"
    elseif status_enum == 4 then
        ret_text = "Paired,connected"
    elseif status_enum == 5 then
        ret_text = "Unknown"
    else
        ret_text = "Unknown"
    end
    --trace(0,1,string.format("bt status %d %s",status_enum,ret_text))
    return ret_text
end

deviceclass_text = function(class_enum)
    if class_enum == 0 then
        ret_text = "Miscellaneous"
    elseif class_enum == 1 then
        ret_text = "Computer"
    elseif class_enum == 2 then
        ret_text = "Phone"
    elseif class_enum == 3 then
        ret_text = "Lan Access Point"
    elseif class_enum == 4 then
        ret_text = "Audio"
    elseif class_enum == 5 then
        ret_text = "Periph. keyboard"
    elseif class_enum == 6 then
        ret_text = "Periph. pointing"
    elseif class_enum == 7 then
        ret_text = "Periph. combokey"
    elseif class_enum == 8 then
        ret_text = "Peripheral"
    elseif class_enum == 9 then
        ret_text = "Imaging"
    elseif class_enum == 10 then
        ret_text = "Unclassified"
    elseif class_enum == 11 then
        ret_text = "Unknown"
    elseif class_enum == 12 then
        ret_text = " "
    elseif class_enum == 13 then
        ret_text = "Desktop"
    elseif class_enum == 14 then
        ret_text = "Server"
    elseif class_enum == 15 then
        ret_text = "Laptop"
    elseif class_enum == 16 then
        ret_text = "Handheld"
    elseif class_enum == 17 then
        ret_text = "Palm"
    elseif class_enum == 18 then
        ret_text = "Cellular"
    elseif class_enum == 19 then
        ret_text = "Cordless"
    elseif class_enum == 20 then
        ret_text = "Smart"
    elseif class_enum == 21 then
        ret_text = "Modem"
    elseif class_enum == 22 then
        ret_text = "Isdn"
    elseif class_enum == 23 then
        ret_text = "fully available"
    elseif class_enum == 24 then
        ret_text = "1-17% utilized"
    elseif class_enum == 25 then
        ret_text = "17-33% utilized"
    elseif class_enum == 26 then
        ret_text = "33-50% utilized"
    elseif class_enum == 27 then
        ret_text = "50-67% utilized"
    elseif class_enum == 28 then
        ret_text = "67-83% utilized"
    elseif class_enum == 29 then
        ret_text = "83-99% utilized"
    elseif class_enum == 30 then
        ret_text = "100% utilized"
    elseif class_enum == 31 then
        ret_text = "Headset"
    elseif class_enum == 32 then
        ret_text = "Microphone"
    elseif class_enum == 33 then
        ret_text = "Loudspeaker"
    elseif class_enum == 34 then
        ret_text = "Portable"
    elseif class_enum == 35 then
        ret_text = "Car"
    elseif class_enum == 36 then
        ret_text = "Setopbox"
    elseif class_enum == 37 then
        ret_text = "Hifi"
    elseif class_enum == 38 then
        ret_text = "Vcr"
    elseif class_enum == 39 then
        ret_text = "Videocamera"
    elseif class_enum == 40 then
        ret_text = "Camcorder"
    elseif class_enum == 41 then
        ret_text = "Videomonitor"
    elseif class_enum == 42 then
        ret_text = "Videospeaker"
    elseif class_enum == 43 then
        ret_text = "Conferencing"
    elseif class_enum == 44 then
        ret_text = "Gaming"
    elseif class_enum == 45 then
        ret_text = "Joystick"
    elseif class_enum == 46 then
        ret_text = "Gamepad"
    elseif class_enum == 47 then
        ret_text = "Remotecontrol"
    elseif class_enum == 48 then
        ret_text = "Sensing"
    elseif class_enum == 49 then
        ret_text = "Digitizer"
    elseif class_enum == 50 then
        ret_text = "Cardreader"
    elseif class_enum == 51 then
        ret_text = "Display"
    elseif class_enum == 52 then
        ret_text = "Camera"
    elseif class_enum == 53 then
        ret_text = "Scanner"
    elseif class_enum == 54 then
        ret_text = "Printer"
    else
        ret_text = " "
    end
    return ret_text
end
    
show_device_to_pair = function(name, dev_class_major, dev_class_minor, pass_key)
    -- don't lookup empty string in dictionary
    if dev_class_minor == " " then
        minor_text = dev_class_minor
    else
        minor_text = current_dictionary(dev_class_minor)
    end

    put('<tr>')
        put('<td align="left"><p>' ..name.. '</p></td>') 
        put('<td align="center"><p>' ..current_dictionary(dev_class_major).. ' ' ..minor_text.. '</p></td>')
        put('<td align="center"><p><input ' .. disabled_string .. ' type="text" name="passKey_name" maxlength="16" size="16" value="' ..pass_key..'"></p></td>')
    put('</tr>')
end

show_device = function(device_no, no, name, dev_class_major, dev_class_minor, status, key)
    -- don't lookup empty string in dictionary
    if dev_class_minor == " " then
        minor_text = dev_class_minor
    else
        minor_text = current_dictionary(dev_class_minor)
    end
    
    put('<tr>')
        put('<td align="left"><p>' ..name.. '</p></td>') 
        put('<td align="center"><p>' ..current_dictionary(dev_class_major).. ' ' ..minor_text.. '</p></td>')
        put('<td align="center"><p>' ..current_dictionary(status).. '</p></td>')
        put('<td align="center"><p>' ..no.. '</p></td>')

        put('<td align=center"><p>')
            if page_title == "Paired devices" then
                link_generate ("Add device", "&amp;KeyForUnpair=" ..key..'"', "unpair", "norm")
            elseif page_title == "Add device" then
                link_generate (page_title, "&amp;PairName=" ..name.. "&amp;DevClassMajor=" ..dev_class_major.. "&amp;DevClassMinor=" ..dev_class_minor.. "&amp;KeyToPair=" ..key.. '"', "pair", "norm") -- Link to "Pair"-page
            end    
        put('</p></td>')
    put('</tr>')
end

num_of_devices = 0
no = {}
name = {}
dev_class_major = {}
dev_class_minor = {}
status = {}
key = {}


pair_pressed = false
if page_title == "Paired devices" then
    --Parse URL
    -- Catch parms for press of "Update"
    if cgilua.cgi["update"] ~= nil then
        --print('bluetooth_devices: update pressed')
    end   
    -- Catch parms for press of "Accept" on Add Device "Pair window"
    pass_key_exists = false 
    if cgilua.cgi["passKey_name"]  ~= nil then
        pass_key = cgilua.cgi["passKey_name"]
        --print('lua, bluetooth_pair, pass_key: ' ..pass_key)
        pass_key_exists = true 
    end
    key_from_pair_exists = false
    if cgilua.cgi["KeyFromPair"]  ~= nil then
        key_from_pair = cgilua.cgi["KeyFromPair"]
        --print('lua, bluetooth_pair, KeyFromPair: ' ..key_from_pair)
        key_from_pair_exists = true
    end
        
    if cgilua.cgi["accept"] ~= nil then
        --print('bluetooth_devices: accept pressed')
        if (test == false) and pass_key_exists and key_from_pair_exists then
            bt_if.send_access(tonumber(key_from_pair), 1, pass_key)  --Accept
        end
    end    

    --Get Parms
    if test then
        num_of_devices = 2
        name = {"dev1", "dev2"}  
        name[0] = "dev0"
        dev_class_major = {"class1major", "class2major"}
        dev_class_major[0] = "class0major"
        dev_class_minor = {"class1minor", "class2minor"}
        dev_class_minor[0] = "class0minor"
        status = {"status1", "status2"}
        status[0] = "status0"
        key = {4, 5}
        key[0] = 3
    else
        num_of_devices = bt_if.get_device_list_cnt(1)
        for i = 0, num_of_devices-1 do
            no[i], name[i], dev_class_major_enum, dev_class_minor_enum, status_enum, key[i] = bt_if.get_device_record(1, i)
            status[i] = status_text(status_enum)
            dev_class_major[i] = deviceclass_text(dev_class_major_enum)
            dev_class_minor[i] = deviceclass_text(dev_class_minor_enum)
        end
    end
elseif page_title == "Add device" then    
    --Parse URL
    if cgilua.cgi["PairName"] ~= nil then
        -- ***** "Pair" was pressed:  
        pair_pressed = true
    end

    --Get Parms
    if pair_pressed then
        --print('lua: pair pressed, PairName: '..cgilua.cgi["PairName"])
        -- Get device record (0, devNo)  again + passkey with get_bt_device()
        --dev_no_for_pairing = cgilua.cgi["devNo"]
        --print('bluetooth_devices: lua: pair pressed, dev_no_for_pairing= '..dev_no_for_pairing) 
        
        name = ""
        dev_class_major = ""
        dev_class_minor = ""
        --Get parameters from URL:
        key_to_pair_exists = false
        if cgilua.cgi["KeyToPair"] ~= nil then
            key_to_pair = cgilua.cgi["KeyToPair"]
            --print('bluetooth_devices: key_to_pair: ' ..key_to_pair)
            key_to_pair_exists = true
        end  
        if cgilua.cgi["PairName"] ~= nil then
            name = cgilua.cgi["PairName"]
            --print('bluetooth_devices: name: ' ..name)
        end    
        if cgilua.cgi["DevClassMajor"] ~= nil then
            dev_class_major = cgilua.cgi["DevClassMajor"]
            --print('bluetooth_devices: dev_class_major: ' ..dev_class_major)
        end    
        if cgilua.cgi["DevClassMinor"] ~= nil then
            dev_class_minor = cgilua.cgi["DevClassMinor"]
            --print('bluetooth_devices: dev_class_minor: ' ..dev_class_minor)
        end    
        
        dummyName, pass_key, dummyVisibility = bt_if.get_bt_device()  -- Just need the pass key
    else
        -- Get parameters from URL
        if cgilua.cgi["KeyForUnpair"] ~= nil then   -- From "Paired Devices" page
            --print('lua: un pair pressed, KeyForUnpair: '..cgilua.cgi["KeyForUnpair"]) 
            if test == false then
                bt_if.send_access(tonumber(cgilua.cgi["KeyForUnpair"]), 0, "")  --Unpair
            end
        end
        if cgilua.cgi["search"] ~= nil then
            --print('bluetooth_devices: search pressed')
            if test == false then
                bt_if.send_inquiry()
            end
        end   

        if test then
            num_of_devices = 2 

            name = {"dev1AD", "dev2AD"}  
            name[0] = "dev0AD"
            dev_class_major = {"class1majorAD", "class2majorAD"} 
            dev_class_major[0] = "class0majorAD"
            dev_class_minor = {"class1minorAD", "class2minorAD"} 
            dev_class_minor[0] = "class0minorAD"
            status = {"status1AD", "status2AD"}
            status[0] = "status0AD"
            key = {1, 2} 
            key[0] = 0
        else
            -- Get parameters from C
            num_of_devices = bt_if.get_device_list_cnt(0)
            for i = 0, num_of_devices-1 do
                no[i], name[i], dev_class_major_enum, dev_class_minor_enum, status_enum, key[i] = bt_if.get_device_record(0, i)
                status[i] = status_text(status_enum)
                dev_class_major[i] = deviceclass_text(dev_class_major_enum)
                dev_class_minor[i] = deviceclass_text(dev_class_minor_enum)
            end
        end
    end
end


-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_bluetooth")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end


-- Generate the HTML
put(start_of_content)
--Print any error message
put('<p id="errortext">' .. error_msg .. '</p>')

if pair_pressed and key_to_pair_exists then --From Add Device page
    --print('bluetooth_devices: B key_to_pair: ' ..key_to_pair)

    put('<p id="bluetooth_pair_tab"><table border="'..border_on..'" cellpadding="4" width="80%">')
    put('<form method="post" action="index.lua?pageID=Paired devices&amp;langID=' .. lang .. '&amp;KeyFromPair=' .. key_to_pair .. '">')   
        
    put('<tr>')
        put('<th align="left" width="33%"><p>' ..current_dictionary("name").. '</p></th>') 
        put('<th align="center" width="33%"><p>' ..current_dictionary("class of device").. '</p></th>')
        put('<th align="center" width="33%"><p>' ..current_dictionary("passkey").. '</p></th>')
    put('</tr>')
    
        show_device_to_pair(name, dev_class_major, dev_class_minor, pass_key)
    
    put('<tr>')
    put('</tr>')
    put('<tr>')
    put('</tr>')
    put('<tr>')
    put('</tr>')
    put('<tr>')
    put('</tr>')

    put('<tr>')
      put('<td allign="center"><input ' .. disabled_string .. ' type="submit" name="accept" value="' .. current_dictionary("accept") .. '"> <input ' .. disabled_string .. ' type="reset" name="reset" value="' .. current_dictionary("cancel") .. '"></td> <td></td> <td></td></tr></form>')

    put('</table></p>')
else
    put('<p id="bluetooth_devices_tab"><table align=left border="'..border_on..'" cellpadding="4" width="80%">')
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">')

    put('<tr>')
        put('<th align="left"><p>' ..current_dictionary("name").. '</p></th>') 
        put('<th align="center"><p>' ..current_dictionary("class of device").. '</p></th>')
        put('<th align="center"><p>' ..current_dictionary("status").. '</p></th>')
        put('<th align="center"><p>' ..current_dictionary("Phone").. '</p></th>')
        put('<td align="center"></td>')
    put('</tr>')
    
    for i = 0, num_of_devices-1 do
        show_device(i, no[i], name[i], dev_class_major[i], dev_class_minor[i], status[i], key[i])
    end

    put('<tr>')
    put('</tr>')
    put('<tr>')
        if page_title == "Add device" then
            put('<td><p><input ' .. disabled_string .. ' type="submit" name="update" value="' .. current_dictionary("update") .. '">&nbsp;&nbsp;<input ' .. disabled_string .. ' type="submit" name="search" value="' .. current_dictionary("search") .. '"></p></td>')
        else
            put('<td><p><input ' .. disabled_string .. ' type="submit" name="update" value="' .. current_dictionary("update") .. '"></p></td>')
        end
        put('<td></td>')
        put('<td></td>')
        put('<td></td>')
    put('</tr>')
    
    put('</form>')
    put('</table>')
end

put(end_of_content)

