option_text = function (expr)
  if (expr) then
    return '  selected '
  else
    return ''
  end
end

currency_text = function (val)
  if (val == 0) then
    return 'EUR'
  elseif (val == 1) then
    return '$'
  elseif (val == 2) then
    -- in utf-8
    return '\194\163' 
  elseif (val == 3) then
    return 'JPY'
  else
    return ''
  end
end


number_or_blank = function(number)
    return string.format("%.2f", number) 
end

validate_input = function (val)
  if val == nil then
    return 0
  else
    return val
  end
end


error_msg = ""
debug_msg = ""

--print('lua, page_title:'..page_title)


currency_num, currency_str_dummy, charge_std_voice, charge_31_audio, charge_cs_unspecific, charge_std_data,
charge_stream_32, charge_stream_64, charge_stream_128, charge_ps_unspecific, charge_stream_256 = call_log_if.get_call_charges()

--print('lua, A currency_num:'..currency_num)
--print('lua, A currency_text(currency_num):'..currency_text(currency_num))


if cgilua.cgi["Currency_str"] ~= nil then
    currency_num =  tonumber(cgilua.cgi["Currency_str"])
end
if cgilua.cgi["StdVoice"] ~= nil then
    charge_std_voice =  validate_input(tonumber(cgilua.cgi["StdVoice"]))
end
if cgilua.cgi["3.1Audio"] ~= nil then
    charge_31_audio =  validate_input(tonumber(cgilua.cgi["3.1Audio"]))
end
if cgilua.cgi["StdData"] ~= nil then
    charge_std_data =  validate_input(tonumber(cgilua.cgi["StdData"]))
end
if cgilua.cgi["Stream32"] ~= nil then
    charge_stream_32 =  validate_input(tonumber(cgilua.cgi["Stream32"]))
end
if cgilua.cgi["Stream64"] ~= nil then
    charge_stream_64 =  validate_input(tonumber(cgilua.cgi["Stream64"]))
end
if cgilua.cgi["Stream128"] ~= nil then
    charge_stream_128 =  validate_input(tonumber(cgilua.cgi["Stream128"]))
end
if cgilua.cgi["Stream256"] ~= nil then
    charge_stream_256 =  validate_input(tonumber(cgilua.cgi["Stream256"]))
end

if cgilua.cgi["submit"] ~= nil then
    submit_pressed = true
else    
    submit_pressed = false
end    

if submit_pressed then
    call_log_if.set_call_charges(currency_num, currency_text(currency_num), charge_std_voice, charge_31_audio, charge_cs_unspecific, charge_std_data,
                            charge_stream_32, charge_stream_64, charge_stream_128, charge_ps_unspecific, charge_stream_256)
end


-- Generate the HTML
put(start_of_content)
--Print any error message
--put('<table align="center"><tr><td><p id="errortext">')
--put(error_msg .. '</p></td></tr></table>')
--put('<table align="center"><tr><td><p>')
--put(debug_msg .. '</p></td></tr></table>')

    put('<p id="call_charges_table"><table align="left" border="'..border_on..'" cellpadding="6" width="70%">')
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">')
    
    put('<tr><td align="left" width="80%" colspan="3">')
        put('<p>' .. current_dictionary("the billing details from").. '</p>')
    put('</td></tr>')

    put('<tr>')
        put('<td align="left"><p>' .. current_dictionary("currency") .. ':</p></td>')
        put('<td align="left"><p><select name="Currency_str">')
            for i = 0, 4 do put('<option value="' .. i ..'"' .. option_text(currency_num == i) .. '>' ..  currency_text(i) .. '</option>\n') end
        put('</select> ' ..current_dictionary("(for display purposes only)").. '</p></td>')
        put('<td></td>')
    put('</tr>')

    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("standard voice")..': '..currency_text(currency_num).. '</p></td>')
        put('<td align="left"><p><input type="text" name="StdVoice" maxlength="7" size="7" value="' ..number_or_blank(charge_std_voice)..'"> ' ..current_dictionary("per minute").. '</p></td>')
        put('<td></td>')
    put('</tr>')
    if CS_SUPPORT ~= "CS_STANDARD" then
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("3.1kHz audio").. ': ' ..currency_text(currency_num).. '</p></td>')
            put('<td align="left"><p><input type="text" name="3.1Audio" maxlength="7" size="7" value="' ..number_or_blank(charge_31_audio)..'"> ' ..current_dictionary("per minute").. '</p></td>')
            put('<td></td>')
        put('</tr>')
    end

    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("standard data").. ': ' ..currency_text(currency_num).. '</p></td>')
        put('<td align="left"><p><input type="text" name="StdData" maxlength="7" size="7" value="' ..number_or_blank(charge_std_data)..'"> ' ..current_dictionary("per MegaByte").. '</p></td>')
        put('<td></td>')
    put('</tr>')

    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("streaming").. ' 32: '..currency_text(currency_num)..'</p></td>')
        put('<td align="left"><p><input type="text" name="Stream32" maxlength="7" size="7" value="' ..number_or_blank(charge_stream_32)..'"> ' ..current_dictionary("per minute").. '</p></td>')
        put('<td></td>')
    put('</tr>')

    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("streaming").. ' 64: '..currency_text(currency_num)..'</p></td>')
        put('<td align="left"><p><input type="text" name="Stream64" maxlength="7" size="7" value="' ..number_or_blank(charge_stream_64)..'"> ' ..current_dictionary("per minute").. '</p></td>')
        put('<td></td>')
    put('</tr>')

    if streaming ~= "STREAMING_32_64" then  
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("streaming").. ' 128: '..currency_text(currency_num)..'</p></td>')
            put('<td align="left"><p><input type="text" name="Stream128" maxlength="7" size="7" value="' ..number_or_blank(charge_stream_128)..'"> ' ..current_dictionary("per minute").. '</p></td>')
            put('<td></td>')
        put('</tr>')
    end

    if streaming == "STREAMING_32_256" then
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("streaming").. ' 256: '..currency_text(currency_num)..'</p></td>')
            put('<td align="left"><p><input type="text" name="Stream256" maxlength="7" size="7" value="' ..number_or_blank(charge_stream_256)..'"> ' ..current_dictionary("per minute").. '</p></td>')
            put('<td></td>')
        put('</tr>')
    end


    put('<tr>')
    put('</tr>')
    put('<tr>')
    put('<td align="left"><input type="submit" name="submit" value="' .. current_dictionary("apply") .. '">&nbsp;&nbsp;<input type="reset" name="reset" value="' .. current_dictionary("cancel") .. '"></td></tr></form>')
    put('<tr>')
        put('<td align="left" colspan="3">')
            put('<p>' ..current_dictionary("Disclaimer: Please note that the estimates").. '</p>')
        put('</td>')
    put('</tr>')
    put('</table></p>')

put(end_of_content)

