js_timer_func = [[
<script type="text/javascript">
function local_timer_func()
{
    document.call_setting.submit();
}
function local_onload_func()
{
    timer=setTimeout('local_timer_func()',5000);
}
</script>
]]
js_timer_func2 = [[
<script type="text/javascript">
function local_onload_func()
{
}
</script>
]]

disabled_text = function (expr)
  if (expr) then
    return ' disabled '
  else
    return ''
  end
end

show_section = function (prefix, wait_enab)
    put('<input type="hidden" name="'..prefix..'_wait_enab_hidden" value="'..wait_enab..'">')
    
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_wait_enab" value="on" '..checked_text(wait_enab == 1)..'>&nbsp;' ..current_dictionary("call wait")..'</p></td>')
    put('</tr>')
end

handle_post_values = function(arg)
    if_class = 1
    if arg == "speech" then
        if_class = 1
    elseif arg == "audio" then
        if_class = 4
    elseif arg == "data" then
        if_class = 2
    end

    if cgilua.cgi[arg.."_wait_enab"] ~= nil then
        if cgilua.cgi[arg.."_wait_enab"] == "on" then
            vals[arg..'_wait_enab'] = 1
        else
            vals[arg..'_wait_enab'] = 0
        end        
    end

    if cgilua.cgi[arg..'_wait_enab_hidden'] ~= nil then
        if vals[arg..'_wait_enab'] ~= tonumber(cgilua.cgi[arg..'_wait_enab_hidden']) then
            ss_if.change_cw(if_class,vals[arg..'_wait_enab'])
        end
    end

end

init_with_hidden_values = function(arg)
    if cgilua.cgi[arg.."_wait_enab_hidden"] ~= nil then
        vals[arg..'_wait_enab'] = tonumber(cgilua.cgi[arg.."_wait_enab_hidden"])
    end
end

-- Setup initial values
vals = {}
vals["speech_wait_enab"] = 0
vals["audio_wait_enab"] = 0
vals["data_wait_enab"] = 0

if cgilua.cgi["cw_query"] ~= nil then
    ss_if.query_cw_status()
    
elseif cgilua.cgi["cw_apply"] ~= nil then
    -- Parse incomming parameters
    handle_post_values("speech")
    handle_post_values("audio")
    handle_post_values("data")
else
    init_with_hidden_values("speech")
    init_with_hidden_values("audio")
    init_with_hidden_values("data")
end    

if cgilua.cgi["cw_query"] ~= nil then 
    trace(0,1,"cw_query")
end
if cgilua.cgi["cw_apply"] ~= nil then 
    trace(0,1,"cw_apply")
end


wait = false
if ss_if.is_operation_in_progress() then
    error_msg = current_dictionary("operation in progress")
    wait = true
end

number_cw_records = 0
if wait == false then
    -- If hidden values exist (not first time we show the page), show warning if last operation might have failed.
    if cgilua.cgi["speech_wait_enab_hidden"] ~= nil then
        cw_res, number_cw_records = ss_if.get_last_cw_operation_result()
        if not cw_res then
            if cgilua.cgi["cwop"] == "query" then
                error_msg = current_dictionary("cw query failed")
            elseif cgilua.cgi["cwop"] == "set" then
                error_msg = current_dictionary("cw set failed") 
            end
        end
        if cw_res then
            trace(0,1, string.format("Call wait result ok"))
        else
            trace(0,1, string.format("Call wait result fail"))
        end

        -- get values from ss_if first time after query is done
        if cgilua.cgi["cwop"] == "query" then
            if number_cw_records ~= nil then
                trace(0,1, string.format("records %d",number_cw_records))
            else
                trace(0,1, string.format("records nil"))
            end
        
            if number_cw_records > 0 then
                for i=1,number_cw_records do
                    cw_class = ss_if.get_cw_entry(i-1)
                    trace(0, 1, string.format("idx %d call wait class %d",i,cw_class))

                    class_txt = nil
                    if cw_class == 1 then
                        class_txt = "speech"
                    elseif cw_class == 2 then
                        class_txt = "data"
                    elseif cw_class == 4 then
                        class_txt = "audio"
                    end

                    if class_txt ~= nil then
                        vals[class_txt.."_wait_enab"] = 1
                    else
                        trace(0,1,string.format("Invalid class in response"))
                    end
                end
            end
        end
    else
        if not msg_if.lua_is_ready_for_ss() then
            error_msg = current_dictionary("ss reg needed")
        end
    end
end

if cgilua.cgi["local_onload"] ~= nil then
    trace(0,1,"cf onload")
end

-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_supplementary")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end

put(start_of_content)

put('<p id="errortext">' .. error_msg .. '</p>')

if wait then
    put(js_timer_func)
elseif cgilua.cgi["local_onload"] ~= nil then
    put(js_timer_func2)
end

put('<p><table align="left" border="'..border_on..'" cellpadding="0">\n')
put('<form name="call_setting" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
--put('<tr><td colspan="4"><p id="errortext">'..error_msg..'</p></td></tr>')
put('<tr><td align="left"><p>'..current_dictionary("read values")..'&nbsp;&nbsp;<input ' .. disabled_string .. ' type="submit" name="cw_query" value="'..current_dictionary("read button")..'" '..disabled_text(wait)..'></p></td>')
put('<tr><td>&nbsp;</td></tr>')
if cgilua.cgi["cw_query"] ~= nil then
    put('<input type="hidden" name="cwop" value="query">')
elseif cgilua.cgi["cw_apply"] ~= nil then
    put('<input type="hidden" name="cwop" value="set">')
elseif wait and cgilua.cgi["cwop"] ~= nil then
    put('<input type="hidden" name="cwop" value="'..cgilua.cgi["cwop"]..'">')
end
if wait then
    put('<input ' .. disabled_string .. ' type="hidden" name="local_onload" value="">')
end

put('<tr>')
    put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("standard voice").. '</p></th>')
put('</tr>')

show_section("speech",vals["speech_wait_enab"])

put('<tr>')
    put('<th align="left"><p class="menutext">' ..current_dictionary("3.1kHz audio").. '</p></th>')
put('</tr>')

show_section("audio",vals["audio_wait_enab"])

put('<tr>')
    if hasISDN == TT_TRUE then
        put('<th align="left"><p class="menutext">' ..current_dictionary("data isdn").. '</p></th>')
    else
        put('<th align="left"><p class="menutext">' ..current_dictionary("data").. '</p></th>')
    end
put('</tr>')

show_section("data",vals["data_wait_enab"])

put('<tr>')
put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" value="'..current_dictionary("apply")..'" name="cw_apply" '..disabled_text(wait)..'>&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="reset" value="'..current_dictionary("cancel")..'" name="reset" '..disabled_text(wait)..'></p></td>')
put('</tr>')
put('<tr><td>&nbsp;</td></tr>')
put('<tr>')
    put('<td align="left" colspan="3">')
        put('<p>' ..current_dictionary("ss info").. '</p>')
    put('</td>')
put('</tr>')


put('</form>\n') 
put('</table></p>\n')
put(end_of_content)

