--Rules:
--Always have a level 1 page as first and last page (Home and Sitemap).
--Home is not always a normal level 1 page.
--Always set parent and menu_level so that the menu_level of the parent is one less.
--Always place a children page just after the parent.
--Pages is printed in order.

--Not shown on:
--Known arguments: '*', '-', E300, E500, E527, E700, USBDisabled, BluetoothDisabled, 
--                 ManualPointingTrue, ISDNDisabled, WLANDisabled, SIPDisabled,
--                 EthNetMgmtDisabled.
--'*' = all terminals + unknown types => page not shown at all.
--'-' = shown on all terminals
--Examples:
--Show on all terminals:
--not_shown_on = {"-"},
--Show on all terminals except E300:
--not_shown_on = {"E300"},
--Show on only E527 and E700:
--not_shown_on = {"E300","E500"},

entry{
    page_title = "Home",
    menu_level = 1,
    parent = "None",
    filename = "home",
    not_shown_on = {"-"},
    vsize = 1,
    status = "special"
}

entry{
    page_title = "Connect",
    menu_level = 1,
    parent = "None",
    filename = "network_connections",
    not_shown_on = {"EthNetMgmtDisabled"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Phone book",
    menu_level = 1,
    parent = "None",
    filename = "phonebook",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"

}

entry{
    page_title = "Mobile numbers",
    menu_level = 2,
    parent = "Phone book",
    filename = "mobile_numbers",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"

}

entry{
    page_title = "Messages",
    menu_level = 1,
    parent = "None",
    filename = "sms",
    not_shown_on = {"-"},
    vsize = 2,
    status = "normal"

}

entry{
    page_title = "Inbox",
    menu_level = 2,
    parent = "Messages",
    filename = "sms",
    not_shown_on = {"-"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Write message",
    menu_level = 2,
    parent = "Messages",
    filename = "sms",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Outbox",
    menu_level = 2,
    parent = "Messages",
    filename = "sms",
    not_shown_on = {"-"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Sent",
    menu_level = 2,
    parent = "Messages",
    filename = "sms",
    not_shown_on = {"-"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Message settings",
    menu_level = 2,
    parent = "Messages",
    filename = "msg_settings",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Calls",
    menu_level = 1,
    parent = "None",
    filename = "calls",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Outgoing calls",
    menu_level = 2,
    parent = "Calls",
    filename = "calls_show",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Received calls",
    menu_level = 2,
    parent = "Calls",
    filename = "calls_show",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Missed calls",
    menu_level = 2,
    parent = "Calls",
    filename = "calls_show",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Standard data sessions",
    menu_level = 2,
    parent = "Calls",
    filename = "calls_show",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Streaming data sessions",
    menu_level = 2,
    parent = "Calls",
    filename = "calls_show",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Settings",
    menu_level = 1,
    parent = "None",
    filename = "settings",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "USB",
    menu_level = 2,
    parent = "Settings",
    filename = "interfaces",
    not_shown_on = {"USBDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "LAN",
    menu_level = 2,
    parent = "Settings",
    filename = "interfaces",
    not_shown_on = {"-"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Port forwarding",
    menu_level = 3,
    parent = "LAN",
    filename = "portforwarding",
    not_shown_on = {"E300"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Network devices",
    menu_level = 3,
    parent = "LAN",
    filename = "network_devices",
    not_shown_on = {"EthNetMgmtDisabled"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Network classification",
    menu_level = 3,
    parent = "LAN",
    filename = "network_classification",
    not_shown_on = {"EthNetMgmtDisabled"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Network user groups",
    menu_level = 3,
    parent = "LAN",
    filename = "network_user_groups",
    not_shown_on = {"EthNetMgmtDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "PPPoE",
    menu_level = 3,
    parent = "LAN",
    filename = "pppoe",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "WLAN",
    menu_level = 2,
    parent = "Settings",
    filename = "wlan",
    not_shown_on = {"WLANDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Bluetooth",
    menu_level = 2,
    parent = "Settings",
    filename = "bluetooth",
    not_shown_on = {"BluetoothDisabled"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Paired devices",
    menu_level = 3,
    parent = "Bluetooth",
    filename = "bluetooth_devices",
    not_shown_on = {"BluetoothDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Add device",
    menu_level = 3,
    parent = "Bluetooth",
    filename = "bluetooth_devices",
    not_shown_on = {"BluetoothDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Phone/Fax",
    menu_level = 2,
    parent = "Settings",
    filename = "phonefax",
    not_shown_on = {"E300"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Phone",
    menu_level = 2,
    parent = "Settings",
    filename = "phonefax",
    not_shown_on = {"E500","E527","E700","EBDU","E723","E727","SBDU","S250","S500","SBL"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "ISDN",
    menu_level = 2,
    parent = "Settings",
    filename = "isdn",
    not_shown_on = {"ISDNDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Common",
    menu_level = 2,
    parent = "Settings",
    filename = "interfaces",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Call forward",
    menu_level = 3,
    parent = "Common",
    filename = "call_forward",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Call barring",
    menu_level = 3,
    parent = "Common",
    filename = "call_barring",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Call waiting",
    menu_level = 3,
    parent = "Common",
    filename = "call_waiting",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Line identification",
    menu_level = 3,
    parent = "Common",
    filename = "call_line_id",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Closed user group",
    menu_level = 3,
    parent = "Common",
    filename = "cug",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "IP Handsets",
    menu_level = 2,
    parent = "Settings",
    filename = "voip",
    not_shown_on = {"SIPDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Call Settings",
    menu_level = 3,
    parent = "IP Handsets",
    filename = "voip",
    not_shown_on = {"SIPDisabled"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Discrete IO",
    menu_level = 2,
    parent = "Settings",
    filename = "discreteio",
    not_shown_on = {"E300","E700","E527","E500"},
    vsize = 1,
    status = "normal"
}

--entry{
--    page_title = "RF Settings",
--    menu_level = 2,
--    parent = "Settings",
--    filename = "rfsettings",
--    not_shown_on = {"E300","E500","E700","E527","EBDU","E723","E727","SBDU","S250","S500"},
--    vsize = 1,
--    status = "normal"
--}

entry{
    page_title = "External Systems",
    menu_level = 2,
    parent = "Settings",
    filename = "extsystems",
    not_shown_on = {"E300","E500","E700","E527","EBDU","E723","E727","SBDU","S250","S500"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "FLEX",
    menu_level = 2,
    parent = "Settings",
    filename = "flex",
    not_shown_on = {"E300","E500","E700","E527","EBDU","E723","E727","SBDU","S250","S500"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Advanced",
    menu_level = 2,
    parent = "Settings",
    filename = "advanced",
    not_shown_on = {"E300","E700","E527","EBDU","E723","E727","SBDU","S250","S500","SBL"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Upload",
    menu_level = 2,
    parent = "Settings",
    filename = "upload",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}


entry{
    page_title = "Alarm list",
    menu_level = 2,
    parent = "Settings",
    filename = "alarmlist",
    not_shown_on = {"EBDU","E723","E727","SBDU","S250","S500","SBL"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Satellite selection",
    menu_level = 2,
    parent = "Settings",
    filename = "sat_select",
    not_shown_on = {"ManualPointingTrue", "SBL"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Language",
    menu_level = 2,
    parent = "Settings",
    filename = "language",
    not_shown_on = {"SBL"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Administration",
    menu_level = 1,
    parent = "None",
    filename = "administration",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin_special"
}

entry{
    page_title = "Call charges",
    menu_level = 2,
    parent = "Administration",
    filename = "call_charges",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin"
}

entry{
    page_title = "Log handling",
    menu_level = 2,
    parent = "Administration",
    filename = "log_handling",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin"
}


entry{
    page_title = "Profiles",
    menu_level = 2,
    parent = "Administration",
    filename = "profiles",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin"
}

entry{
    page_title = "Traffic flow filters", 
    menu_level = 2,
    parent = "Administration",
    filename = "traffic_flow_filters",
    not_shown_on = {"-"},
    vsize = 2,
    status = "admin"
}

entry{
    page_title = "Upload nosim",
    menu_level = 2,
    parent = "Administration",
    filename = "upload",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin_special_only"
}

entry{
    page_title = "SIM PIN",
    menu_level = 2,
    parent = "Administration",
    filename = "sim_pin",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin"
}

entry{
    page_title = "SIM Lock",
    menu_level = 2,
    parent = "Administration",
    filename = "sim_lock",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin_special"
}

entry{
    page_title = "User Permissions",
    menu_level = 2,
    parent = "Administration",
    filename = "user_permissions",
    not_shown_on = {"-"},
    vsize = 1,
    status = "admin"
}

entry{
    page_title = "Helpdesk",
    menu_level = 1,
    parent = "none",
    filename = "helpdesk",
    not_shown_on = {"-"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Event list",
    menu_level = 2,
    parent = "Helpdesk",
    filename = "eventlist",
    not_shown_on = {"E300","E500","E527","E700"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Event log",
    menu_level = 2,
    parent = "Helpdesk",
    filename = "eventlist",
    not_shown_on = {"E300","E500","E527","E700"},
    vsize = 2,
    status = "normal"
}

entry{
    page_title = "Self Test",
    menu_level = 2,
    parent = "Helpdesk",
    filename = "past",
    not_shown_on = {"E300","E500", "E700","E527"},
    vsize = 1,
    status = "normal"
}

entry{
    page_title = "Sitemap",
    menu_level = 1,
    parent = "None",
    filename = "sitemap",
    not_shown_on = {"-"},
    vsize = 2,
    status = "normal"
}

entry{ 
    page_title = "Maintenance", 
    menu_level = 1, 
    parent = "None", 
    filename = "mt_status", 
    not_shown_on = {"*"}, 
    vsize = 2, 
    status = "special" 
} 
   

