function pin_name(pin)
    if pin == 0 then
        return "TP14"
    elseif pin == 1 then
        return "TP13"
    elseif pin == 2 then
        return "TP27"
    elseif pin == 3 then
        return "TP28"
    elseif pin == 4 then
        return "TP29";
    elseif pin == 5 then
        return "BP1"
    elseif pin == 6 then
        return "BP2"
    else 
        return "BP4"
    end
end

function fnc_name(fnc)
    if fnc == 1 then
        return current_dictionary("call")
    elseif fnc == 2 then
        return current_dictionary("sbu fail")
    elseif fnc == 3 then
        return current_dictionary("service avail")
    elseif fnc == 4 then
        return current_dictionary("sms")
    elseif fnc == 6 then
        return current_dictionary("lamps inhibit")
    else
        return current_dictionary("not used")
    end
end

function direction_name(fnc)
    if fnc == 6 or fnc == 7 then
        return current_dictionary("input")
    else
        return current_dictionary("output")
    end
end

function show_entry(id, fnc_id, enab, pol)
    put('<tr>')
    put('<td><p align="center">'..pin_name(id)..'</p></td>')
    put('<td><p align="left">' .. direction_name(fnc_id) .. '</p></td>')
    put('<td><p align="left">&nbsp;&nbsp;' .. fnc_name(fnc_id) .. '</p></td>')
    put('<td align="center"><p><input ' .. disabled_string .. ' type="checkbox" name="enabled_'..id..'"')
        put(checked_text(enab == TT_TRUE) ..' value="ON"></p></td>')
    put('<td><p>&nbsp;&nbsp;')
        put('<input ' .. disabled_string .. ' type="radio" name="pol_'..id..'" value="high"')
        put(checked_text(pol==1)..'>' .. current_dictionary('aero active high'))
        put(' <input ' .. disabled_string .. ' type="radio" name="pol_'..id..'" value="low"')
        put(checked_text(pol==0) ..'>' .. current_dictionary('aero active low') .. '</p></td>')
    put('</tr>\n')
end

--parse input
if cgilua.cgi["submit"] ~= nil then

    enabled_set = {}
    for i = 0,7 do
        enabled_set[i] = TT_FALSE
    end
    --enabled_set[0]
    if (cgilua.cgi['enabled_1'] == 'ON') then
	    enabled_set[1] = TT_TRUE
    end
    if (cgilua.cgi['enabled_2'] == 'ON') then
    	enabled_set[2] = TT_TRUE
    end
    if (cgilua.cgi['enabled_3'] == 'ON') then
	    enabled_set[3] = TT_TRUE
    end
    if (cgilua.cgi['enabled_4'] == 'ON') then
	    enabled_set[4] = TT_TRUE
    end
    if (cgilua.cgi['enabled_5'] == 'ON') then
	    enabled_set[5] = TT_TRUE
    end
    --enabled_set[6]
    --enabled_set[7]

    polarity_set = {}
    for i = 0,7 do
        polarity_set[i] = 0
    end
    
    --polarity_set[0]
    if (cgilua.cgi['pol_1'] == 'high') then
	    polarity_set[1] = 1
    end
    if (cgilua.cgi['pol_2'] == 'high') then
	    polarity_set[2] = 1
    end
    if (cgilua.cgi['pol_3'] == 'high') then
	    polarity_set[3] = 1
    end
    if (cgilua.cgi['pol_4'] == 'high') then
	    polarity_set[4] = 1
    end
    if (cgilua.cgi['pol_5'] == 'high') then
	    polarity_set[5] = 1
    end
    --polarity_set[6]
    --polarity_set[7]
    
    ringerCallType_set = {}
    for i=0,3 do
    	ringerCallType_set[i] = TT_FALSE
    end

    if (cgilua.cgi['std_ringer'] == 'ON') then
    	ringerCallType_set[0] = TT_TRUE
    end
    if (cgilua.cgi['prem_ringer'] == 'ON') then
	    ringerCallType_set[1] = TT_TRUE
    end
    if (cgilua.cgi['udi_ringer'] == 'ON') then
	    ringerCallType_set[2] = TT_TRUE
    end
    if (cgilua.cgi['rdi_ringer'] == 'ON') then
	    ringerCallType_set[3] = TT_TRUE
    end

    result = msg_if.lua_aero_set_discreteio_status(ringerCallType_set,
				                                     polarity_set,
                				                     enabled_set);

    if result == 2 then
        error_msg = current_dictionary("failed write protection")
    end

end

-- check write protection and access permission
disabled_string = ''
allowed = true
if msg_if.lua_is_aero_cm_write_protected() then
    allowed = false
    if error_msg == "" then
        -- don't overwrite message from submit
        error_msg = current_dictionary("write protected page")
    end
elseif admin_status < 0 then
    allowed = msg_if.lua_get_user_permissions("change_discrete_io")
    if not allowed then
        error_msg = current_dictionary("admin_locked")
    end
end
if not allowed then 
    disabled_string = ' disabled '
end

enabled, fnc, polarity, ringerCallType = msg_if.lua_aero_read_discreteio_status()

put(start_of_content)

put('<p id="errortext">' .. error_msg .. '</p>\n')
put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '">\n')


put('<table align="left" border="' .. border_on ..'" cellpadding="0">\n')
put('<tr>')
put('<td colspan="5" align="left"><p class="menutext">' .. current_dictionary('discrete io') .. '</p></td>')
put('</tr>\n')
put('<tr>')
put('<th align="center"><p>' .. current_dictionary('discreteiopin') .. '</p></th>')
put('<th align="left"><p>' .. current_dictionary('io') .. '</p></th>')
put('<th align="left"><p>&nbsp;&nbsp;' .. current_dictionary('function') .. '</p></th>')
put('<th align="left"><p>' .. current_dictionary('enabled') .. '</p></th>')
put('<th align="left"><p>&nbsp;&nbsp;' .. current_dictionary('polarity') .. '</p></th>')
put('</tr>\n')

-- skip tp14
show_entry(1, fnc[1], enabled[1], polarity[1])
show_entry(2, fnc[2], enabled[2], polarity[2])
show_entry(3, fnc[3], enabled[3], polarity[3])
show_entry(4, fnc[4], enabled[4], polarity[4])
show_entry(5, fnc[5], enabled[5], polarity[5])
--skip BP2
--skip BP3

-- Ringer Output
put('<tr><th align="left" colspan="5"><p class="menutext">' .. current_dictionary('ringer output') .. '</p></th></tr>')
put('<tr>')
put('<td align="left" ><p>' ..current_dictionary("incoming calls").. '&nbsp;&nbsp;</p></td>\n')
put('<td align="left" colspan="4"><p>')
put('<input ' .. disabled_string .. ' type="checkbox" name="std_ringer"'..checked_text(ringerCallType[0]==TT_TRUE)..' value="ON">')
put(current_dictionary("standard")..'&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="prem_ringer"'..checked_text(ringerCallType[1]==TT_TRUE)..' value="ON">')
put(current_dictionary("3.1kHz audio").. '&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="udi_ringer"'..checked_text(ringerCallType[2]==TT_TRUE)..' value="ON">')
put('UDI &nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="rdi_ringer"'..checked_text(ringerCallType[3]==TT_TRUE)..' value="ON">RDI</p>')
put('</td></tr>\n')
put('<tr><td>&nbsp</td></tr>')

--Submit/Cancel buttons

put('<tr>')
put('<td align="left" colspan="4"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>')
put('</tr>\n')
put('</table>\n\n')

put('</form>\n')

put(end_of_content)
 