time_format = function(duration)
    -- duration in seconds
    h = 0
    m = 0
    s = 0
    d = 0
    s  = math.mod(duration, 60)
    m  = (math.mod(duration, 3600) - s)/60
    h = math.mod((duration - m*60 - s)/3600,24)
    d = (duration - h*3600 - m*60 - s)/(3600*24)
    d_str = current_dictionary("short_days")
    h_str = current_dictionary("short_hours")
    m_str = current_dictionary("short_minutes")
    s_str = current_dictionary("short_seconds")
    if d > 0 then
        timestr = string.format("%d"..d_str.." %d"..h_str.." %d"..m_str.." %d"..s_str, d, h, m, s)
    elseif h>0 then
        timestr = string.format("%d"..h_str.." %d"..m_str.." %d"..s_str, h, m, s)
    elseif m>0 then
        timestr = string.format("%d"..m_str.." %d"..s_str, m, s)
    else
        timestr = string.format("%d"..s_str, s)
    end
    return timestr  
end


penalty_time = msg_if.lua_get_flex_penalty_time()

-- Parse incoming parameters
if penalty_time > 0 then
    error_msg = current_dictionary("time remaining flex") .. time_format(penalty_time);
elseif cgilua.cgi["key1"] ~= nil or cgilua.cgi["key2"] ~= nil or cgilua.cgi["key3"] ~= nil or
    cgilua.cgi["key4"] ~= nil or cgilua.cgi["key5"] ~= nil then

    if string.len(cgilua.cgi["key1"]) ~= 5 or string.len(cgilua.cgi["key2"]) ~= 5 or 
    string.len(cgilua.cgi["key3"]) ~= 5 or string.len(cgilua.cgi["key4"]) ~= 5 or 
    string.len(cgilua.cgi["key5"]) ~= 5 then
        error_msg = current_dictionary("invalid flex key format")    
    else
        result, penalty_time = msg_if.lua_flex_apply_key(cgilua.cgi["key1"],cgilua.cgi["key2"],cgilua.cgi["key3"],cgilua.cgi["key4"],cgilua.cgi["key5"])
        if result == 0 then
        -- ok
        elseif result == 2 then
            error_msg = current_dictionary("failed write protection")
        else
            error_msg = current_dictionary("invalid flex key.") .. current_dictionary("time remaining flex") .. time_format(penalty_time);
        end
    end
end

-- check write protection 
disabled_string = ''
allowed = true
if msg_if.lua_is_aero_cm_write_protected() then
    allowed = false
    disabled_string = ' disabled '
    if error_msg == "" then
        -- don't overwrite message from submit
        error_msg = current_dictionary("write protected page")
    end
end

put('\n')
put(start_of_content)
put('<p><table align="left" border="'..border_on..'" cellpadding="0">\n')
put('<form name="flex" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
put('<tr><td colspan="2"><p id="errortext">'..error_msg..'</p></td></tr>')

if penalty_time > 0 then
    -- in penalty time, only show refresh
    put('<tr></tr>')
    put('<tr>')
       put('<td align="left"><p><input type="submit" value="' .. current_dictionary("refresh") .. '"></td>\n')
    put('</tr>')
else
    feat1_ok, feat2_ok = msg_if.lua_get_flex_features()
    if feat1_ok then
        feat1_text = current_dictionary("enabled")
    else
        feat1_text = current_dictionary("disabled")
    end
    if feat2_ok then
        feat2_text = current_dictionary("enabled")
    else
        feat2_text = current_dictionary("disabled")
    end
    put('<tr>')
        put('<td align="left" colspan="2"><p class="menutext">' ..current_dictionary("flex") ..'</p></td>')
    put('</tr>\n')
    put('<tr>')
    put('<td align="left"><p>'..current_dictionary("flex key")..'</p></td>')
    put('<td align="left"><p><input ' .. disabled_string .. ' type="text" maxlength="5" size="10" name="key1">')
    put('&nbsp;&nbsp;')
    put('<input' .. disabled_string .. ' type="text" maxlength="5" size="10" name="key2">')
    put('&nbsp;&nbsp;')
    put('<input ' .. disabled_string .. ' type="text" maxlength="5" size="10" name="key3">')
    put('&nbsp;&nbsp;')
    put('<input ' .. disabled_string .. ' type="text" maxlength="5" size="10" name="key4">')
    put('&nbsp;&nbsp;')
    put('<input ' .. disabled_string .. ' type="text" maxlength="5" size="10" name="key5">')
    put('</p></td>')
    put('</tr>')

    put('<tr>')
        put('<td align="left"colspan="2"><p><input ' .. disabled_string .. ' type="submit" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>')

    put('<tr></tr><tr></tr>')
    put('<tr>')
    put('<td align="left" colspan="1"><p class="menutext">' ..current_dictionary("flex features") ..'</p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>'..current_dictionary("multiuser flex feature")..'&nbsp;</p></td>')
        put('<td align="left"><p>'..feat1_text..'</p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>'..current_dictionary("wifi flex feature")..'&nbsp;</p></td>')
        put('<td align="left"><p>'..feat2_text..'</p></td>')
    put('</tr>')
end

put('</form>\n') 
put('</table></p>\n')
put(end_of_content)

