traffic_type_text = function (val)
-- interactive reported as standard and conversational as streaming
  if (val == 2) or (val == 1) then
    return 'streaming'
  elseif (val == 4) or (val == 3) then
    return 'standard data'
  elseif (val == 5) then
    return 'streaming 32 kbps'
  elseif (val == 6) then
    return 'streaming 64 kbps'
  elseif (val == 7) then
    return 'streaming 128 kbps'
  elseif (val == 8) then
    return 'streaming 256 kbps'
  else  
    return 'unknown'
  end
end


time_format = function(duration)
    h = 0
    m = 0
    s = 0
    d = 0
    s  = math.mod(duration, 60)
    m  = (math.mod(duration, 3600) - s)/60
    h = math.mod((duration - m*60 - s)/3600,24)
    d = (duration - h*3600 - m*60 - s)/(3600*24)
    if d > 0 then
        timestr = string.format("%dd %02d:%02d:%02d", d, h, m, s)
    else
        timestr = string.format("%02d:%02d:%02d", h, m, s)
    end
    return timestr  
end

byte_format = function(bytes)
    bytestr = string.format("%.2f", bytes/1024/1024 )
    return bytestr  
end

if hasEthNetMgmt == TT_TRUE then
    nug = msg_if.lua_get_current_nug(cgilua.servervariable("REMOTE_ADDR"))
else
    nug = -1
end

if cgilua.cgi["pdpOP"] ~= nil and cgilua.cgi["cid"] ~= nil then
    if cgilua.cgi["pdpOP"] == "1" then
        msg_if.lua_start_pdp(cgilua.cgi["cid"],nug);
    else
        msg_if.lua_stop_pdp(cgilua.cgi["cid"],nug);
    end
end

error_msg = ""
debug_msg = ""

if (usim_string == "USIM_STATUS_PIN1_NEEDED") then
    error_msg = current_dictionary("please enter pin") 
elseif (usim_string == "USIM_STATUS_FAIL") then
    error_msg = current_dictionary("pin not correct - please enter pin")
elseif (usim_string == "USIM_STATUS_PIN1_BLOCKED") then
    error_msg = current_dictionary("the usim card has been blocked - please enter puk code")
elseif (usim_string == "USIM_STATUS_BLOCKED_PERSONALISATION") then
    error_msg = current_dictionary("illegal sim")
elseif (usim_string == "USIM_STATUS_INVALID") then
    error_msg = current_dictionary("invalid sim")
elseif usim_string ~= "USIM_STATUS_OK" then
    error_msg = current_dictionary("please insert a usim card")
end

--(usim_string == "USIM_STATUS_INVALID" or usim_string == "USIM_STATUS_ABSENT")

std_mo, std_mt, prem_mo, prem_mt, udi_mo, udi_mt, rdi_mo, rdi_mt, type, duration = msg_if.lua_get_cs_status()
prem_mo = prem_mo + udi_mo + rdi_mo
prem_mt = prem_mt + udi_mt + rdi_mt

dp_name = msg_if.lua_get_dp_name()
if dp_name == "" then 
    dp_name = "Unknown"
end

state = msg_if.lua_get_terminal_status()
if state == 3 and duration > 0 then
    -- only override with data active umts-reg thinks we are ready.
    state = 5
end

ip_addr = msg_if.read_config_db_ip_addr(t)
mac, serial, pcb, imei, mac_wlan = msg_if.lua_read_config_db_sysconf_info()
ver = msg_if.print_version_info()

pdp_lan = {}

if hasEthNetMgmt == TT_TRUE then
    autoactivate_mode = nm_if.lua_get_nug_config(nug)
else
    autoactivate_mode = msg_if.lua_get_pdp_autoactivate()
end

if autoactivate_mode == 1 then
    pdp_lan_no = msg_if.lua_get_number_pdp_lan(1,nug)
else
    pdp_lan_no = msg_if.lua_get_number_pdp_lan(0,nug)
end
for i=0,(pdp_lan_no-1) do
    cid, prof, active, name = msg_if.lua_get_pdp_lan(i)
    table.insert(pdp_lan,{cid = cid, profile = prof, active = active, name = name})
end
prim_act_cid, prim_act_profile, prim_act_profile_name = msg_if.lua_get_pdp_lan_primary()

data_sessions = {}
data_no = msg_if.lua_get_number_ps_sessions()
for i=0,(data_no-1) do
    ip1,ip2,ip3,ip4,traftype,x,y = msg_if.lua_get_ps_session(i)
    table.insert(data_sessions,{ip = ip1..'.'..ip2..'.'..ip3..'.'..ip4, traftype = traftype})
end


if state == 3 and data_no > 0 then
    -- only override with data active if umts-reg thinks we are ready.
    state = 5
end

ps_bytes_std, ps_time_32, ps_time_64, ps_time_128, ps_time_256 = msg_if.lua_get_ps_statistics()

sat_select = msg_if.lua_get_sat_selection()
gps_fix, gps_allowed, longitude_deg, longtitude_min, east, latitude_deg, latitude_min, north = msg_if.lua_get_gps_position()


east_string = ''
north_string = ''

if ( east ) then
    east_string =  current_dictionary("short_east")
else
    east_string =  current_dictionary("short_west")
end

if ( north ) then
    north_string =  current_dictionary("short_north")
else
    north_string =  current_dictionary("short_south")
end

if (gps_fix == true) then 
    if (gps_allowed == true) then
        gps_pos_string = north_string .. string.format(" %2d&deg;%02d\'", latitude_deg, latitude_min) .. ', ' .. east_string .. string.format(" %2d&deg;%02d\'", longitude_deg, longtitude_min)
    else 
         gps_pos_string = current_dictionary("acquired") 
    end
else 
    gps_pos_string = current_dictionary("acquiring") 
end

antenna_connected = TT_TRUE
antenna_type=msg_if.lua_get_antenna_type()
if antenna_type == "detect" then
    antenna_type = current_dictionary("detecting antenna")
    antenna_connected = TT_FALSE
elseif antenna_type == "no" then
    antenna_type = current_dictionary("no antenna")
    antenna_connected = TT_FALSE
end 

if isProductBDU == TT_TRUE or product == "SBL" then
    curr_satellite, elevation = msg_if.lua_get_current_satellite()
end

put(start_of_content)
--Print any error message
put('<table align=center><tr><td><p id="errortext">')
put(error_msg .. '</p></td></tr></table>')

if (usim_string == "USIM_STATUS_OK") then
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">')
    put('<table border = "'..border_on..'">')
        put('<tr>')
            put('<td align="left"><p class="menutext">'.. current_dictionary("properties") ..'</p></td>')
            put('<td align="left" width="10"></td><td></td>')
            put('<td align="left" width="20"></td>')
            put('<td align="left"><p class="menutext">'.. current_dictionary("sessions total") ..'</p></td>')
        put('</tr>')
        put('<tr>')
            if dp_name == "Unknown" then
                put('<td align="left"><p>'.. current_dictionary("airtime provider") ..'</p></td><td></td><td><p>('.. current_dictionary("unknown") ..')</p></td>')
            else
                put('<td align="left"><p>'.. current_dictionary("airtime provider") ..'</p></td><td></td><td><p>'.. dp_name ..'</p></td>')
            end
            put('<td align="left" width="20"></td>')
            put('<td align="left"><p>'.. current_dictionary("standard voice inbound") ..'</p></td><td><p>' .. time_format(std_mt) .. '</p></td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("GPS position")..'</p></td><td></td><td><p>' ..gps_pos_string ..  '</p></td>')
            put('<td align="left" width="20"></td>')
            put('<td align="left"><p>'.. current_dictionary("standard voice outbound") ..'</p></td><td><p>' .. time_format(std_mo) .. '</p></td>')


        put('</tr>')
        put('<tr>')
            if state == 0 then
                if hasManualPointing == TT_TRUE then
                    put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("point now") ..'</p></td>')
                else
                    put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("scanning") ..'</p></td>')
                end 
            elseif state == 1 then
                put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("searching") ..'</p></td>')
            elseif state == 2 then
                put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("registering") ..'</p></td>')
            elseif state == 3 then
                put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("ready") ..'</p></td>')
            elseif state == 4 then
                put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("no gps") ..'</p></td>')
            elseif state == 5 then
                put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("data active") ..'</p></td>')
            elseif state == 6 then
                put('<td align="left"><p>'.. current_dictionary("status") ..'</p></td><td></td><td><p>'.. current_dictionary("not registered") ..'</p></td>')
            end
            put('<td align="left" width="20"></td>')
            if CS_SUPPORT ~= "CS_STANDARD" then
                put('<td align="left"><p>'.. current_dictionary("3.1 kHz audio inbound") ..'</p></td><td><p>' .. time_format(prem_mt) .. '</p></td>')
            else
                put('<td align="left"><p></p></td><td><p></p></td>')
            end
        put('</tr>')
        put('<tr>')
            if hasManualPointing == TT_TRUE then
                put('<td align="left"><p>'.. current_dictionary("pointing") ..'</p></td><td></td><td><p><a href="pointing_mode.lp?langID=' ..lang.. '">' .. current_dictionary("go to pointing mode") ..'</a></p></td>')
            elseif sat_select == 1 then
                put('<td align="left"><p>'.. current_dictionary("satellite selection") ..'</p></td><td></td><td><p>Asia-Pacific</p></td>')            
            elseif sat_select == 2 then
                put('<td align="left"><p>'.. current_dictionary("satellite selection") ..'</p></td><td></td><td><p>EMEA</p></td>')
            elseif sat_select == 3 then
                put('<td align="left"><p>'.. current_dictionary("satellite selection") ..'</p></td><td></td><td><p>Americas</p></td>')
            elseif sat_select == 4 then
                put('<td align="left"><p>'.. current_dictionary("satellite selection") ..'</p></td><td></td><td><p>Auto</p></td>')
            else 
                put('<td align="left"><p>'.. current_dictionary("satellite selection") ..'</p></td><td></td><td><p>N/A</p></td>')
            end
            put('<td align="left" width="20"></td>')
            if CS_SUPPORT ~= "CS_STANDARD" then
                put('<td align="left"><p>'.. current_dictionary("3.1 kHz audio outbound") ..'</p></td><td><p>' .. time_format(prem_mo) .. '</p></td>')
            else
                put('<td align="left"><p></p></td><td><p></p></td>')
            end
        put('</tr>')
        put('<tr>')
            if isProductBDU ~= TT_TRUE and product ~= "SBL" then
                put('<td align="left"><p>' .. current_dictionary("unit serial number") .. '</p></td><td></td><td><p>'..serial..'</p></td>')
            else
                put('<td align="left"><p>' .. current_dictionary("current satellite") .. '</p></td><td></td><td><p>')
                if curr_satellite == 1 or curr_satellite == 2 or curr_satellite == 3 or
                   curr_satellite == 4 or curr_satellite == 5 then
                    if curr_satellite == 1 then
                        put('Asia-Pacific')
                    elseif curr_satellite == 2 then
                        put('EMEA')
                    elseif curr_satellite == 3 then
                        put('Americas')
                    elseif curr_satellite == 4 or curr_satellite == 5 then
                        put('--')
                    end
                    put(' ('..current_dictionary("elevation")..': ')
                    if elevation >= 0 then
                        put(elevation..'&deg;)')
                    else
                        put('--)')
                    end
                else 
                    put(current_dictionary("satellite none"))
                end
                put('</p></td>')
            end
            put('<td align="left" width="20"></td>')
            put('<td align="left"><p>'.. current_dictionary("standard data") ..'</p></td><td><p>'..byte_format(ps_bytes_std)..' MB</p></td>')
        put('</tr>')
        put('<tr>')
            if isProductBDU ~= TT_TRUE and product ~= "SBL" then
                put('<td align="left"><p>' .. current_dictionary("software version") .. '</p></td><td></td><td><p>'..ver..'</p></td>')   
            else
                put('<td align="left"><p>' .. current_dictionary("unit serial number") .. '</p></td><td></td><td><p>'..serial..'</p></td>')
            end
            put('<td align="left" width="20"></td>')
            put('<td align="left"><p>'.. current_dictionary("streaming 32 kbps") ..'</p></td><td><p>'..time_format(ps_time_32)..'</p></td>')
        put('</tr>')
        put('<tr>')
            if isProductBDU ~= TT_TRUE and product ~= "SBL" then
                put('<td align="left"><p>'.. current_dictionary("local ip address") ..'</p></td><td></td><td><p>' .. ip_addr.ip_addr3 .. '.' .. ip_addr.ip_addr2 ..'.'.. ip_addr.ip_addr1 ..'.'.. ip_addr.ip_addr0..'</p></td>')
            else
                put('<td align="left"><p>' .. current_dictionary("software version") .. '</p></td><td></td><td><p>'..ver..'</p></td>')   
            end
            put('<td align="left" width="20"></td>')
            put('<td align="left"><p>'.. current_dictionary("streaming 64 kbps") ..'</p></td><td><p>'..time_format(ps_time_64)..'</p></td>')
        put('</tr>')
        put('<tr>')                                                                                  
            if isProductBDU ~= TT_TRUE and product ~= "SBL" then
                put('<td align="left"><p>'.. current_dictionary("imei number") ..'</p></td><td></td><td><p>'..string.sub(imei,1,8)..'-'..string.sub(imei,9,14) ..'-'..string.sub(imei,15)..'</p></td>')
            elseif product == "SBL" then
                imsi = msg_if.lua_get_imsi()
                put('<td align="left"><p>'.. current_dictionary("imsi number") ..'</p></td><td></td><td><p>'..imsi..'</p></td>')
            else
                put('<td align="left"><p>'.. current_dictionary("local ip address") ..'</p></td><td></td><td><p>' .. ip_addr.ip_addr3 .. '.' .. ip_addr.ip_addr2 ..'.'.. ip_addr.ip_addr1 ..'.'.. ip_addr.ip_addr0..'</p></td>')
            end
            put('<td align="left" width="20"></td>')
            if streaming ~= "STREAMING_32_64" then
                put('<td align="left"><p>'.. current_dictionary("streaming 128 kbps") ..'</p></td><td><p>'..time_format(ps_time_128)..'</p></td>')
            end
        put('</tr>')
        put('<tr>')
            if isProductBDU ~= TT_TRUE and product ~= "SBL" then
                put('<td align="left"><p>' .. current_dictionary("mac address") .. '</p></td><td></td><td><p>'..mac..'</p></td>')
            else
                put('<td align="left"><p>'.. current_dictionary("imei number") ..'</p></td><td></td><td><p>'..string.sub(imei,1,8)..'-'..string.sub(imei,9,14) ..'-'..string.sub(imei,15)..'</p></td>')
            end
            put('<td align="left" width="20"></td>')
            if streaming == "STREAMING_32_256" then
                put('<td align="left"><p>'.. current_dictionary("streaming 256 kbps") ..'</p></td><td><p>'..time_format(ps_time_256)..'</p></td>')
            end
        put('</tr>')
        if hasWLAN == TT_TRUE and isProductBDU ~= TT_TRUE and product ~= "SBL" then
            put('<tr>')
                put('<td align="left"><p>' .. current_dictionary("mac wlan") .. '</p></td><td></td><td><p>'..mac_wlan..'</p></td>')
            put('</tr>')
        elseif isProductBDU == TT_TRUE then
            put('<tr>')
                if antenna_connected == TT_TRUE then
                    if state == 0 then
                        put('<td align="left"><p>' .. current_dictionary("antenna status") .. '</p></td><td></td><td><p>'.. current_dictionary("sky scan") .. '</p></td>')
                    else
                        put('<td align="left"><p>' .. current_dictionary("antenna status") .. '</p></td><td></td><td><p>'.. current_dictionary("tracking") .. '</p></td>')
                    end
                else
                    put('<td align="left"><p>' .. current_dictionary("antenna status") .. '</p></td><td></td><td><p>'..antenna_type..'</p></td>')                 
                end
            put('</tr>')
        end
        put('<tr>')
            put('<td align="left" colspan="3"><p class="menutext">'.. current_dictionary("ongoing data sessions") ..'</p></td>')
            put('<td align="left" width="20"></td>')
            put('<td align="left"><p class="menutext">'.. current_dictionary("ongoing calls") ..'</p></td>')
        put('</tr>')
        put('<tr>')
            if table.getn(data_sessions) == 0 then
                put('<td align="left" colspan="3"><p>('..current_dictionary('no active data sessions')..')</p></td>')
            else
                put('<td align="left" colspan="3"><p>'..current_dictionary(traffic_type_text(data_sessions[1].traftype)) .. '  ('..data_sessions[1].ip..')</p></td>')
            end
            put('<td align="left" width="20"></td>')
            if duration > 0 then
                if type == 0 then
                    put('<td align="left"><p>'.. current_dictionary("standard voice") ..'<p></td><td><p>' .. time_format(duration) .. '</p></td>')
                elseif type == 2 then
                    put('<td align="left"><p>'.. current_dictionary("3.1 kHz audio") ..' ' ..current_dictionary("(64 kbps UDI)") .. '</p></td><td><p>' .. time_format(duration) .. '</p></td>')
                elseif type == 3 then
                    put('<td align="left"><p>'.. current_dictionary("3.1 kHz audio") ..' ' ..current_dictionary("(56 kbps RDI)") .. '</p></td><td><p>' .. time_format(duration) .. '</p></td>')
                else
                    put('<td align="left"><p>'.. current_dictionary("3.1 kHz audio") ..'</p></td><td><p>' .. time_format(duration) .. '</p></td>')
                end
            else
                put('<td align="left"><p>('.. current_dictionary("no active calls") ..')</p></td><td><p></p></td>')
            end
        put('</tr>')
        for i=2,table.getn(data_sessions) do
            put('<tr>')
                put('<td align="left" colspan="3"><p>'..current_dictionary(traffic_type_text(data_sessions[i].traftype)) .. '  ('..data_sessions[i].ip..')</p></td>')
            put('</tr>')
        end

    put('</table>')

    put('<table align="left" border="'..border_on..'" cellpadding="0">')
    put('<tr>')
        -- If auto activate is enabled we only show streaming profiles
        nug_text = ''
        if hasEthNetMgmt == TT_TRUE then
            nug_text = ' ('..nm_if.lua_get_nug_name(nug)..')'
        end

        if autoactivate_mode == 1 then
            put('<th align="left" colspan="5"><p class="menutext" >' .. current_dictionary("streaming pdp lan").. nug_text..'</p></th>\n')
        else
            put('<th align="left" colspan="5"><p class="menutext" >' .. current_dictionary("pdp lan").. nug_text..'</p></th>\n')
        end
    put('</tr>')

    show_stop_old = false
    if prim_act_cid ~= 0 then
        show_stop_old = true
        in_list = false
        for i=1,table.getn(pdp_lan) do
            if pdp_lan[i].cid == prim_act_cid then
                if pdp_lan[i].profile == prim_act_profile then
                    show_stop_old = false
                end
                in_list = true
                break
            end
        end
        if not in_list and autoactivate_mode == 1 and prim_act_profile == 0 then
            show_stop_old = false
        end
    end

    if show_stop_old then
        put('<tr>')
        put('<td align="left"><p>')
        txt1 = current_dictionary('stop')
        txt2 = 0
        link_generate (page_title, "&amp;pdpOP="..txt2.."&amp;cid="..prim_act_cid, txt1..' '..prim_act_profile_name, "direct", current_dictionary("do you want to")..' '..txt1..' '..prim_act_profile_name..' ?')
        put('</p></td>')
        put('</tr>')
    end
     
    put('<tr>')
    if table.getn(pdp_lan) == 0 then
        if not show_stop_old then
            put('<td align="left"><p>('..current_dictionary('no profiles')..')</p></td>')
        end            
    else
        for i=1,math.min(table.getn(pdp_lan),3) do
            put('<td align="left" width="150"><p>')
            if pdp_lan[i].active == 1 then
                txt1 = current_dictionary('stop')
                txt2 = 0
            else
                txt1 = current_dictionary('start')
                txt2 = 1
            end
            if show_stop_old and pdp_lan[i].cid == prim_act_cid then
                put(current_dictionary('start')..' '..pdp_lan[i].name)
            else
                link_generate (page_title, "&amp;pdpOP="..txt2.."&amp;cid="..pdp_lan[i].cid, txt1..' '..pdp_lan[i].name, "direct", current_dictionary("do you want to")..' '..txt1..' '..pdp_lan[i].name..' ?')
            end    
            put('</p></td>\n')
        end
    end
    put('</tr>')
    if table.getn(pdp_lan) > 3 then
        put('<tr>')
        for i=4,table.getn(pdp_lan) do
            put('<td align="left" width="150"><p>')
            if pdp_lan[i].active == 1 then
                txt1 = current_dictionary('stop')
                txt2 = 0
            else
                txt1 = current_dictionary('start')
                txt2 = 1
            end
            link_generate (page_title, "&amp;pdpOP="..txt2.."&amp;cid="..pdp_lan[i].cid, txt1..' '..pdp_lan[i].name, "direct", current_dictionary("do you want to")..' '..txt1..' '..pdp_lan[i].name..' ?')
            put('</p></td>\n')
        end
        put('</tr>')
    end
    put('<tr>')
        put('<td align="left"><p><input type="submit" name="submit" value="' .. current_dictionary("refresh") .. '"></td>\n')
    put('</tr>')
    put('</table></form>')
elseif (usim_string == "USIM_STATUS_PIN1_BLOCKED" or cgilua.cgi["usimOP"] == "ValidatePUK") then
    put('<table align=center>')
    put('<tr>')
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;usimOP=ValidatePUK"><td><p>' ..current_dictionary("puk") .. ': <input type="password" maxlength="8" name="passwordPUK"></p></td><td><p>'.. current_dictionary("pin")..': <input type="password" maxlength="8" name="password"></p></td><td><p><input type="submit" value="'..current_dictionary("validate") ..'"></p></td></form>')
    put('</tr>')
    put('</table>')
elseif (usim_string == "USIM_STATUS_INVALID" or usim_string == "USIM_STATUS_ABSENT" or 
        usim_string == "USIM_STATUS_BLOCKED_PERSONALISATION") then
    put('<table align=center>')
    put('<tr>')
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;usimOP=Validate"><td><p>'..current_dictionary("pin")..': <input type="password" maxlength="8" name="password"></p></td><td><p><input type="submit" value="'..current_dictionary("validate")..'"></p></td></form>')
    put('</tr>')
    put('</table>')
else
    put('<table align=center>')
    put('<tr>')
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;usimOP=Validate"><td><p>'..current_dictionary("pin")..': <input type="password" maxlength="8" name="password"></p></td><td><p><input type="submit" value="'..current_dictionary("validate")..'"></p></td></form>')
    put('</tr>')
    put('</table>') 
end
put(end_of_content)


