debug = "no"
debug_cgilua = "no"
error_msg = ""
debug_msg = ""
TT_TRUE = 1
TT_FALSE = 0
border_on = 0

function page_generate (pageID) 
    require('sajax')    
    require('html')
    require('menu')
    require('string')
    require('menu')
    require('menupath')
    require('mt_status_sajax')

    cgilua.htmlheader()

    usim_string = ""

    local function usim_status()
        local myq=Queue.lookup("xavante")
        local q=Queue.lookup("USIM")
        local message_table=
        {
            ["head"] = {
                ["messageId"] = "USIM_MSG_STATUS",
                ["returnQueue"] = myq,
                ["returnMessageId"] = "USIM_MSG_STATUS"
            }
        }
        local message=msg_if.to_msg(message_table)
        q:put(message)
        return_message = myq:get(20000)
        if not return_message then
            return "Usim Status: Unknown"
        end
        return_message_table = msg_if.from_msg(return_message)
        return return_message_table.status
    end

    local function validate(password)
        local myq=Queue.lookup("xavante")
        local q=Queue.lookup("USIM")
        local message_table=
        {
            ["head"] = {
                ["messageId"] = "USIM_MSG_VERIFY",
                ["returnQueue"] = myq,
                ["returnMessageId"] = "USIM_MSG_STATUS"
            },

            ["body"] = {
                ["verify"] = {
                    ["id"] = 1,
                    ["pin"] = password
                }
            }
        }
        local message=msg_if.to_msg(message_table)
        q:put(message)
        return_message = myq:get(20000)
        if not return_message then
            return "Timed Out"
        end
        return_message_table = msg_if.from_msg(return_message)
        return return_message_table.status
    end

    local function validatePUK(puk,password)
        local myq=Queue.lookup("xavante")
        local q=Queue.lookup("USIM")
        local message_table=
        {
            ["head"] = {
                ["messageId"] = "USIM_MSG_UNBLOCK",
                ["returnQueue"] = myq,
                ["returnMessageId"] = "USIM_MSG_STATUS"
            },

            ["body"] = {
                ["unblock"] = {
                    ["id"] = 1,
                    ["puk"] = puk,
                    ["pin"] = password
                }
            }
        }
        local message=msg_if.to_msg(message_table)
        q:put(message)
        return_message = myq:get(20000)
        if not return_message then
            return "Timed Out"
        end
        return_message_table = msg_if.from_msg(return_message)
        return return_message_table.status
    end

    if cgilua.cgi["usimOP"] == "Validate" then
        usim_string = usim_status()
        if usim_string ~= "USIM_STATUS_OK" then
            usim_string = validate(cgilua.cgi["password"])
        end
    elseif cgilua.cgi["usimOP"] == "ValidatePUK" then
        --msg_if.lua_usim_unblock(cgilua.cgi["passwordPUK"],cgilua.cgi["password"])
        --usim_string = usim_status()
        usim_string = validatePUK(cgilua.cgi["passwordPUK"],cgilua.cgi["password"])
        --put(passwordPUK)
    elseif cgilua.cgi["usimOP"] == "Require" then
        if cgilua.cgi["pin"] ~= nil then
            main_sim_pin_res, main_req_pin_state = msg_if.lua_set_pin_state(tonumber(cgilua.cgi["req_pin"]),cgilua.cgi["pin"])
        else
            main_sim_pin_res = "USIM_STATUS_OK"
        end
        usim_string = usim_status()
    elseif cgilua.cgi["usimOP"] == "Change" then
        if cgilua.cgi["pw_old"] ~= nil then
            main_sim_pin_res = msg_if.lua_change_pin(cgilua.cgi["pw_old"], cgilua.cgi["pw_new1"])
        else
            main_sim_pin_res = "USIM_STATUS_OK"
        end
        usim_string = usim_status()
    else 
        usim_string = usim_status()
    end


    --usim_string = usim_status()

    --page_title = arg[1]
    product = msg_if.lua_get_short_product_id()
    trace(0, 1, string.format("lua - product = %s",product))
    hasNAT, hasSimpleNAT, hasBluetooth, hasUSB, hasManualPointing, CS_SUPPORT, hasBtLan, hasISDN, hasWLAN, hasSIP, hasEthNetMgmt = msg_if.lua_get_platform_info()

    trace(0, 1, string.format("lua - hasNAT = %d, hasBluetooth = %d, hasUSB = %d, hasManualPointing = %d",hasNAT, hasBluetooth, hasUSB, hasManualPointing))
    trace(0, 1, string.format("CS_SUPPORT = %s, hasBtLan = %d, hasISDN = %d, hasWLAN = %d",CS_SUPPORT, hasBtLan, hasISDN, hasWLAN))
    streaming = msg_if.lua_get_streaming_info()
    --page_title = pageID
    hasInterfaceIcons = TT_TRUE
    hasPotsDisable = TT_TRUE
    hasEthDisable = TT_TRUE
    isProductBDU = TT_FALSE
    if product == "EBDU" or product == "E727" or product == "E723" or product == "SBDU" or product == "S500" or product == "S250" then
        hasInterfaceIcons = TT_FALSE
        hasPotsDisable = TT_FALSE
        hasEthDisable = TT_FALSE
        isProductBDU = TT_TRUE
    elseif product == "SBL" then
        hasInterfaceIcons = TT_FALSE
        hasPotsDisable = TT_FALSE
        hasEthDisable = TT_FALSE
    end

    trace(0, 1, string.format("lua - pageID = %s", pageID))

    if CS_SUPPORT ~= "CS_STANDARD" and pageID == "Phone" then
        page_title = "Phone/Fax"    
    else
        page_title = pageID    
    end

    if debug_cgilua == "yes" then
        trace(0,1,"cgilua.cgi dump --->")
        table.foreach(cgilua.cgi, function(k,v) trace(0,1,"  '"..k.."' '"..v.."'") end)
        trace(0,1,"cgilua.cgi dump <---")
    end


    adm_status = ""
    not_shown_on = {}

    function entry_adm_generate (arg)
        --print('lua - entry_adm_generate: ' .. arg.status) 
        if arg.page_title == page_title then
            adm_status = arg.status
            not_shown_on = arg.not_shown_on
        end
    end

    entry = entry_adm_generate
    dofile(LUA_WEB_FILE_ROOT .. '/db.lua')


    if not_shown_on[1] == nil then
        page_title = "Home"
    elseif usim_string ~= "" then
        if usim_string ~= "USIM_STATUS_OK" and adm_status ~= "special" and adm_status ~= "admin_special" and adm_status ~= "admin_special_only" then
            page_title = "Home";
        end
        if usim_string == "USIM_STATUS_OK" and adm_status == "admin_special_only" then
            page_title = "Home";
        end
    end

    --print('lua - page_title: ' .. page_title)
    --print('lua - adm_status: ' .. adm_status)

    new_admin_login = "false"
    time = 0
    if cgilua.cgi["usernameAdm"] ~= "" and cgilua.cgi["usernameAdm"] ~= nil and cgilua.cgi["passwordAdm"] ~= nil then
        --trace(0, 1, string.format("lua - username: %s",cgilua.cgi["usernameAdm"]))
        --trace(0, 1, string.format("lua - password: %s",cgilua.cgi["passwordAdm"]))
        res, time = msg_if.lua_check_password(cgilua.cgi["usernameAdm"],cgilua.cgi["passwordAdm"])
        trace(0, 1, string.format("lua - check: %d",res))
        trace(0, 1, string.format("lua - time: %d",time))
        if res > -1 then
            new_admin_login = "true"
        end
    end

    saved_time = cgilua.cookies.get("tt_adm")

    if saved_time == nil then
        saved_time = 0
    end

    admin_status = -1
    if new_admin_login == "false" then
        admin_status = msg_if.lua_check_admin_status(saved_time)
    else
        admin_status = msg_if.lua_check_admin_status(time)
    end
    if adm_status == "admin" or adm_status == "admin_special" or adm_status == "admin_special_only" then
        if admin_status < 0 then
            page_title = "Administration"
        end
    end

    if not_shown_on[1] ~= "-" then
        for i = 1,table.getn(not_shown_on) do
            if not_shown_on[i] == product then
                trace(0, 1, string.format("lua - %s == %s",not_shown_on[i],product))
                page_title = "Home"
                break   
            end
            if not_shown_on[i] == "ManualPointingTrue" and hasManualPointing == TT_TRUE then
                page_title = "Home"
                break   
            end
            if not_shown_on[i] == "BluetoothDisabled" and hasBluetooth == TT_FALSE then
                page_title = "Home"
                break   
            end
            if not_shown_on[i] == "USBDisabled" and hasUSB == TT_FALSE then
                page_title = "Home"
                break   
            end
            if not_shown_on[i] == "ISDNDisabled" and hasISDN == TT_FALSE then
                page_title = "Home"
                break   
            end
            if not_shown_on[i] == "WLANDisabled" and hasWLAN == TT_FALSE then
                page_title = "Home"
                break   
            end
	    if not_shown_on[i] == "SIPDisabled" and hasSIP == TT_FALSE then
	        page_title = "Home"
	        break
	    end
            if not_shown_on[i] == "EthNetMgmtDisabled" and hasEthNetMgmt == TT_FALSE then
                page_title = "Home"
                break
            end
        end
    end

    --print('lua - page_title: ' .. page_title)


    --Setup lang and dictionary
    --check language change from language.lua, needs to be done before menu is rendered
    if cgilua.cgi["radio_langu"] ~= nil then
        settings_if.set_language(tonumber(cgilua.cgi["radio_langu"]));
        tmp_lang_txt, tmp_lang  = settings_if.get_language()
        cgilua.cgi["langID"] = tmp_lang_txt
    end
    dofile(LUA_WEB_FILE_ROOT .. '/lang.lua')

    filename = ""
    parent = ""
    vsize = 1

    function entry_filename_generate (arg)
        if arg.page_title == page_title then
            filename = arg.filename
            parent = arg.parent
            -- For a E300 translate Phone/Fax parent name gets translated to Phone
            if CS_SUPPORT == "CS_STANDARD" and parent == "Phone/Fax" then
                parent = "Phone"    
            end
            vsize = arg.vsize
        end
    end

    entry = entry_filename_generate
    dofile(LUA_WEB_FILE_ROOT .. '/db.lua')

    if cgilua.cgi["adminLogOff"] ~= nil then
        if cgilua.cgi["adminLogOff"] == "logoff" then
            --print('lua - logoff called')
            admin_status = -1
            cgilua.cookies.delete("tt_adm")
        end 
    end

    if cgilua.cgi["stop_pointing"] ~= nil then
        if cgilua.cgi["stop_pointing"] == "true" then
            msg_if.lua_stop_pointing()
        end 
    end

    if cgilua.cgi["usernameAdmChange"] ~= "" and cgilua.cgi["usernameAdmChange"] ~= nil and cgilua.cgi["passwordAdmChange1"] ~= nil and cgilua.cgi["passwordAdmChange2"] ~= nil then
        --print('lua - username: ' .. cgilua.cgi["usernameAdmChange"]) 
        --print('lua - password: ' .. cgilua.cgi["passwordAdmChange"])
        if cgilua.cgi["passwordAdmChange1"] == cgilua.cgi["passwordAdmChange2"] then 
            res = msg_if.lua_change_password(cgilua.cgi["usernameAdmChange"],cgilua.cgi["passwordAdmChange1"])
        end
        --print('lua - res: ' .. res)
    end

    if cgilua.cgi["radio_onoff_ethernet"] ~= nil then
        if cgilua.cgi["radio_onoff_ethernet"] == "enabled" then
            msg_if.lua_write_interface_status("ethernet","enabled")
        elseif cgilua.cgi["radio_onoff_ethernet"] == "disabled" then
            msg_if.lua_write_interface_status("ethernet","disabled")
        end
    end

    if cgilua.cgi["radio_onoff_usb"] ~= nil then
        if cgilua.cgi["radio_onoff_usb"] == "enabled" then
            msg_if.lua_write_interface_status("usb","enabled")
        elseif cgilua.cgi["radio_onoff_usb"] == "disabled" then
            msg_if.lua_write_interface_status("usb","disabled")
        end
    end

    if cgilua.cgi["radio_onoff_bluetooth"] ~= nil then
        if cgilua.cgi["radio_onoff_bluetooth"] == "enabled" then
            msg_if.lua_write_interface_status("bluetooth","enabled")
        elseif cgilua.cgi["radio_onoff_bluetooth"] == "disabled" then
            msg_if.lua_write_interface_status("bluetooth","disabled")
        end
    end

    if cgilua.cgi["radio_onoff_phonefax"] ~= nil then
        if cgilua.cgi["radio_onoff_phonefax"] == "enabled" then
            msg_if.lua_write_interface_status("pot","enabled")
        elseif cgilua.cgi["radio_onoff_phonefax"] == "disabled" then
            msg_if.lua_write_interface_status("pot","disabled")
        end
    end

    if cgilua.cgi["radio_onoff_isdn"] ~= nil then
        if cgilua.cgi["radio_onoff_isdn"] == "enabled" then
            msg_if.lua_write_interface_status("isdn","enabled")
        elseif cgilua.cgi["radio_onoff_isdn"] == "disabled" then
            msg_if.lua_write_interface_status("isdn","disabled")
        end
    end

    if cgilua.cgi["radio_onoff_wlan"] ~= nil then
        if cgilua.cgi["radio_onoff_wlan"] == "enabled" then
            msg_if.lua_write_interface_status("wlan","enabled")
        elseif cgilua.cgi["radio_onoff_wlan"] == "disabled" then
            msg_if.lua_write_interface_status("wlan","disabled")
        end
    end

    if cgilua.cgi["dbg_border"] ~= nil and cgilua.cgi["dbg_border"] == "1" then
        border_on = 1
    end
    
    --sajax init
    function new_sms()
        if usim_string ~= "USIM_STATUS_OK" then
           return 0
        else
           return msg_if.lua_new_msg_status()
        end
    end

    function ethernet_status()
        if usim_string ~= "USIM_STATUS_OK" then
           return 1
        else
           if hasInterfaceIcons ~= TT_TRUE then
                return 1
           else
                return msg_if.lua_read_interface_status("ethernet")
           end
        end
    end

    function pot_status()
        if usim_string ~= "USIM_STATUS_OK" then
           return 1
        else
           if hasInterfaceIcons ~= TT_TRUE then
                return 1
           else 
                return msg_if.lua_read_interface_status("pot")
           end 
        end
    end

    function isdn_status()
        if usim_string ~= "USIM_STATUS_OK" then
           return 1
        else
           if hasInterfaceIcons ~= TT_TRUE or hasISDN ~= TT_TRUE then
                return 1
           else
                return msg_if.lua_read_interface_status("isdn")
           end
        end
    end

    function wlan_status()
        if usim_string ~= "USIM_STATUS_OK" then
           return 1
        else
           if hasInterfaceIcons ~= TT_TRUE or hasWLAN ~= TT_TRUE then
                return 1
           else
               return msg_if.lua_read_interface_status("wlan")
           end
        end
    end

    function bluetooth_status()
        if usim_string ~= "USIM_STATUS_OK" then
           return 1
        else
           if hasInterfaceIcons ~= TT_TRUE or hasBluetooth ~= TT_TRUE then
                return 1
           else
                return msg_if.lua_read_interface_status("bluetooth")
           end
        end
    end

    function alarm_status()
        if usim_string ~= "USIM_STATUS_OK" then
           return 0
        else
           return msg_if.lua_alarm_status()
        end
    end

    function get_cn0_normalized()
    -- return normalized cn0 value; values for e300 and e700 gets adjusted to e500 range
        val = msg_if.lua_get_cn0()
        if product == "E700" then
            -- E700 range is 2.5dBHz "higher" than e500
            val = val - 25
        end
        return val
    end

    function get_battery_status()
        status, capacity = msg_if.lua_battery_status()
        return status
    end

    function get_battery_capacity()
        status, capacity = msg_if.lua_battery_status()
        return capacity
    end
    
    sajax.init()
    
    sajax.export ("new_sms", new_sms)
    sajax.export ("ethernet_status", ethernet_status)
    sajax.export ("pot_status", pot_status)
    sajax.export ("isdn_status", isdn_status)
    sajax.export ("wlan_status", wlan_status)
    sajax.export ("bluetooth_status", bluetooth_status)
    sajax.export ("alarm_status", alarm_status)
    sajax.export ("get_cn0_normalized", get_cn0_normalized)
    sajax.export ("get_battery_status", get_battery_status)
    sajax.export ("get_battery_capacity", get_battery_capacity)

    if filename == "mt_status" then        
        mt_sajax_export()
    end

    if sajax.handle_client_request () then return end 
    
    put(start_of_html_page1a)
    put(msg_if.lua_get_long_product_id())
    put(start_of_html_page1b)

    if cgilua.cgi["helpdesk"] ~= nil then
        if cgilua.cgi["helpdesk"] == "false" then
            put('<meta http-equiv="REFRESH" content="5; url=index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&helpdesk=true">')
        elseif cgilua.cgi["helpdesk"] == "save" then
            put('<meta http-equiv="REFRESH" content="0; url=debug_info">')
        end
        
    end
   
    if new_admin_login == "true" then
        cgilua.cookies.sethtml("tt_adm", time)      
        --sleep some time to be sure the cookie is handled in the client web browser
        msg_if.lua_sleep(100)
    end
    if admin_status > -1 then
        cgilua.cookies.sethtml("tt_adm", msg_if.lua_time())
        --sleep some time to be sure the cookie is handled in the client web browser
        msg_if.lua_sleep(100)
    end
    
    saved_time = cgilua.cookies.get("tt_adm")
    if saved_time == nil then
        saved_time = 0
    end 

    put(start_of_html_page2)
    put('               <script type="text/javascript">\n')
    put(sajax.show_javascript())

    if product == "EBDU" or product == "E727" or product == "E723" or product == "SBDU" or product == "S500" or product == "S250" or product=="SBL" then
        put(string.gsub(string.gsub(sajax_js1,"english",lang),"Alarm list","Event list")) 
    else
        put(string.gsub(sajax_js1,"english",lang))
    end

    if filename == "mt_status" then
        -- insert autogenerated mt_status javascript callback functions
        mt_status_funcs();
    end
    
    put('               </script>\n')
    put(start_of_html_page3a)
    
    if cgilua.cgi['local_onload'] ~= nil or 
    cgilua.cgi['cf_apply'] ~= nil or cgilua.cgi['cf_query'] ~= nil or
    cgilua.cgi['barr_apply'] ~= nil or cgilua.cgi['barr_query'] ~= nil or
    cgilua.cgi['cw_apply'] ~= nil or cgilua.cgi['cw_query'] ~= nil or 
    filename == "mt_status" then
        put('local_onload_func();')
    end

    if product == "SBDU" or product == "S500" or product == "S250" or product == "SBL" then
        put(string.gsub(start_of_html_page3b,"BGANLOGO","bgan-fill.jpg"))
    else
        put(string.gsub(start_of_html_page3b,"BGANLOGO","bgan.bmp")) 
    end

    dofile(LUA_WEB_FILE_ROOT .. '/status.lua')
    icons = 0
    dofile(LUA_WEB_FILE_ROOT .. '/icons.lua')
    put(icons_end1 .. (766-52*(icons+2)) .. icons_end2 .. 668*vsize .. icons_end3)
    --put(dummy_menu)
    if filename ~= "mt_status" then
        menu_generate(page_title)
    end
    --dofile(LUA_WEB_FILE_ROOT .. '/icons.lua')
    --menupath_generate(page_title,parent)
    dofile(LUA_WEB_FILE_ROOT .. '/' .. filename .. '.lua')
    put(end_of_html_page)
end

function link_generate (page_title, URL_string, link_string, link_type, confirm)
    text = "";
    if confirm ~= nil then
        text = 'onclick=\'return submitConfirm("'..confirm..'");\''
    end
    if link_type == "menu" then
        put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. URL_string .. '" STYLE="TEXT-DECORATION: NONE; color: #000000;" '..text..'>' .. current_dictionary(string.lower(link_string)) ..  '</A>')
    end
    if link_type == "norm" then
        put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. URL_string .. '" '..text..'>' .. current_dictionary(string.lower(link_string)) ..  '</A>')
    end
    if link_type == "direct" then
        put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. URL_string .. '" '..text ..'>' .. link_string ..  '</A>')
    end
    if link_type == "sort_up" then
        put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. URL_string .. '" STYLE="TEXT-DECORATION: NONE; color: #000000;" '..text..'>' .. current_dictionary(string.lower(link_string)) ..  '<img src="sort-up.gif" style="border-width: 0px;"></A>')
    end
    if link_type == "sort_down" then
        put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. URL_string .. '" STYLE="TEXT-DECORATION: NONE; color: #000000;" '..text..'>' .. current_dictionary(string.lower(link_string)) ..  '<img src="sort-down.gif" style="border-width: 0px;"></A>')
    end
end

function put_radio_button(type, name, main_text, a_text, b_text, checked)
    if type == "std_vert" then
        put('<p>\n')
        put('  ' ..current_dictionary(main_text).. ': \n')
        if checked == "a" then
            put('    <input type="radio" name="' .. name .. '" value="a" checked>' ..current_dictionary(a_text).. '&nbsp;&nbsp;\n') 
            put('    <input type="radio" name="' .. name .. '" value="b"> ' ..current_dictionary(b_text).. '\n')
        elseif checked == "b" then
            put('    <input type="radio" name="' .. name .. '" value="a">' ..current_dictionary(a_text).. '&nbsp;&nbsp;\n') 
            put('    <input type="radio" name="' .. name .. '" value="b" checked> ' ..current_dictionary(b_text).. '\n') 
        end
        put('</p>\n')
    end
    if type == "std_vert_table" then
        put('<td><p>\n')
        put('  ' ..current_dictionary(main_text).. ': </p></td>\n')
        if checked == "a" then
            put('    <td><p><input type="radio" name="' .. name .. '" value="a" checked>' ..current_dictionary(a_text).. '&nbsp;&nbsp;\n') 
            put('    <input type="radio" name="' .. name .. '" value="b"> ' ..current_dictionary(b_text).. '</p></td>\n')
        elseif checked == "b" then
            put('    <td><p><input type="radio" name="' .. name .. '" value="a">' ..current_dictionary(a_text).. '&nbsp;&nbsp;\n') 
            put('    <input type="radio" name="' .. name .. '" value="b" checked> ' ..current_dictionary(b_text).. '</p></td>\n') 
        end
    end

end

-- substitute all special characters with the html equivalent.
-- eg: thrane & thrane -> thrane &amp; thrane
function html_entities(str)
   str = string.gsub(str, "&", "&amp;")
   str = string.gsub(str, "<", "&lt;")
   str = string.gsub(str, ">", "&gt;")
   return str
end

--Check if a phone number is allowed (only contains 0-9, +, ' ')
function check_number (number)
    _, ok_chars = string.gsub(number, "[%d%+*# ]", "")
    --put(ok_chars)
    if ok_chars < string.len(number) then
        return false
    else
        return true
    end
end

--Check if a number is allowed (only contains 0-9, +, ' ')
function check_simple_number (number)
    _, ok_chars = string.gsub(number, "[%d%+ ]", "")
    --put(ok_chars)
    if ok_chars < string.len(number) then
        return false
    else                            
        return true
    end
end

function strip_spaces (str)
    num = string.gsub(str, "[ ]", "")
    -- return only the resulting string, not number of substitution
    -- as we then can't use it directly in C calls (msg_if etc)
    return num
end    

checked_text = function (expr)
  if (expr) then
    return ' checked '
  else
    return ''
  end
end

selected_text = function (expr)
  if (expr) then
    return ' selected '
  else
    return ''
  end
end

option_text = function (expr)
  if (expr) then
    return '  selected '
  else
    return ''
  end
end

-- Takes time/date string (formatted by lib/lua/system_if/src webif_format_date_time_string() )
-- and replaces the month tag with text from current dictionary
-- If year is 1970 it 
function translate_month_and_1970(str)
    if string.find(str,"1970") ~= nil then
        return current_dictionary("time unavailable")
    else
        str1 = string.gsub(str,"Jan",current_dictionary("short_month_jan"))
        str2 = string.gsub(str1,"Feb",current_dictionary("short_month_feb"))
        str1 = string.gsub(str2,"Mar",current_dictionary("short_month_mar"))
        str2 = string.gsub(str1,"Apr",current_dictionary("short_month_apr"))
        str1 = string.gsub(str2,"May",current_dictionary("short_month_may"))
        str2 = string.gsub(str1,"Jun",current_dictionary("short_month_jun"))
        str1 = string.gsub(str2,"Jul",current_dictionary("short_month_jul"))
        str2 = string.gsub(str1,"Aug",current_dictionary("short_month_aug"))
        str1 = string.gsub(str2,"Sep",current_dictionary("short_month_sep"))
        str2 = string.gsub(str1,"Oct",current_dictionary("short_month_oct"))
        str1 = string.gsub(str2,"Nov",current_dictionary("short_month_nov"))
        str2 = string.gsub(str1,"Dec",current_dictionary("short_month_dec"))
        return str2
    end
end 


