
-- Entries for the Mainenance page.
--
--  Groups must be listed together, starting with a member with group_position = "start", and ending
--  with a member with group_position = "end".
--
-- Field descriptions:
--   field_name:        Internal name. Use one word, lowercase.
--   prettyprint:       Name as seen on the web page
--   group:             Which group it is contained in.
--   grouppretty:       Only used for the first group member (i.e. group_position = "start"). Sets the group 
--                      name as seen on the web page. Use one word, lowercase.
--   groupcol:          This marks the web page column which contains the group:
--                          "start":        Marks the first group in current column
--                          "end":          Marks the last group in current column
--                          "":             All other groups
--   group_position:    This marks the position of the entry within its group. Valid values:
--                          "start":        Marks the first group member
--                          "end":          Marks the last group member
--                          "":             All other members
--   divclass:          Only used for the first group member (i.e. group_position = "start"). Chooses the
--                      HTML div class (=the size) for the box containing the group. Valid values:
--                          "mtwindow<x>":  See style sheet (css) for values of <x> and the corresponding sizes.
--   update_func        If "yes", the function new_<group>_<field_name>_value(value) will be called when a new value has
--                      been received. This function can then operate on the new value
--                      Mostly used to control threshold coloring

-- SYS group
entry{
    field_name = "buildno",
    prettyprint = "Build no.",
    group = "sys",
    group_position = "start",
    grouppretty = "System",
    groupcol = "start",
    divclass = "mtwindow3",
    update_func = ""    
}

entry{
    field_name = "imei",
    prettyprint = "IMEI",
    group = "sys",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "imsi",
    prettyprint = "IMSI",
    group = "sys",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "utclass",
    prettyprint = "UT class",
    group = "sys",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "temp",
    prettyprint = "Temperature",
    group = "sys",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "time",
    prettyprint = "Uptime",
    group = "sys",
    group_position = "end",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

-- GPS group
entry{
    field_name = "fixtype",
    prettyprint = "Fix type",
    group = "gps",
    group_position = "start",
    grouppretty = "GPS",
    groupcol = "",
    divclass = "mtwindow3",
    update_func = ""
}

entry{
    field_name = "pos",
    prettyprint = "Position",
    group = "gps",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "age",
    prettyprint = "Position age",
    group = "gps",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "vel",
    prettyprint = "Velocity",
    group = "gps",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "heading",
    prettyprint = "Heading",
    group = "gps",
    group_position = "end",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

-- USIM group
entry{
    field_name = "status",
    prettyprint = "Card status",
    group = "usim",
    group_position = "start",
    grouppretty = "USIM",
    groupcol = "",
    divclass = "mtwindow1",
    update_func = "yes"
}

entry{
    field_name = "pin1",
    prettyprint = "Pin 1 status",
    group = "usim",
    group_position = "end",
    grouppretty = "",
    groupcol = "end",
    divclass = "",
    update_func = "yes"
}

-- ANT group
entry{
    field_name = "anttype",
    prettyprint = "Type",
    group = "ant",
    group_position = "start",
    grouppretty = "Antenna",
    groupcol = "start",
    divclass = "mtwindow2",
    update_func = "yes"
}

entry{
    field_name = "status",
    prettyprint = "Status",
    group = "ant",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "temp_hpa",
    prettyprint = "Temperature (hpa)",
    group = "ant",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "temp_acm",
    prettyprint = "Temperature (acm)",
    group = "ant",
    group_position = "end",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

-- SAT group
entry{
    field_name = "name",
    prettyprint = "Name",
    group = "sat",
    group_position = "start",
    grouppretty = "Satellite",
    groupcol = "",
    divclass = "mtwindow2",
    update_func = ""
}

entry{
    field_name = "pos",
    prettyprint = "Position",
    group = "sat",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "elev",
    prettyprint = "Elevation",
    group = "sat",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "band",
    prettyprint = "Elevation band",
    group = "sat",
    group_position = "end",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

-- NAS group
entry{
    field_name = "rxtput",
    prettyprint = "Rx throughput",
    group = "nas",
    group_position = "start",
    grouppretty = "NAS",
    groupcol = "",
    divclass = "mtwindow4",
    update_func = "yes"
}

entry{
    field_name = "txtput",
    prettyprint = "Tx throughput",
    group = "nas",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "psattach",
    prettyprint = "PS status",
    group = "nas",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "csattach",
    prettyprint = "CS status",
    group = "nas",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "plmnstatus",
    prettyprint = "PLMN status",
    group = "nas",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "sesstatus",
    prettyprint = "Session status",
    group = "nas",
    group_position = "end",
    grouppretty = "",
    groupcol = "end",
    divclass = "",
    update_func = ""
}

-- IAI2 group
entry{
    field_name = "status",
    prettyprint = "Status",
    group = "iai2",
    group_position = "start",
    grouppretty = "IAI2",
    groupcol = "start",
    divclass = "mtwindow5",
    update_func = "yes"
}

entry{
    field_name = "beamtype",
    prettyprint = "Beam type",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "spotid",
    prettyprint = "Spot id",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "cno",
    prettyprint = "C/No",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "rxfreq",
    prettyprint = "Rx frequency",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "channo",
    prettyprint = "Channel no.",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "rxbytes",
    prettyprint = "Rx bytes",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "txbytes",
    prettyprint = "Tx bytes",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "rxqueue",
    prettyprint = "Rx queue size",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "txqueue",
    prettyprint = "Tx queue size",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "cipher",
    prettyprint = "Ciphering",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = ""
}

entry{
    field_name = "dropped",
    prettyprint = "Dropped packets",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "crcerr",
    prettyprint = "CRC errors",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "srej",
    prettyprint = "SREJ level",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "rxretr",
    prettyprint = "Rx retransmissions",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "txretr",
    prettyprint = "Tx retransmissions",
    group = "iai2",
    group_position = "",
    grouppretty = "",
    groupcol = "",
    divclass = "",
    update_func = "yes"
}

entry{
    field_name = "bcnstatus",
    prettyprint = "BCn status",
    group = "iai2",
    group_position = "end",
    grouppretty = "",
    groupcol = "end",
    divclass = "",
    update_func = ""
}


