
function get_val_string(func)
    mylist  = {func()}
    ret_str = "";
    for i,v in ipairs(mylist) do
        ret_str = ret_str .. v .. "$"
    end
    return ret_str
end

function mt_time()        
    return msg_if.lua_mt_time()
end

function mt_sys_status()        
    return get_val_string(msg_if.lua_mt_sys_status)
end

function mt_gps_status()
    return get_val_string(msg_if.lua_mt_gps_status)
end

function mt_usim_status()
    return get_val_string(msg_if.lua_mt_usim_status)
end

function mt_ant_status()
    return get_val_string(msg_if.lua_mt_ant_status)
end

function mt_iai2_status()
    return get_val_string(msg_if.lua_mt_iai2_status)
end

function mt_sat_status()
    return get_val_string(msg_if.lua_mt_sat_status)
end

function mt_nas_status()
    return get_val_string(msg_if.lua_mt_nas_status)
end

function mt_sajax_export()
    sajax.export ("mt_time", mt_time);
    sajax.export ("mt_sys_status", mt_sys_status);
    sajax.export ("mt_gps_status", mt_gps_status);
    sajax.export ("mt_usim_status", mt_usim_status);
    sajax.export ("mt_ant_status", mt_ant_status);
    sajax.export ("mt_iai2_status", mt_iai2_status);
    sajax.export ("mt_sat_status", mt_sat_status);
    sajax.export ("mt_nas_status", mt_nas_status);
end

mt_status_js = [[

    var mt_infoGroupCount;
    var mt_infoGroupMax = 0;
    var mt_currentTimeSec = 0;
    var mt_plotRxRate;
    var mt_plotTxRate;
    var mt_plotCno;

    function mt_time_cb(value) 
    {
        mt_currentTimeSec = parseInt(value/1000);
    }


    // Field update function - returns wanted text color
    function new_sys_temp_value(value)
    {
        return (parseInt(value) > 60) ? "red" : "black";
    }

    function new_gps_fixtype_value(value)
    {
//        return (value == "Fix") ? "black" : "red";
        return (value == "3D") ? "black" : "red";
    }

    function new_gps_age_value(value)
    {
        return (parseInt(value) > 60) ? "red" : "black";
    }

    function new_usim_status_value(value)
    {
        return (value == "Ok") ? "black" : "red";
    }

    function new_usim_pin1_value(value)
    {
        return (value == "Ok") ? "black" : "red";
    }

    function new_ant_anttype_value(value)
    {
        return (value == "Missing") ? "red" : "black";
    }

    function new_ant_status_value(value)
    {
        if(value == "Searching" ||  value == "Sky scan")
        {
            return "orange";
        }
        else if(value == "Tracking")
        {
            return "black";
        }
        else
        {
            return "red";
        }
    }

    function new_ant_temp_hpa_value(value)
    {
        return (parseInt(value) > 90) ? "red" : "black";
    }

    function new_ant_temp_acm_value(value)
    {
        return (parseInt(value) > 90) ? "red" : "black";
    }

    function new_sat_elev_value(value)
    {
        return (parseInt(value) < 10) ? "red" : "black";
    }

    function new_sat_band_value(value)
    {
        return (parseInt(value) < 0 || parseInt(value) > 4) ? "red" : "black";
    }

    function new_nas_rxtput_value(value)
    {
        mt_plotRxRate = value;
        
        return "black";
    }

    function new_nas_txtput_value(value)
    {
        mt_plotTxRate = value;
        
        return "black";        
    }

    function new_nas_psattach_value(value)
    {
        if(value == "Idle" ||  value == "Attaching")
        {
            return "orange";
        }
        else if(value == "Attached")
        {
            return "black";
        }
        else
        {
            return "red";
        }
    }

    function new_nas_csattach_value(value)
    {
        return new_nas_psattach_value(value);        
    }

    function new_iai2_status_value(value)
    {
        if(value == "Registering")
        {
            return "orange";
        }
        else if(value == "Registered")
        {
            return "black";
        }
        else
        {
            return "red";
        }
    }    

    function new_iai2_cno_value(value)
    {
        mt_plotCno = value;

        return (parseInt(value) < 17) ? "red" : "black";
    }    

    function new_iai2_dropped_value(value)
    {
        return (parseInt(value) > 0) ? "red" : "black";
    }

    function new_iai2_crcerr_value(value)
    {
        return (parseInt(value) > 0) ? "red" : "black";
    }

    function new_iai2_srej_value(value)
    {
        return (parseInt(value) > 0) ? "red" : "black";
    }

    function new_iai2_rxretr_value(value)
    {
        return (parseInt(value) > 0) ? "red" : "black";
    }

    function new_iai2_txretr_value(value)
    {
        return (parseInt(value) > 0) ? "red" : "black";
    }

    function checkAndUpdateTimer()
    {
        mt_infoGroupCount++;
        
        if(mt_infoGroupCount >= mt_infoGroupMax)
        {
            for(i=0;i<document.applets.length;i++)
            {
                // Hmmm... not pretty to send to all applets
                if(document.applets[i].isActive())
                {
                    document.applets[i].setInfo("Cno", mt_currentTimeSec, mt_plotCno);
                    if(mt_plotRxRate >= 0)
                    {
                	    document.applets[i].setInfo("RxRate", mt_currentTimeSec, mt_plotRxRate.toString());
                	}
                	if(mt_plotTxRate >= 0)
                    {
                	    document.applets[i].setInfo("TxRate", mt_currentTimeSec, mt_plotTxRate.toString());                	
                	}            	    
            	}
            }

            setTimeout('update_status_fields()', 1000);
            mt_infoGroupCount = 0;
        }
    }        

    function local_onload_func()
    {
        mt_infoGroupCount = 0;
        update_status_fields();        
    }
   
]]


mt_grouptable = {};
mt_current_group_str = nil;
mt_index = 0;

function status_func_generate(arg)
    if arg.group_position == "start" then                
        -- New group started                                
        table.insert(mt_grouptable, arg.group)
        mt_current_group_str = "function mt_" .. arg.group .. "_status_cb(z) {\n"
        mt_current_group_str = mt_current_group_str .. "var myRef; var fields = z.split(\"$\");\n"
        mt_index = 0;
    end
    mt_current_group_str = mt_current_group_str .. "myRef = document.getElementById(\"" .. arg.group .. "_" .. arg.field_name .. "\");\n"   
    mt_current_group_str = mt_current_group_str .. 'myRef.innerHTML = "<p class=\\"mttext\\">" + fields[' .. mt_index .. '] + "</p>";\n'
    if arg.update_func == "yes" then
        mt_current_group_str = mt_current_group_str .. "myRef.style.color = new_" .. arg.group .. "_" .. arg.field_name .. "_value(fields[" .. mt_index .. "]);\n"
    end
    mt_index = mt_index + 1
    
    if arg.group_position == "end" then
        -- End current group
        put(mt_current_group_str);
        put("checkAndUpdateTimer();\n");
        put("}\n");
        put("mt_infoGroupMax++;\n");
    end
end

function mt_status_funcs()
    put(mt_status_js)
    
    entry = status_func_generate
    dofile(LUA_WEB_FILE_ROOT .. '/mt_status_db.lua')
    
    put("function update_status_fields()\n{\n");
    put("x_mt_time(mt_time_cb);\n");
    for _,v in pairs(mt_grouptable) do
        put("x_mt_" .. v .. "_status(mt_" .. v .. "_status_cb);\n");
    end
    put("}\n");
end

