traffic_type_text = function (val)
-- interactive reported as standard and conversational as streaming
  if (val == 2) or (val == 1) then
    return 'streaming'
  elseif (val == 4) or (val == 3) then
    return 'standard data'
  elseif (val == 5) then
    return 'streaming 32 kbps'
  elseif (val == 6) then
    return 'streaming 64 kbps'
  elseif (val == 7) then
    return 'streaming 128 kbps'
  elseif (val == 8) then
    return 'streaming 256 kbps'
  else  
    return 'unknown'
  end
end

count, nug_data = nm_if.lua_get_active_nug_list()

if admin_status < 0 then
    error_msg = current_dictionary("enter password")
end

put(start_of_content)

if count == 1 then
    put('<br><p id="errortext">' .. current_dictionary('only active if more than one group') .. '</p>\n')
elseif admin_status < 0 then
    put('<p><table align=left border="'..border_on..'" cellpadding="0">\n')
    put('<form name="adm_password" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
    put('<tr>\n')
        put('<td align="left"  colspan="3"><p id="errortext">' .. error_msg .. '</p></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<th align="left"><p class="menutext">' .. current_dictionary("administrator logon") .. '</p></th>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' .. current_dictionary("username") .. ':</td>\n')
        put('<td align="left"><input type="text" name="usernameAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' ..current_dictionary("password") .. ':</td>\n')
        put('<td align="left"><input type="password" name="passwordAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p><INPUT type="submit" value="' .. current_dictionary("logon") .. '">&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>\n')
    put('</form>\n')
    put('</table></p>\n')
else
    nug_active = {}

    for i=0,count-1 do
        nug_active[i] = nug_data[i]

        nug_active[i] = {}
        nug_active[i]['idx'] = nug_data[i*2 + 1]
        nug_active[i]['auto_activate'] = nug_data[i*2 + 2]
    end

    if cgilua.cgi["pdpOP"] ~= nil and cgilua.cgi["cid"] ~= nil and cgilua.cgi["grp"] ~= nil then
        valid_grp = false
        grp = tonumber(cgilua.cgi["grp"])
        for i=0,table.getn(nug_active) do
            if nug_active[i]['idx'] == grp then
                valid_grp = true
                break
            end            
        end
        if not valid_grp then
            error_msg = "Invalid request"
        else
            if cgilua.cgi["pdpOP"] == "1" then
                msg_if.lua_start_pdp(cgilua.cgi["cid"],cgilua.cgi["grp"]);
            else
                msg_if.lua_stop_pdp(cgilua.cgi["cid"],cgilua.cgi["grp"]);
            end
        end
    end

    data_sessions = {}
    data_no = msg_if.lua_get_number_ps_sessions()
    for i=0,(data_no-1) do
        ip1,ip2,ip3,ip4,traftype,isNug,nugId = msg_if.lua_get_ps_session(i)
        table.insert(data_sessions,{ip = ip1..'.'..ip2..'.'..ip3..'.'..ip4, traftype = traftype, isNug = isNug, nugId = nugId})
    end


    --Print any error message
    put('<table align=center><tr><td><p id="errortext">')
    put(error_msg .. '</p></td></tr></table>')

    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">')
    put('<table border = "'..border_on..'">')

        put('<tr>')
            put('<td align="left" colspan="3"><p class="menutext">'.. current_dictionary("ongoing data sessions") ..'</p></td>')
        put('</tr>')
        put('<tr>')
            if table.getn(data_sessions) == 0 then
                put('<td align="left" colspan="3"><p>('..current_dictionary('no active data sessions')..')</p></td>')
            else
                name = ''
                if data_sessions[1].isNug then
                    name = nm_if.lua_get_nug_name(data_sessions[1].nugId)
                end

                put('<td align="left"><p>'..current_dictionary(traffic_type_text(data_sessions[1].traftype)) .. '  ('..data_sessions[1].ip..')</p></td>')
                put('<td align="left" width="10"></td>')
                put('<td align="left"><p>'..name..'</p></td>')
            end
        put('</tr>')
        for i=2,table.getn(data_sessions) do
            name = ''
            if data_sessions[i].isNug then
                name = nm_if.lua_get_nug_name(data_sessions[i].nugId)
            end
            put('<tr>')
                put('<td align="left"><p>'..current_dictionary(traffic_type_text(data_sessions[i].traftype)) .. '  ('..data_sessions[i].ip..')</p></td>')
                put('<td align="left" width="10"></td>')
                put('<td align="left"><p>'..name..'</p></td>')
            put('</tr>')
        end
    put('</table>')

    put('<table align="left" border="'..border_on..'" cellpadding="0">')

    for k=0,table.getn(nug_active) do
        nug = nug_active[k]['idx']
        pdp_lan = {}
        
        if nug_active[k]['auto_activate'] == 1 then
            pdp_lan_no = msg_if.lua_get_number_pdp_lan(1,nug)
        else
            pdp_lan_no = msg_if.lua_get_number_pdp_lan(0,nug)
        end
        for i=0,(pdp_lan_no-1) do
            cid, prof, active, name = msg_if.lua_get_pdp_lan(i)
            table.insert(pdp_lan,{cid = cid, profile = prof, active = active, name = name})
        end
        prim_act_cid, prim_act_profile, prim_act_profile_name = msg_if.lua_get_pdp_lan_primary()

        put('<tr>')
            -- If auto activate is enabled we only show streaming profiles
            nug_text = ' ('..nm_if.lua_get_nug_name(nug)..')'
    
            if nug_active[k]['auto_activate'] == 1 then
                put('<th align="left" colspan="5"><p class="menutext" >' .. current_dictionary("streaming pdp lan").. nug_text..'</p></th>\n')
            else
                put('<th align="left" colspan="5"><p class="menutext" >' .. current_dictionary("pdp lan").. nug_text..'</p></th>\n')
            end
        put('</tr>')

        show_stop_old = false
        if prim_act_cid ~= 0 then
            show_stop_old = true
            in_list = false
            for i=1,table.getn(pdp_lan) do
                if pdp_lan[i].cid == prim_act_cid then
                    if pdp_lan[i].profile == prim_act_profile then
                        show_stop_old = false
                    end
                    in_list = true
                    break
                end
            end
            if not in_list and nug_active[k]['auto_activate'] == 1 and prim_act_profile == 0 then
                show_stop_old = false
            end
        end

        if show_stop_old then
            put('<tr>')
            put('<td align="left"><p>')
            txt1 = current_dictionary('stop')
            txt2 = 0
            link_generate (page_title, "&amp;pdpOP="..txt2.."&amp;cid="..prim_act_cid.."&amp;grp="..nug, txt1..' '..prim_act_profile_name, "direct", current_dictionary("do you want to")..' '..txt1..' '..prim_act_profile_name..' ?')
            put('</p></td>')
            put('</tr>')
        end
     
        put('<tr>')
        if table.getn(pdp_lan) == 0 then
            if not show_stop_old then
                put('<td align="left"><p>('..current_dictionary('no profiles')..')</p></td>')
            end            
        else
            for i=1,math.min(table.getn(pdp_lan),3) do
                put('<td align="left" width="150"><p>')
                if pdp_lan[i].active == 1 then
                    txt1 = current_dictionary('stop')
                    txt2 = 0
                else
                    txt1 = current_dictionary('start')
                    txt2 = 1
                end
                if show_stop_old and pdp_lan[i].cid == prim_act_cid then
                    put(current_dictionary('start')..' '..pdp_lan[i].name)
                else
                    link_generate (page_title, "&amp;pdpOP="..txt2.."&amp;cid="..pdp_lan[i].cid.."&amp;grp="..nug, txt1..' '..pdp_lan[i].name, "direct", current_dictionary("do you want to")..' '..txt1..' '..pdp_lan[i].name..' ?')
                end    
                put('</p></td>\n')
            end
        end
        put('</tr>')
        if table.getn(pdp_lan) > 3 then
            put('<tr>')
            for i=4,table.getn(pdp_lan) do
                put('<td align="left" width="150"><p>')
                if pdp_lan[i].active == 1 then
                    txt1 = current_dictionary('stop')
                    txt2 = 0
                else
                    txt1 = current_dictionary('start')
                    txt2 = 1
                end
                link_generate (page_title, "&amp;pdpOP="..txt2.."&amp;cid="..pdp_lan[i].cid.."&amp;grp="..nug, txt1..' '..pdp_lan[i].name, "direct", current_dictionary("do you want to")..' '..txt1..' '..pdp_lan[i].name..' ?')
                put('</p></td>\n')
            end
            put('</tr>')
        end
    end
    put('<tr>')
        put('<td align="left"><p><input type="submit" name="submit" value="' .. current_dictionary("refresh") .. '"></td>\n')
    put('</tr>')
    put('</table></form>')
end
put(end_of_content)


