--debug phone book content
--msg_if.lua_write_phonebook(1,"A. Random Number","2312343242","international")
--msg_if.lua_write_phonebook(5,"Another Random Number","654654654654","international")
--msg_if.lua_write_phonebook(4,"Just A. Random Number","456353453","unknown")
--msg_if.lua_write_phonebook(2,"This Is A. Test","6546546599","unknown")

--msg_if.lua_write_phonebook(22,"abc","123","unknown")
--msg_if.lua_write_phonebook(25,"bcd","234","unknown")
--msg_if.lua_write_phonebook(56,"cde","345","unknown")



all_entries = {}
phonebook_entries = {}

max_entries, max_length = msg_if.lua_phonebook_info()

error_msg = "&nbsp;";
edit = "false"

--Parse URL (simple)
if cgilua.cgi["phonebookOP"] ~= nil then
    if cgilua.cgi["phonebookOP"] == "delete" then
        --Delete entry with "entryIndex"
        if cgilua.cgi["entryIndex"] ~= nil then
            msg_if.lua_write_phonebook(cgilua.cgi["entryIndex"],"","","unknown")    
        end
    elseif cgilua.cgi["phonebookOP"] == "reset" then
        --Delete content of phone book
        for i = 1,max_entries do
            msg_if.lua_write_phonebook(i,"","","unknown")
        end  
    elseif cgilua.cgi["phonebookOP"] == "edit" then
        --Show edit fields to the user (done later)
        edit = "true" 
    end
end

--Parse URL, check the URL contains a number
if cgilua.cgi["number"] ~= nil and string.gsub(cgilua.cgi["number"],"[+*# ]","") ~= "" and cgilua.cgi["name"] ~= nil then
   --If user was editing an entry
    if cgilua.cgi["phonebookOP"] == "saveEntry" and cgilua.cgi["entryIndex"] ~= nil then
        --Check if the new number is valid
        if not check_number(cgilua.cgi["number"]) then
            --If not, print a error message
            error_msg = current_dictionary("only 0-9, +, *, # and spaces are allowed in phone numbers")
        else
            temp_number = cgilua.cgi["number"]
            temp_number_int, international = string.gsub(temp_number, "[+]", "") 
            final_number = strip_spaces(temp_number_int)
            --Insert changed entry at index
            if international > 0 then  
                msg_if.lua_write_phonebook(cgilua.cgi["entryIndex"],cgilua.cgi["name"],final_number,"international")
            else
                msg_if.lua_write_phonebook(cgilua.cgi["entryIndex"],cgilua.cgi["name"],final_number,"unknown")
            end
        end
    end
end

--Print error message if no valid number
if cgilua.cgi["number"] ~= nil then
    if string.gsub(cgilua.cgi["number"],"[+*# ]","") == "" then
        error_msg = current_dictionary("please enter a phone number")
    end
end 

for i = 1,max_entries do
    pb_name, pb_number, pb_type = msg_if.lua_read_phonebook(i)
    table.insert(all_entries,{pb_name,pb_number,i,pb_type})
end  

sort = ""

--trace(0, 1, string.format("number[%d]: %d",1,all_entries[1][2]))
--trace(0, 1, string.format("number[%d]: %d",2,all_entries[2][2]))
--trace(0, 1, string.format("number[%d]: %d",3,all_entries[3][2]))
--trace(0, 1, string.format("number[%d]: %d",4,all_entries[4][2]))
--trace(0, 1, string.format("number[%d]: %d",10,all_entries[10][2]))

--Sort after numbers
if cgilua.cgi["sortOP"] == "sortNU" then
    sort = "&sortOP=sortNU"
    numbers = {}
    empty_entries = {}
    for i = 1,table.getn(all_entries) do
        if all_entries[i][2] == "" then
            table.insert(empty_entries,all_entries[i][3])
        else
            table.insert(numbers,all_entries[i][2])
        end
    end
    table.sort(numbers,function (a, b) return string.lower(a) < string.lower(b) end)
    new_phonebook = {}
    for i = 1,table.getn(numbers) do
        for j = 1,table.getn(all_entries) do
            if all_entries[j][2] == numbers[i] then
                table.insert(new_phonebook,all_entries[j])
                break
            end
        end
    end
    for i = 1,table.getn(empty_entries) do
        table.insert(new_phonebook,all_entries[empty_entries[i]])   
    end
    trace(0, 1, string.format("numbers: %d",table.getn(numbers)))
    trace(0, 1, string.format("empty_entries: %d",table.getn(empty_entries)))
    trace(0, 1, string.format("new_phonebook: %d",table.getn(new_phonebook)))
    trace(0, 1, string.format("all_entries: %d",table.getn(all_entries)))
    all_entries = new_phonebook
end


--Sort after names
if cgilua.cgi["sortOP"] == "sortNA" then
    sort = "&sortOP=sortNA"
    names = {}
    empty_entries = {}
    for i = 1,table.getn(all_entries) do
        if all_entries[i][1] == "" then
            table.insert(empty_entries,all_entries[i][3])
        else
            table.insert(names,all_entries[i][1])
        end
    end
    table.sort(names,function (a, b) return string.lower(a) < string.lower(b) end)
    new_phonebook = {}
    for i = 1,table.getn(names) do
        for j = 1,table.getn(all_entries) do
            if all_entries[j][1] == names[i] then
                table.insert(new_phonebook,all_entries[j])
                break
            end
        end
    end
    for i = 1,table.getn(empty_entries) do
        table.insert(new_phonebook,all_entries[empty_entries[i]])   
    end
    trace(0, 1, string.format("names: %d",table.getn(names)))
    trace(0, 1, string.format("empty_entries: %d",table.getn(empty_entries)))
    trace(0, 1, string.format("new_phonebook: %d",table.getn(new_phonebook)))
    trace(0, 1, string.format("all_entries: %d",table.getn(all_entries)))
    all_entries = new_phonebook
end

if cgilua.cgi["phonebookPage"] ~= nil then
    pageNumber = cgilua.cgi["phonebookPage"]
else
    pageNumber = 1
end

for i = 1,19 do
    table.insert(phonebook_entries,{all_entries[i+(pageNumber-1)*20][1],all_entries[i+(pageNumber-1)*20][2],all_entries[i+(pageNumber-1)*20][3],all_entries[i+(pageNumber-1)*20][4]})
end

if tonumber(pageNumber) < 10 then
    table.insert(phonebook_entries,{all_entries[20+(pageNumber-1)*20][1],all_entries[20+(pageNumber-1)*20][2],all_entries[20+(pageNumber-1)*20][3],all_entries[20+(pageNumber-1)*20][4]})
end

   allowed = true;
-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("edit_phone_book")
        if not allowed then 
            error_msg = current_dictionary("admin_locked")
        end
    end

--Generate html code
put(start_of_content)
put('<p id="errortext">' .. error_msg .. '</p>')
put('<table align=left border="'..border_on..'" width="80%">')
--Phone book menu
put('<th align="center" width="7%"><p>\n')
link_generate (page_title, "", "entry", "sort_down")
put('</p></th>\n')
put('<th align="center" width="5%"><p>\n')
put('</p></th>\n')
put('<th align="left" width="25%"><p>\n')
link_generate (page_title, "&amp;sortOP=sortNA", "name", "sort_down")
put('</p></th>\n')
put('<th align="left" width="25%"><p>\n')
link_generate (page_title, "&amp;sortOP=sortNU", "number", "sort_down")
put('</p></th>\n')
put('<th align="center" width="25%"><p>\n')
put(current_dictionary("actions"))
put('</p></th>\n')

--Main table of phone book
for i = 1,table.getn(phonebook_entries) do
    --Allow the user to edit one entry
    if edit == "true" and tonumber(cgilua.cgi["entryIndex"]) == phonebook_entries[i][3] then
        if phonebook_entries[i][4] == "international" then
            put('<tr><form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;phonebookOP=saveEntry&amp;entryIndex=' .. phonebook_entries[i][3] .. '&amp;phonebookPage=' .. pageNumber .. sort ..'"><td align="center"><p>' .. i+(pageNumber-1)*20 .. '</p></td><td></td><td align="left"><input type="text" name="name" maxlength="20" size="20" value="' .. phonebook_entries[i][1] .. '"></td><td align="left"><input type="text" name="number" maxlength="32" size="32" value="+' .. phonebook_entries[i][2] .. '"></td><td align="center"><input type="submit" value="'..current_dictionary("save entry")..'"></td></form></tr>')
        else
            put('<tr><form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;phonebookOP=saveEntry&amp;entryIndex=' .. phonebook_entries[i][3] .. '&amp;phonebookPage=' .. pageNumber .. sort ..'"><td align="center"><p>' .. i+(pageNumber-1)*20 .. '</p></td><td></td><td align="left"><input type="text" name="name" maxlength="20" size="20" value="' .. phonebook_entries[i][1] .. '"></td><td align="left"><input type="text" name="number" maxlength="32" size="32" value="' .. phonebook_entries[i][2] .. '"></td><td align="center"><input type="submit" value="'..current_dictionary("save entry")..'"></td></form></tr>')
        end
    else
        --Else print normal entries 
        put('<tr><td align="center"><p>')
        put(phonebook_entries[i][3])  
        put('</p></td>')
        put('<td></td>')
        put('<td align="left"><p>' .. phonebook_entries[i][1] .. '</p></td>')
        if phonebook_entries[i][4] == "international" then
            put('<td align="left"><p>+' .. phonebook_entries[i][2] .. '</p></td>')
        else
            put('<td align="left"><p>' .. phonebook_entries[i][2] .. '</p></td>')
        end
        if phonebook_entries[i][2] ~= "" and allowed then
            put('<td align="center"><p><A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;phonebookOP=edit&amp;entryIndex=' .. phonebook_entries[i][3] ..'&amp;phonebookPage=' .. pageNumber .. sort ..'">' .. current_dictionary("edit") .. '</A>/<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;phonebookOP=delete&amp;entryIndex=' .. phonebook_entries[i][3] ..'&amp;phonebookPage=' .. pageNumber .. sort ..'">' .. current_dictionary("delete") .. '</p></A></td></tr>') 
        elseif allowed then
            put('<td align="center"><p><A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;phonebookOP=edit&amp;entryIndex=' .. phonebook_entries[i][3] ..'&amp;phonebookPage=' .. pageNumber .. sort ..'">' .. current_dictionary("new") .. '</A></p></td></tr>')   
        end
    end
end
put('<tr><td colspan="5" align="center"><p>\n')
--Reset link
if allowed then link_generate (page_title, "&amp;phonebookOP=reset&amp;phonebookPage=" .. pageNumber , "delete all entries in phone book", "norm") end
put('</p></td></tr>\n')
put('<tr><td colspan="5" align="center">\n')
put('<p class="menutext">')
for i = 1,10 do
    link_generate(page_title, "&amp;phonebookPage=" .. i .. sort, i, "direct")
    put(" ")
end
put('</p>\n')
put('</td></tr>') 
put('</table>')

put('</tr></table>')
put(end_of_content)
