
-- ********************************
-- object handling (set)
-- ********************************
hasTwoPhonePorts = TT_FALSE
if product == "E700" or product == "EBDU" or product == "E727" or product == "E723" or product == "SBDU" or product == "S500" or product == "S250" or product == "SBL" then
   hasTwoPhonePorts = TT_TRUE
end

calltype1, supported_calltypes1 = msg_if.lua_get_phone_fax_status(1)
trace(0, 1, string.format("lua - calltype1: %s", calltype1))
trace(0, 1, string.format("lua - supported_calltypes1: %s", supported_calltypes1))
if hasTwoPhonePorts == TT_TRUE then
   calltype2, supported_calltypes2 = msg_if.lua_get_phone_fax_status(2)
   trace(0, 1, string.format("lua - calltype2: %s", calltype2))
   trace(0, 1, string.format("lua - supported_calltypes2: %s", supported_calltypes2))
end

if cgilua.cgi["phonefaxoutgoing1"] ~= nil then
   if cgilua.cgi["phonefaxoutgoing1"] == "a" then
      calltype1 = 0 
   end
   if cgilua.cgi["phonefaxoutgoing1"] == "b" then
      calltype1 = 1
   end
end
if cgilua.cgi["phonefaxoutgoing2"] ~= nil then
   if cgilua.cgi["phonefaxoutgoing2"] == "a" then
      calltype2 = 0 
   end
   if cgilua.cgi["phonefaxoutgoing2"] == "b" then
      calltype2 = 1
   end
end


if cgilua.cgi["phonefaxincoming_std1"] ~= nil then
   trace(0, 1, string.format("lua - phonefaxincoming_std1: %s", cgilua.cgi["phonefaxincoming_std1"]))
end
if cgilua.cgi["phonefaxincoming_prem1"] ~= nil then
   trace(0, 1, string.format("lua - phonefaxincoming_prem1: %s", cgilua.cgi["phonefaxincoming_prem1"]))
end
if cgilua.cgi["phonefaxincoming_std2"] ~= nil then
   trace(0, 1, string.format("lua - phonefaxincoming_std2: %s", cgilua.cgi["phonefaxincoming_std2"]))
end
if cgilua.cgi["phonefaxincoming_prem2"] ~= nil then
   trace(0, 1, string.format("lua - phonefaxincoming_prem2: %s", cgilua.cgi["phonefaxincoming_prem2"]))
end


if cgilua.cgi["phonefaxincoming_std1"] ~= nil and cgilua.cgi["phonefaxincoming_prem1"] ~= nil then
   msg_if.lua_set_phone_fax_status(1,calltype1,3)
elseif cgilua.cgi["phonefaxincoming_prem1"] ~= nil then
   msg_if.lua_set_phone_fax_status(1,calltype1,2)
elseif cgilua.cgi["phonefaxincoming_std1"] ~= nil then
   msg_if.lua_set_phone_fax_status(1,calltype1,1)
else
   if cgilua.cgi["submit"] ~= nil then
      msg_if.lua_set_phone_fax_status(1,calltype1,0)
   end
end
if hasTwoPhonePorts == TT_TRUE then
   if cgilua.cgi["phonefaxincoming_std2"] ~= nil and cgilua.cgi["phonefaxincoming_prem2"] ~= nil then
      msg_if.lua_set_phone_fax_status(2,calltype2,3)
   elseif cgilua.cgi["phonefaxincoming_prem2"] ~= nil then
      msg_if.lua_set_phone_fax_status(2,calltype2,2)
   elseif cgilua.cgi["phonefaxincoming_std2"] ~= nil then
      msg_if.lua_set_phone_fax_status(2,calltype2,1)
   else
      if cgilua.cgi["submit"] ~= nil then
	 msg_if.lua_set_phone_fax_status(2,calltype2,0)
      end
   end
end

-- *****************
-- get current state
-- *****************

status = msg_if.lua_read_interface_status("pot")
calltype1, supported_calltypes1 = msg_if.lua_get_phone_fax_status(1)
trace(0, 1, string.format("lua - calltype1: %s", calltype1))
trace(0, 1, string.format("lua - supported_calltypes1: %s", supported_calltypes1))
if hasTwoPhonePorts == TT_TRUE then
   calltype2, supported_calltypes2 = msg_if.lua_get_phone_fax_status(2)
   trace(0, 1, string.format("lua - calltype2: %s", calltype2))
   trace(0, 1, string.format("lua - supported_calltypes2: %s", supported_calltypes2))
end



-- check access permission
disabled_string = ''
if admin_status < 0 then
   allowed = msg_if.lua_get_user_permissions("change_phone")
   if not allowed then 
      disabled_string = ' disabled '
      error_msg = current_dictionary("admin_locked")
   end
end


-- ***********
-- format html
-- ***********

put(start_of_content)
put('<p id="errortext">' .. error_msg .. '</p>')
put('<p><table border="'..border_on..'" cellpadding="0" align="left">')
put('<form name="settings_interfaces" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')
--Enable/disable interface
if hasPotsDisable == TT_TRUE then
   put('<tr>')
   put('<th align="left"><p class="menutext">' ..current_dictionary("interface status").. '</p></th>')
   put('</tr>')
   put('<tr>')
   if CS_SUPPORT ~= "CS_STANDARD" then
      put('<td align="left"><p>' ..current_dictionary("phone/fax interface") .. '</p></td>')
   else
      put('<td align="left"><p>' ..current_dictionary("phone interface") .. '</p></td>')
   end
   put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_onoff_phonefax" value="enabled" ' ..checked_text(status == 0).. '>' .. current_dictionary("enabled") .. '</p></td>\n')
   put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_onoff_phonefax" value="disabled" ' ..checked_text(status == 1).. '>' .. current_dictionary("disabled") .. '</p></td>\n')
   put('</tr>')
end
if hasTwoPhonePorts == TT_TRUE then
   put('<tr>')
   put('<th align="left"><p class="menutext">' ..current_dictionary("port 1").. '</p></th>')
   put('</tr>')
end 
put('<tr>')
put('<td align="left"><p>' ..current_dictionary("incoming calls").. '</p></td>')
put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="phonefaxincoming_std1" value="ON"')
if supported_calltypes1 == 1 or supported_calltypes1 == 3 then
   put(' checked ')
end
put('>' ..current_dictionary("standard").. '</p></td>')
if CS_SUPPORT ~= "CS_STANDARD" then
   put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="phonefaxincoming_prem1" value="ON"')
   if supported_calltypes1 > 1 then
      put(' checked ')
   end
   put('>' ..current_dictionary("3.1kHz audio").. '</p></td>')
end
put('</tr>')
if CS_SUPPORT ~= "CS_STANDARD" then
   put('<tr>')
   put('<td align="left"><p>' ..current_dictionary("outgoing calls") .. '</p></td>')        
   put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="phonefaxoutgoing1" value="a" ' ..checked_text(calltype1 == "Speech").. '>' .. current_dictionary("standard") .. '</p></td>\n')
   put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="phonefaxoutgoing1" value="b" ' ..checked_text(calltype1 == "3.1KHz").. '>' .. current_dictionary("3.1kHz audio") .. '</p></td>\n')          
   put('</tr>')
end
if hasTwoPhonePorts == TT_TRUE then
   put('<tr>')
   put('<th align="left"><p class="menutext">' ..current_dictionary("port 2").. '</p></th>')
   put('</tr>') 
   put('<tr>')
   put('<td align="left"><p>' ..current_dictionary("incoming calls").. '</p></td>')
   put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="phonefaxincoming_std2" value="ON"')
   if supported_calltypes2 == 1 or supported_calltypes2 == 3 then
      put(' checked ')
   end
   put('>' ..current_dictionary("standard").. '</p></td>')
   put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="phonefaxincoming_prem2" value="ON"')
   if supported_calltypes2 > 1 then
      put(' checked ')
   end
   put('>' ..current_dictionary("3.1kHz audio").. '</p></td>')
   put('</tr>')
   put('<tr>')
   put('<td align="left"><p>' ..current_dictionary("outgoing calls") .. '</p></td>')
   put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="phonefaxoutgoing2" value="a" ' ..checked_text(calltype2 == "Speech").. '>' .. current_dictionary("standard") .. '</p></td>\n')
   put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="phonefaxoutgoing2" value="b" ' ..checked_text(calltype2 == "3.1KHz").. '>' .. current_dictionary("3.1kHz audio") .. '</p></td>\n')
   put('</tr>')
end   

--submit button
put('<tr>')
put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
put('</tr>')
put('</form></table></p>\n')
put(end_of_content)
