-- ***************
-- local functions
-- ***************

-- Read posted parameters, and send data to flash
function submit()
   portf = {}
   enabled = 0
   if cgilua.cgi["submit"] ~= nil then
      if cgilua.cgi["pf_onoff"] ~= nil then
     if cgilua.cgi["pf_onoff"] == "enabled" then
        enabled = 1
     else
        enabled = 0
     end 
      end

      for i = 1, 10 do 
     portf[i] = {}
     if cgilua.cgi["pft_active" .. i] ~= nil then
        portf[i]["enabled"] = 1 --active
     else
        portf[i]["enabled"] = 0 --disabled
     end
     put('<!-- Enabled: ' .. portf[i]["enabled"] .. '-->\n')


     if cgilua.cgi["pft_port" .. i] ~= nil then
        portf[i]["port"] = cgilua.cgi["pft_port" .. i]
     end
     if cgilua.cgi["pft_destip" .. i] ~= nil then
        portf[i]["translatedip"] = cgilua.cgi["pft_destip" .. i]
     end
     if cgilua.cgi["pft_destport" .. i] ~= nil then
        portf[i]["translatedport"] = cgilua.cgi["pft_destport" .. i]
     end
     if cgilua.cgi["pft_port_end" .. i] ~= nil then
        portf[i]["port_end"] = cgilua.cgi["pft_port_end" .. i]
     end
      end
      -- Save the data
      portforward.write(enabled, portf)
   end
end

-- Read state
submit()
enabled, portf = portforward.read()

-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_lan")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end
    

put(start_of_content)
put('\n')

put('<script type="text/javascript">\n')
put('function upd(form, idx)\n')
put('{\n')
put('   var v1 = +form.elements["pft_port"+idx].value;\n')
put('   var v2 = +form.elements["pft_port_end"+idx].value;\n')
put('   var v3 = +form.elements["pft_destport"+idx].value;\n')
put('   var v4 = v3 + v2-v1;\n')
put('   if (isNaN(v4))\n')
put('       form.elements["pft_destport_end"+idx].value = "";\n')
put('   else\n')
put('       form.elements["pft_destport_end"+idx].value = v3 + v2-v1;\n')
put('   }\n')
put('\n')
put('function checkRange(form,text)\n')
put('{\n')
put('   for (var i = 1;i <= 10; i++)\n')
put('   {\n')
put('       var v1 = +form.elements["pft_port"+i].value;\n')
put(' 		var v2 = +form.elements["pft_port_end"+i].value;\n')
put('       if (isNaN(v2) || v2<v1)\n')
put('     	{\n')
put('           alert(text);\n')
put('           form.elements["pft_port_end"+i].focus();\n')
put('           return false;\n')
put('       }\n')
put('   }\n')
put('   return true;\n')
put('}\n')
put('</script>\n')
   

put('<p id="errortext">' .. error_msg .. '</p>')

range_error = current_dictionary("invalid end port")
put('<form name="portforward" method="post" action="index.lua?pageID=' .. page_title)
put('&langID=' .. lang .. '"  onsubmit=\'return checkRange(this,"'..range_error..'");\'> \n')
put('<table border="'..border_on..'" cellpadding="0" align="left" width="80%">\n')
put('  <tr>\n')
put('    <th align="left" colspan="4">\n')
put('      <p class="menutext">' .. current_dictionary("port forwarding") .. '</p>\n')
put('    </th>\n')
put('    <th align="left" ><p class="menutext"></p></th>\n')
put('    <th align="left" ><p class="menutext"></p></th>\n')
put('    <th align="left" ><p class="menutext"></p></th>\n')
put('  </tr>')
-- Enable / disable portforwarding
put('  <tr>')
--put('    <td align="left"><p>' .. current_dictionary("port forwarding") .. '</p></td>\n')
put('    <td align="left"  colspan="2">\n')
put('      <p>' .. current_dictionary("port forwarding") .. '</p>\n')
put('    </td>\n')
put('    <td align="left"  colspan="2">\n')
put('      <p><input ' .. disabled_string .. ' type="radio" name="pf_onoff" ')
put('          value="enabled" ' .. checked_text(enabled == 1) .. '>' .. current_dictionary("enabled") .. ' <input ' .. disabled_string .. ' type="radio" name="pf_onoff" ')
put('          value="disabled" ' .. checked_text(enabled == 0) .. '>' .. current_dictionary("disabled") .. ' </p>\n')
put('    </td>\n')
put('  </tr>\n')

put('  <tr>\n')
put('    <th align="left" width="10%"><p>' .. current_dictionary("active")           .. '</p></th>\n')
put('    <th align="left" width="25%"><p>' .. current_dictionary("incoming port range")    .. '</p></th>\n')
put('    <th align="left" width="20%"><p>' .. current_dictionary("destination ip")   .. '</p></th>\n')
put('    <th align="left" ><p>' .. current_dictionary("destination port range") .. '</p></th>\n')
put('  </tr>\n')

for index, pft in pairs(portf) do
   transport_end = pft["translatedport"] + pft["port_end"] - pft["port"]
   put('  <tr>\n')
   put('    <td align="left" ><p>\n')
   put('      <input ' .. disabled_string .. ' type="checkbox" name="pft_active' .. index ..'"' .. checked_text(pft["enabled"] ~= 0) .. '>\n')
   put('    </p></td>\n')
   put('    <td align="left" ><p>\n')
   put('      <input ' .. disabled_string .. ' type="text" size="5" name="pft_port' .. index ..'" value="' .. pft["port"] .. '" onchange="upd(this.form,'..index..')">')
   put('      - <input ' .. disabled_string .. ' type="text" size="5" name="pft_port_end' .. index ..'" value="' .. pft["port_end"] .. '" onchange="upd(this.form,'..index..')">')
   
   put('    </p></td>\n')
   put('    <td align="left" ><p>\n')
   put('      <input ' .. disabled_string .. ' type="text" size="15" name="pft_destip' .. index ..'" value="' .. pft["translatedip"] .. '" onchange="upd(this.form,'..index..')">')
   put('    </p></td>\n')
   put('    <td align="left" ><p>\n')
   put('      <input ' .. disabled_string .. ' type="text"size="5"  name="pft_destport' .. index ..'" value="' .. pft["translatedport"] .. '"onchange="upd(this.form,'..index..')">')
   put('      - <input disabled type="text"size="5"  name="pft_destport_end' .. index ..'" value="' .. transport_end .. '">')
   put('    </p></td>\n')
   put('  </tr>\n')
end

--submit button
put('  <tr>\n')
put('    <td align="left" colspan="3">\n')
put('      <p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '"/>\n')
put('        &nbsp;&nbsp;\n')
put('      <input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"/></p>\n')
put('    </td>\n')
put('  </tr>\n')
put('</table>\n')
put('</form>\n')


-- portforward.write(enabled, portf)

put(end_of_content)

