option_text = function (expr)
  if (expr) then
    return '  selected '
  else
    return ''
  end
end

traffic_class_text = function (val)
  if (val == 0) then
    return 'subscribed'
  elseif (val == 1) then
    return 'conversational'
  elseif (val == 2) then
    return 'streaming'
  elseif (val == 3) then
    return 'interactive'
  elseif (val == 4) then
    return 'background'
  else
    return 'unknown'
  end
end

deliver_order_text = function (val)
  if (val == 0) then
    return 'subscribed'
  elseif (val == 1) then
    return 'yes'
  elseif (val == 2) then
    return 'no'
  else
    return 'unknown'
  end
end

error_size_text = function (val)
  if (val == 0) then
    return current_dictionary('subscribed')
  elseif (val == 1) then
    return '1*10(-2)'
  elseif (val == 2) then
    return '7*10(-3)'
  elseif (val == 3) then
    return '1*10(-3)'
  elseif (val == 4) then
    return '1*10(-4)'
  elseif (val == 5) then
    return '1*10(-5)'
  elseif (val == 6) then
    return '1*10(-6)'
  elseif (val == 7) then
    return '1*10(-1)'
  else
    return current_dictionary('unknown')
  end
end

ber_text = function (val)
  if (val == 0) then
    return current_dictionary('subscribed')
  elseif (val == 1) then
    return '5*10(-2)'
  elseif (val == 2) then
    return '1*10(-2)'
  elseif (val == 3) then
    return '5*10(-3)'
  elseif (val == 4) then
    return '4*10(-3)'
  elseif (val == 5) then
    return '1*10(-3)'
  elseif (val == 6) then
    return '1*10(-4)'
  elseif (val == 7) then
    return '1*10(-5)'
  elseif (val == 8) then
    return '1*10(-6)'
  elseif (val == 9) then
    return '6*10(-8)'
  else
    return current_dictionary('unknown')
  end
end

del_err_text = function (val)
  if (val == 0) then
    return 'subscribed'
  elseif (val == 1) then
    return 'no detect'
  elseif (val == 2) then
    return 'yes'
  elseif (val == 3) then
    return 'no'
  else
    return 'unknown'
  end
end

thp_text = function (val)
  if (val == 0) then
    return 'subscribed'
  elseif (val == 1) then
    return 'priority 1'
  elseif (val == 2) then
    return 'priority 2'
  elseif (val == 3) then
    return 'priority 3'
  else
    return 'unknown'
  end
end

validate_input = function (val, limit)
    if val == nil then
        return 0
    elseif val > limit then
        return limit
    else
        return val
    end
end


if cgilua.cgi["traffic_class_1"] ~= nil then
    t_class_1=  tonumber(cgilua.cgi["traffic_class_1"])
    d_order_1=  tonumber(cgilua.cgi["d_order_1"])
    d_sdu_1=    tonumber(cgilua.cgi["delevery_sdu_1"])
    e_size_1=   tonumber(cgilua.cgi["error_size_1"])
    e_ber_1=    tonumber(cgilua.cgi["BER_1"])

    m_bit_ul_1= validate_input(tonumber(cgilua.cgi["m_bit_ul_1"]),8640)
    m_bit_dl_1= validate_input(tonumber(cgilua.cgi["m_bit_dl_1"]),8640)
    g_bit_ul_1= validate_input(tonumber(cgilua.cgi["g_bit_ul_1"]),8640)
    g_bit_dl_1= validate_input(tonumber(cgilua.cgi["g_bit_dl_1"]),8640)
    m_size_1=   validate_input(tonumber(cgilua.cgi["m_size_1"]),1520)
    t_delay_1=  validate_input(tonumber(cgilua.cgi["t_delay_1"]),4000)

    thp_1=   tonumber(cgilua.cgi["thp_1"])

    profiles_if.set_qos_profile(244,t_class_1, m_bit_ul_1, m_bit_dl_1, g_bit_ul_1, g_bit_dl_1, d_order_1, m_size_1, e_size_1,  e_ber_1, d_sdu_1, t_delay_1, thp_1)
end

if cgilua.cgi["traffic_class_2"] ~= nil then
    t_class_2=  tonumber(cgilua.cgi["traffic_class_2"])
    d_order_2=  tonumber(cgilua.cgi["d_order_2"])
    d_sdu_2=    tonumber(cgilua.cgi["delevery_sdu_2"])
    e_size_2=   tonumber(cgilua.cgi["error_size_2"])
    e_ber_2=    tonumber(cgilua.cgi["BER_2"])

    m_bit_ul_2= validate_input(tonumber(cgilua.cgi["m_bit_ul_2"]),8640)
    m_bit_dl_2= validate_input(tonumber(cgilua.cgi["m_bit_dl_2"]),8640)
    g_bit_ul_2= validate_input(tonumber(cgilua.cgi["g_bit_ul_2"]),8640)
    g_bit_dl_2= validate_input(tonumber(cgilua.cgi["g_bit_dl_2"]),8640)
    m_size_2=   validate_input(tonumber(cgilua.cgi["m_size_2"]),1520)
    t_delay_2=  validate_input(tonumber(cgilua.cgi["t_delay_2"]),4000)

    thp_2=   tonumber(cgilua.cgi["thp_2"])

    profiles_if.set_qos_profile(245,t_class_2, m_bit_ul_2, m_bit_dl_2, g_bit_ul_2, g_bit_dl_2, d_order_2, m_size_2, e_size_2,  e_ber_2, d_sdu_2, t_delay_2, thp_2)
end

if cgilua.cgi["traffic_class_3"] ~= nil then
    t_class_3=  tonumber(cgilua.cgi["traffic_class_3"])
    d_order_3=  tonumber(cgilua.cgi["d_order_3"])
    d_sdu_3=    tonumber(cgilua.cgi["delevery_sdu_3"])
    e_size_3=   tonumber(cgilua.cgi["error_size_3"])
    e_ber_3=    tonumber(cgilua.cgi["BER_3"])

    m_bit_ul_3= validate_input(tonumber(cgilua.cgi["m_bit_ul_3"]),8640)
    m_bit_dl_3= validate_input(tonumber(cgilua.cgi["m_bit_dl_3"]),8640)
    g_bit_ul_3= validate_input(tonumber(cgilua.cgi["g_bit_ul_3"]),8640)
    g_bit_dl_3= validate_input(tonumber(cgilua.cgi["g_bit_dl_3"]),8640)
    m_size_3=   validate_input(tonumber(cgilua.cgi["m_size_3"]),1520)
    t_delay_3=  validate_input(tonumber(cgilua.cgi["t_delay_3"]),4000)

    thp_3=   tonumber(cgilua.cgi["thp_3"])

    profiles_if.set_qos_profile(246,t_class_3, m_bit_ul_3, m_bit_dl_3, g_bit_ul_3, g_bit_dl_3, d_order_3, m_size_3, e_size_3,  e_ber_3, d_sdu_3, t_delay_3, thp_3)
end

if cgilua.cgi["text_1"] ~= nil then
    text_1= cgilua.cgi["text_1"]
    profiles_if.set_profile_name(4,text_1)
end 

if cgilua.cgi["text_2"] ~= nil then
    text_2= cgilua.cgi["text_2"]
    profiles_if.set_profile_name(5,text_2)
end 

if cgilua.cgi["text_3"] ~= nil then
    text_3= cgilua.cgi["text_3"]
    profiles_if.set_profile_name(6,text_3)
end 

t_class_d, m_bit_ul_d, m_bit_dl_d, g_bit_ul_d, g_bit_dl_d, d_order_d, m_size_d, e_size_d,  e_ber_d, d_sdu_d, t_delay_d, thp_d = profiles_if.get_qos_profile(240)
t_class_32, m_bit_ul_32, m_bit_dl_32, g_bit_ul_32, g_bit_dl_32, d_order_32, m_size_32, e_size_32,  e_ber_32, d_sdu_32, t_delay_32, thp_32 = profiles_if.get_qos_profile(241)
t_class_64, m_bit_ul_64, m_bit_dl_64, g_bit_ul_64, g_bit_dl_64, d_order_64, m_size_64, e_size_64,  e_ber_64, d_sdu_64, t_delay_64, thp_64 = profiles_if.get_qos_profile(242)
t_class_128, m_bit_ul_128, m_bit_dl_128, g_bit_ul_128, g_bit_dl_128, d_order_128, m_size_128, e_size_128,  e_ber_128, d_sdu_128, t_delay_128, thp_128 = profiles_if.get_qos_profile(243)
t_class_256, m_bit_ul_256, m_bit_dl_256, g_bit_ul_256, g_bit_dl_256, d_order_256, m_size_256, e_size_256,  e_ber_256, d_sdu_256, t_delay_256, thp_256 = profiles_if.get_qos_profile(247)

t_class_1, m_bit_ul_1, m_bit_dl_1, g_bit_ul_1, g_bit_dl_1, d_order_1, m_size_1, e_size_1,  e_ber_1, d_sdu_1, t_delay_1, thp_1 = profiles_if.get_qos_profile(244)
t_class_2, m_bit_ul_2, m_bit_dl_2, g_bit_ul_2, g_bit_dl_2, d_order_2, m_size_2, e_size_2,  e_ber_2, d_sdu_2, t_delay_2, thp_2 = profiles_if.get_qos_profile(245)
t_class_3, m_bit_ul_3, m_bit_dl_3, g_bit_ul_3, g_bit_dl_3, d_order_3, m_size_3, e_size_3,  e_ber_3, d_sdu_3, t_delay_3, thp_3 = profiles_if.get_qos_profile(246)

text_std = profiles_if.get_profile_name(0)
text_32  = profiles_if.get_profile_name(1)
text_64  = profiles_if.get_profile_name(2)
text_128 = profiles_if.get_profile_name(3)
text_1   = profiles_if.get_profile_name(4)
text_2   = profiles_if.get_profile_name(5)
text_3   = profiles_if.get_profile_name(6)
text_256 = profiles_if.get_profile_name(7)
                                          
--Generate html code
put(start_of_content)
    put('<p id="profiles"><table border="'..border_on..'" cellpadding="3" width="85%" >')
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">')
    put('<tr>')
        put('<td align="center" width="18%"></td>')
        put('<th align="center" width="8%"><p>' .. text_std .. '</p></th>')
        put('<th align="center" width="8%"><p>' .. text_32 .. '</p></th>')
        put('<th align="center" width="8%"><p>' .. text_64 .. '</p></th>')
        if streaming ~= "STREAMING_32_64" then
            put('<th align="center" width="8%"><p>' .. text_128 .. '</p></th>')
        end
        if streaming == "STREAMING_32_256" then
            put('<th align="center" width="8%"><p>' .. text_256 .. '</p></th>')
        end
        
        put('<th align="center" width="17%"><p><input type="text" name="text_1" size="14" maxlength="20" value="' .. text_1 .. '"></p></th>')
        put('<th align="center" width="17%"><p><input type="text" name="text_2" size="14" maxlength="20" value="' .. text_2 .. '"></p></th>')
        if streaming ~= "STREAMING_32_256" then
            put('<th align="center" width="17%"><p><input type="text" name="text_3" size="14" maxlength="20" value="' .. text_3 .. '"></p></th>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Traffic class title") .. '" ><p>' .. current_dictionary("traffic class") .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(traffic_class_text(t_class_d)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(traffic_class_text(t_class_32)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(traffic_class_text(t_class_64)) .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. current_dictionary(traffic_class_text(t_class_128)) .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. current_dictionary(traffic_class_text(t_class_256)) .. '</p></td>')
        end
        
        put('<td align="center"><p><select name="traffic_class_1" >')
            for i = 0,4 do put('<option value="' .. i ..'"' .. option_text(t_class_1 == i) .. '>' ..  current_dictionary(traffic_class_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        put('<td align="center"><p><select name="traffic_class_2">')
            for i = 0,4 do put('<option value="' .. i ..'"' .. option_text(t_class_2 == i) .. '>' ..  current_dictionary(traffic_class_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><select name="traffic_class_3">')
                for i = 0,4 do put('<option value="' .. i ..'"' .. option_text(t_class_3 == i) .. '>' ..  current_dictionary(traffic_class_text(i)) .. '</option>\n') end
            put('</select></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Maximum bitrate title") .. '" ><p>' .. current_dictionary("maximum bitrate") .. ' ' .. current_dictionary("ul") .. ' (' .. current_dictionary("kbps") ..')</p></td>')
        put('<td align="center"><p>' .. m_bit_ul_d .. '</p></td>')
        put('<td align="center"><p>' .. m_bit_ul_32 .. '</p></td>')
        put('<td align="center"><p>' .. m_bit_ul_64 .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. m_bit_ul_128 .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. m_bit_ul_256 .. '</p></td>')
        end
        put('<td align="center"><p><input type="text" name="m_bit_ul_1" size="4" maxlength="4" value="' .. m_bit_ul_1 .. '"></p></td>')
        put('<td align="center"><p><input type="text" name="m_bit_ul_2" size="4" maxlength="4" value="' .. m_bit_ul_2 .. '"></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><input type="text" name="m_bit_ul_3" size="4" maxlength="4" value="' .. m_bit_ul_3 .. '"></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Maximum bitrate title") .. '" ><p>' .. current_dictionary("maximum bitrate") .. ' ' .. current_dictionary("dl") .. ' (' .. current_dictionary("kbps") ..')</p></td>')
        put('<td align="center"><p>' .. m_bit_dl_d .. '</p></td>')
        put('<td align="center"><p>' .. m_bit_dl_32 .. '</p></td>')
        put('<td align="center"><p>' .. m_bit_dl_64 .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. m_bit_dl_128 .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. m_bit_dl_256 .. '</p></td>')
        end
        put('<td align="center"><p><input type="text" name="m_bit_dl_1" size="4" maxlength="4" value="' .. m_bit_dl_1 .. '"></p></td>')
        put('<td align="center"><p><input type="text" name="m_bit_dl_2" size="4" maxlength="4" value="' .. m_bit_dl_2 .. '"></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><input type="text" name="m_bit_dl_3" size="4" maxlength="4" value="' .. m_bit_dl_3 .. '"></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Guaranteed bitrate title") .. '" ><p>' .. current_dictionary("guaranteed bitrate") .. ' ' .. current_dictionary("ul") .. ' (' .. current_dictionary("kbps") ..')</p></td>')
        put('<td align="center"><p>' .. g_bit_ul_d .. '</p></td>')
        put('<td align="center"><p>' .. g_bit_ul_32 .. '</p></td>')
        put('<td align="center"><p>' .. g_bit_ul_64 .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. g_bit_ul_128 .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. g_bit_ul_256 .. '</p></td>')
        end
        put('<td align="center"><p><input type="text" name="g_bit_ul_1" size="4" maxlength="4" value="' .. g_bit_ul_1 .. '"></p></td>')
        put('<td align="center"><p><input type="text" name="g_bit_ul_2" size="4" maxlength="4" value="' .. g_bit_ul_2 .. '"></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><input type="text" name="g_bit_ul_3" size="4" maxlength="4" value="' .. g_bit_ul_3 .. '"></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Guaranteed bitrate title") .. '" ><p>' .. current_dictionary("guaranteed bitrate")  .. ' ' .. current_dictionary("dl") .. ' (' .. current_dictionary("kbps") ..')</p></td>')
        put('<td align="center"><p>' .. g_bit_dl_d .. '</p></td>')
        put('<td align="center"><p>' .. g_bit_dl_32 .. '</p></td>')
        put('<td align="center"><p>' .. g_bit_dl_64 .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. g_bit_dl_128 .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. g_bit_dl_256 .. '</p></td>')
        end
        put('<td align="center"><p><input type="text" name="g_bit_dl_1" size="4" maxlength="4" value="' .. g_bit_dl_1 .. '"></p></td>')
        put('<td align="center"><p><input type="text" name="g_bit_dl_2" size="4" maxlength="4" value="' .. g_bit_dl_2 .. '"></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><input type="text" name="g_bit_dl_3" size="4" maxlength="4" value="' .. g_bit_dl_3 .. '"></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Delivery order title") .. '" ><p>' .. current_dictionary("delivery order") .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(deliver_order_text(d_order_d)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(deliver_order_text(d_order_32)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(deliver_order_text(d_order_64)) .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. current_dictionary(deliver_order_text(d_order_128)) .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. current_dictionary(deliver_order_text(d_order_256)) .. '</p></td>')
        end
        put('<td align="center"><p><select name="d_order_1">')
            for i = 0,2 do put('<option value="' .. i ..'"' .. option_text(d_order_1 == i) .. '>' ..  current_dictionary(deliver_order_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        put('<td align="center"><p><select name="d_order_2">')
            for i = 0,2 do put('<option value="' .. i ..'"' .. option_text(d_order_2 == i) .. '>' ..  current_dictionary(deliver_order_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><select name="d_order_3">')
                for i = 0,2 do put('<option value="' .. i ..'"' .. option_text(d_order_3 == i) .. '>' ..  current_dictionary(deliver_order_text(i)) .. '</option>\n') end
            put('</select></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Maximum SDU title") .. '" ><p>' .. current_dictionary("maximum SDU size") .. ' (' .. current_dictionary("byte") ..')</p></td>')
        put('<td align="center"><p>' .. m_size_d .. '</p></td>')
        put('<td align="center"><p>' .. m_size_32 .. '</p></td>')
        put('<td align="center"><p>' .. m_size_64 .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. m_size_128 .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. m_size_256 .. '</p></td>')
        end        
        put('<td align="center"><p><input type="text" name="m_size_1" size="4" maxlength="4" value="' .. m_size_1 .. '" ></p></td>')
        put('<td align="center"><p><input type="text" name="m_size_2" size="4" maxlength="4" value="' .. m_size_2 .. '" ></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><input type="text" name="m_size_3" size="4" maxlength="4" value="' .. m_size_3 .. '" ></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("SDU error title") .. '" ><p>' .. current_dictionary("SDU error ratio")  .. '</p></td>')
        put('<td align="center"><p>' .. error_size_text(e_size_d) .. '</p></td>')
        put('<td align="center"><p>' .. error_size_text(e_size_32) .. '</p></td>')
        put('<td align="center"><p>' .. error_size_text(e_size_64) .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. error_size_text(e_size_128) .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. error_size_text(e_size_256) .. '</p></td>')
        end    
        put('<td align="center"><p><select name="error_size_1">')
            for i = 0,7 do put('<option value="' .. i ..'"' .. option_text(e_size_1 == i) .. '>' .. error_size_text(i) .. '</option>\n') end
        put('</select></p></td>')
        put('<td align="center"><p><select name="error_size_2">')
            for i = 0,7 do put('<option value="' .. i ..'"' .. option_text(e_size_2 == i) .. '>' .. error_size_text(i) .. '</option>\n') end
        put('</select></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><select name="error_size_3">')
                for i = 0,7 do put('<option value="' .. i ..'"' .. option_text(e_size_3 == i) .. '>' .. error_size_text(i) .. '</option>\n') end
            put('</select></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Residual error title") .. '" ><p>' .. current_dictionary("residual bit error ratio")  .. '</p></td>')
        put('<td align="center"><p>' .. ber_text(e_ber_d) .. '</p></td>')
        put('<td align="center"><p>' .. ber_text(e_ber_32) .. '</p></td>')
        put('<td align="center"><p>' .. ber_text(e_ber_64) .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. ber_text(e_ber_128) .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. ber_text(e_ber_256) .. '</p></td>')
        end       
        put('<td align="center"><p><select name="BER_1">')
            for i = 0,9 do put('<option value="' .. i ..'"' .. option_text(e_ber_1 == i) .. '>' .. ber_text(i) .. '</option>\n') end
        put('</select></p></td>')
        put('<td align="center"><p><select name="BER_2">')
            for i = 0,9 do put('<option value="' .. i ..'"' .. option_text(e_ber_2 == i) .. '>' .. ber_text(i) .. '</option>\n') end
        put('</select></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><select name="BER_3">')
                for i = 0,9 do put('<option value="' .. i ..'"' .. option_text(e_ber_3 == i) .. '>' .. ber_text(i) .. '</option>\n') end
            put('</select></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Delivery erroneous title") .. '" ><p>' .. current_dictionary("delivery of erroneous SDUs") .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(del_err_text(d_sdu_d)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(del_err_text(d_sdu_32)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(del_err_text(d_sdu_64)) .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. current_dictionary(del_err_text(d_sdu_128)) .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. current_dictionary(del_err_text(d_sdu_256)) .. '</p></td>')
        end
        put('<td align="center"><p><select name="delevery_sdu_1">')
            for i = 0,3 do put('<option value="' .. i ..'"' .. option_text(d_sdu_1 == i) .. '>' .. current_dictionary(del_err_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        put('<td align="center"><p><select name="delevery_sdu_2">')
            for i = 0,3 do put('<option value="' .. i ..'"' .. option_text(d_sdu_2 == i) .. '>' .. current_dictionary(del_err_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><select name="delevery_sdu_3">')
                for i = 0,3 do put('<option value="' .. i ..'"' .. option_text(d_sdu_3 == i) .. '>' .. current_dictionary(del_err_text(i)) .. '</option>\n') end
            put('</select></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("Transfer delay title") .. '" ><p>' .. current_dictionary("transfer delay") ..'</p></td>')
        put('<td align="center"><p>' .. t_delay_d .. '</p></td>')
        put('<td align="center"><p>' .. t_delay_32 .. '</p></td>')
        put('<td align="center"><p>' .. t_delay_64 .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. t_delay_128 .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. t_delay_256 .. '</p></td>')
        end
        put('<td align="center"><p><input type="text" name="t_delay_1" size="4" maxlength="4" value="' .. t_delay_1 .. '"></p></td>')
        put('<td align="center"><p><input type="text" name="t_delay_2" size="4" maxlength="4" value="' .. t_delay_2 .. '"></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><input type="text" name="t_delay_3" size="4" maxlength="4" value="' .. t_delay_3 .. '"></p></td>')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left" title="' .. current_dictionary("THP title") .. '" ><p>' .. current_dictionary("traffic handling priority")  .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(thp_text(thp_d)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(thp_text(thp_32)) .. '</p></td>')
        put('<td align="center"><p>' .. current_dictionary(thp_text(thp_64)) .. '</p></td>')
        if streaming ~= "STREAMING_32_64" then
            put('<td align="center"><p>' .. current_dictionary(thp_text(thp_128)) .. '</p></td>')
        end
        if streaming == "STREAMING_32_256" then
            put('<td align="center"><p>' .. current_dictionary(thp_text(thp_256)) .. '</p></td>')
        end
        put('<td align="center"><p><select name="thp_1">')
            for i = 0,3 do put('<option value="' .. i ..'"' .. option_text(thp_1 == i) .. '>' .. current_dictionary(thp_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        put('<td align="center"><p><select name="thp_2">')
            for i = 0,3 do put('<option value="' .. i ..'"' .. option_text(thp_2 == i) .. '>' .. current_dictionary(thp_text(i)) .. '</option>\n') end
        put('</select></p></td>')
        if streaming ~= "STREAMING_32_256" then
            put('<td align="center"><p><select name="thp_3">')
                for i = 0,3 do put('<option value="' .. i ..'"' .. option_text(thp_3 == i) .. '>' .. current_dictionary(thp_text(i)) .. '</option>\n') end
            put('</select></p></td>')
        end
    put('</tr>')
    put('<tr>')
    put('</tr>')
    put('<tr>')
    put('<td align="left" colspan=4><input type="submit" value="' .. current_dictionary("apply") .. '">')
    put('&nbsp;&nbsp;<input type="reset" value="' .. current_dictionary("cancel") .. '"></td>\n')
    put('</tr></form>')
    put('</table></p>')

put(end_of_content)
