if product == "SBL" then
    require "sat_select"
else
    hasPanel = TT_TRUE
    if product == "EBDU" or product == "E727" or product == "E723" or product == "SBDU" or product == "S500" or product == "S250" or product == "SBL" then
        hasPanel = TT_FALSE
    end
    
    -- Parse incomming parameters
    put('\n')
    
    if hasPanel == TT_TRUE then
        if cgilua.cgi["point_req"] ~= nil then
          pointing = tonumber(cgilua.cgi["point_req"])
          settings_if.set_power_on_pointing(pointing);
        end
        
        if cgilua.cgi["power_con"] ~= nil then
          power = tonumber(cgilua.cgi["power_con"])
          settings_if.set_power_on_dc(power);
        end
        backlight_timeout=30
        backlight_level=4
        if cgilua.cgi["backlight_timeout"] ~= nil then
          bl_time = tonumber(cgilua.cgi["backlight_timeout"])
          bl_level = tonumber(cgilua.cgi["backlight_level"])
          if bl_time == 0 then
            -- set some standard value.
            bl_time = 5 
            bl_mode = 1
          elseif bl_time == 1 then
            bl_time = 5
            bl_mode = 2
          else
            bl_mode = 0 
          end
          settings_if.set_backlight(bl_mode, bl_time, bl_level)
        end
        
        if cgilua.cgi["contrast_auto"] ~= nil then
          contrast_auto = tonumber(cgilua.cgi["contrast_auto"])
          contrast_level = tonumber(cgilua.cgi["contrast_level"])
          settings_if.set_contrast(contrast_auto, contrast_level)
        end
        
        if cgilua.cgi["audio_message"] ~= nil then
          if cgilua.cgi["audio_point"] ~= nil then
            audio_point   = tonumber(cgilua.cgi["audio_point"])
          else
            audio_point   = 1
          end 
          audio_message = tonumber(cgilua.cgi["audio_message"])
          audio_alarm   = tonumber(cgilua.cgi["audio_alarm"])
          settings_if.set_audio_settings(audio_point, audio_message, audio_alarm)
        end
        
        if cgilua.cgi["stealth_mode"] ~= nil then
          stealth_mode = tonumber(cgilua.cgi["stealth_mode"])
          settings_if.set_stealthmode(stealth_mode)
        end
        
        pointing = settings_if.get_power_on_pointing()
        power_on_dc = settings_if.get_power_on_dc()
        bl_mode, bl_time, bl_level = settings_if.get_backlight()
        contrast_auto, contrast_level = settings_if.get_contrast()
        audio_point, audio_message, audio_alarm = settings_if.get_audio_settings()
        stealth_mode = settings_if.get_stealthmode()
    else
        if cgilua.cgi["chart_co_con"] ~= nil then
          chart_co_con = tonumber(cgilua.cgi["chart_co_con"])
          msg_if.lua_set_chart_co_status(chart_co_con)
        end
        chart_co_con = msg_if.lua_get_chart_co_status()
    end
    
    -- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_general")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end
    
    ant_ser, ant_sw_boot_major, ant_sw_boot_minor, ant_sw_major, ant_sw_minor = msg_if.lua_get_ant_info()
    
    put(start_of_content)
    put('<p id="errortext">' .. error_msg .. '</p>')
    
    
    put('<p><table align="left" border="'..border_on..'" cellpadding="0" width="70%">\n')
    
    put('<form name="main_settings" method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">\n')
    
    if hasPanel == TT_TRUE then
        put('<tr>')
            put('<td align="left" width="30%"></td>')
            put('<td align="left" width="12%"></td>')
            put('<td align="left" width="12%"></td>')
            put('<td align="left" width="65%"></td>')
        put('</tr>')
        if product ~= "E527" or hasManualPointing == TT_TRUE then
            put('<tr>')
                put('<th align="left"><p class="menutext">' ..current_dictionary("power up").. '</p></th>')
            put('</tr>')
            if hasManualPointing == TT_TRUE then
                put('<tr>')
                    put('<td align="left" colspan="4"><p>' ..current_dictionary("pointing required at power up")..'&nbsp;')
                    put('<input ' .. disabled_string .. ' type="radio" name="point_req" value="0"' .. checked_text(not pointing) .. '>' .. current_dictionary("yes"))
                    put('<input ' .. disabled_string .. ' type="radio" name="point_req" value="1"' .. checked_text(pointing) .. '>'  .. current_dictionary("no") .. '</p></td>\n')
                put('</tr>')
            end
            if product ~= "E527" then
                put('<tr>')
                    put('<td align="left" colspan="4"><p>' ..current_dictionary("the terminal will switch on ") .. current_dictionary("when external power is connected").. '&nbsp;')
                    put('<input ' .. disabled_string .. ' type="radio" name="power_con" value="1"' .. checked_text(power_on_dc) .. '>' .. current_dictionary("yes"))
                    put('<input ' .. disabled_string .. ' type="radio" name="power_con" value="0"' .. checked_text(not power_on_dc) .. '>'  .. current_dictionary("no")  .. '</p></td>')
                put('</tr>')
            end
        end
        put('<tr>')
            put('<th align="left"><p class="menutext">' ..current_dictionary("backlight").. '</p></th>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("timed") .. '</p></td>')
            put('<td align="left" colspan="3"><p><select ' .. disabled_string .. ' name="backlight_timeout">')
                put('<option value="2"' .. option_text(bl_time == 2 and bl_mode == 0) .. '>2 ' .. current_dictionary("seconds") .. '</option>\n')
                put('<option value="5"' .. option_text(bl_time == 5 and bl_mode == 0) .. '>5 ' .. current_dictionary("seconds") .. '</option>\n')
                put('<option value="10"' .. option_text(bl_time == 10 and bl_mode == 0) .. '>10 ' .. current_dictionary("seconds") .. '</option>\n')
                put('<option value="30"' .. option_text(bl_time == 30 and bl_mode == 0) .. '>30 ' .. current_dictionary("seconds") .. '</option>\n')
                put('<option value="60"' .. option_text(bl_time == 60 and bl_mode == 0) .. '>60 ' .. current_dictionary("seconds") .. '</option>\n')
                put('<option value="0"' .. option_text(bl_mode == 1) .. '>' ..current_dictionary("always on") .. '</option>\n')
                put('<option value="1"' .. option_text(bl_mode == 2) .. '>' ..current_dictionary("always off") .. '</option>\n')
            put('</select></p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("set level") .. '</p></td>')
            put('<td align="left"><p><select ' .. disabled_string .. ' name="backlight_level">')
            for i = 0,6 do 
                put('<option value="' .. i .. '"' .. option_text(bl_level == i) .. '>' .. i+1 .. '</option>\n')
            end
            put('</select></p></td>\n')
        put('</tr>')
    
        put('<!-- contrast_auto:' .. tostring(contrast_auto) .. ' contrast_level: ' .. contrast_level .. ' -->\n');
        put('<tr>')
            put('<th align="left"><p class="menutext">' ..current_dictionary("contrast").. '</p></th>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("automatic contrast") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="contrast_auto" value="1"' .. checked_text(contrast_auto) .. '>' .. current_dictionary("yes") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="contrast_auto" value="0"' .. checked_text(not contrast_auto) .. '>' .. current_dictionary("no") .. '</p></td>\n')
        put('</tr>')
    
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("set level") .. '</p></td>')
            put('<td align="left"><p><select ' .. disabled_string .. ' name="contrast_level">')
            for i = 0,6 do 
                put('<option value="' .. i .. '" ' .. option_text(contrast_level == i) .. '>' .. i+1 .. '</option>\n')
            end
            put('</select></p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("audio indicators").. '</p></th>')
        put('</tr>')
        if hasManualPointing == TT_TRUE then
            put('<tr>')
                put('<td align="left"><p>' ..current_dictionary("pointing") .. '</p></td>')
                put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="audio_point" value="1"' .. checked_text(audio_point) .. '>' .. current_dictionary("on") .. '</p></td>')
                put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="audio_point" value="0"' .. checked_text(not audio_point) .. '>' .. current_dictionary("off") .. '</p></td>\n')
            put('</tr>')
        end
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("messages") .. '</p></td>\n')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="audio_message" value="1"' .. checked_text(audio_message) .. '>' .. current_dictionary("on").. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="audio_message" value="0"' .. checked_text(not audio_message) .. '>' .. current_dictionary("off") .. '</p></td>\n')
        put('</tr>')
        put('<tr>\n')
            put('<td align="left"><p>' ..current_dictionary("alarm") .. ' </p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="audio_alarm" value="1"' .. checked_text(audio_alarm) .. '>' .. current_dictionary("on").. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="audio_alarm" value="0"' .. checked_text(not audio_alarm) .. '>' .. current_dictionary("off") .. '</p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<th align="left"><p class="menutext">' ..current_dictionary("stealth mode").. '</p></th>')
        put('</tr>')
        put('<tr>\n')
            put('<td align="left"><p>' ..current_dictionary("stealth") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="stealth_mode" value="1"' .. checked_text(stealth_mode) .. '>' .. current_dictionary("enable") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="stealth_mode" value="0"' .. checked_text(not stealth_mode) .. '>' .. current_dictionary("disable") .. '</p></td>\n')
        put('</tr>')
    else
        put('<tr>')
            put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("antenna").. '</p></th>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("antenna bootloader version")..':')
            put('<td align="left" colspan="2"><p>' .. ant_sw_boot_major .. '.' .. ant_sw_boot_minor .. '</p></td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("antenna software version")..':')
            put('<td align="left" colspan="2"><p>' .. ant_sw_major .. '.' .. ant_sw_minor .. '</p></td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("antenna serial number")..':')
            put('<td align="left" colspan="2"><p>' .. ant_ser .. '</p></td>')
        put('</tr>')
        if (product ~= "SBL") then
        	put('<tr>')
            	put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("l-band connector") .. '</p></th>')
        	put('</tr>')
        	put('<tr>')
            	put('<td align="left"><p>' ..current_dictionary("l-band connector") .. '</p></td>')
            	put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="chart_co_con" value="1"' .. checked_text(chart_co_con) .. '>' .. current_dictionary("enable") .. '</p></td>')
            	put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="chart_co_con" value="0"' .. checked_text(not chart_co_con) .. '>' .. current_dictionary("disable") .. '</p></td>\n')
        	put('</tr>')
        end
    end
    
    put('<tr>\n')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>')
    
    put('</form>\n') 
    
    put('</table></p>\n')
    
    put(end_of_content)
end
