time_format = function(duration)
    -- duration in seconds
    h = 0
    m = 0
    s = 0
    d = 0
    s  = math.mod(duration, 60)
    m  = (math.mod(duration, 3600) - s)/60
    h = math.mod((duration - m*60 - s)/3600,24)
    d = (duration - h*3600 - m*60 - s)/(3600*24)
    d_str = current_dictionary("short_days")
    h_str = current_dictionary("short_hours")
    m_str = current_dictionary("short_minutes")
    s_str = current_dictionary("short_seconds")
    if d > 0 then
        timestr = string.format("%d"..d_str.." %d"..h_str.." %d"..m_str.." %d"..s_str, d, h, m, s)
    elseif h>0 then
        timestr = string.format("%d"..h_str.." %d"..m_str.." %d"..s_str, h, m, s)
    elseif m>0 then
        timestr = string.format("%d"..m_str.." %d"..s_str, m, s)
    else
        timestr = string.format("%d"..s_str, s)
    end
    return timestr  
end


has_access, penalty_time = msg_if.lua_get_simlock_penalty_time()

--if cgilua.cgi["acc"] ~= "1" then
--    has_access = false
--end

-- Parse incomming parameters
if not has_access then
    if penalty_time > 0 then
        error_msg = current_dictionary("time remaining") .. time_format(penalty_time);
    elseif cgilua.cgi["code"] ~= nil then
        has_access, bootldr, penalty_time = msg_if.lua_simlock_is_code_valid(cgilua.cgi["code"])
        -- bootldr value only valid if has_access is false and there are no penalty time
        if not has_access then
            if not bootldr then
                error_msg = current_dictionary("bootloader too old")
            else
                error_msg = current_dictionary("invalid sim lock code.") .. current_dictionary("time remaining") .. time_format(penalty_time*60);
            end
        else
            cur_lock, cur_val1, cur_val2 = msg_if.lua_get_simlock()
        end
    end
else
    -- logged in        
    err = 0
    if cgilua.cgi["lock"] ~= nil then
        lock = tonumber(cgilua.cgi["lock"])
        cur_lock = lock
        if lock == 3 then
            val1 = cgilua.cgi["imsi_val"]
        elseif lock == 4 then
            val1 = cgilua.cgi["dp_val"]
        elseif lock == 5 then
            val1 = cgilua.cgi["isp_val1"]
            val2 = cgilua.cgi["isp_val2"]
        end

        err = msg_if.lua_set_simlock(lock,val1,val2)

        cur_lock = lock
        cur_val1 = val1
        cur_val2 = val2

        if err == 1 then
            error_msg = current_dictionary("unable to change simlock")
        elseif err == 2 then
            error_msg = current_dictionary("invalid imsi")
        elseif err == 3 then
            error_msg = current_dictionary("invalid dp code")
        elseif err == 4 then
            error_msg = current_dictionary("invalid isp code")
        elseif err == 5 then
            error_msg = current_dictionary("unable to read values from sim")
        elseif err == 6 then
            error_msg = current_dictionary("no dp on sim")
        elseif err == 7 then
            error_msg = current_dictionary("no isp on sim")
        end
    end
    
    cur_lock, cur_val1, cur_val2 = msg_if.lua_get_simlock()
end

put('\n')
put(start_of_content)
put('<p><table align="left" border="'..border_on..'" cellpadding="0">\n')
put('<form name="sim_lock" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
put('<tr><td colspan="2"><p id="errortext">'..error_msg..'</p></td></tr>')

if not has_access then
    -- not logged in
    if penalty_time > 0 then
        -- in penalty time, only show refresh
        put('<tr></tr>')
        put('<tr>')
        put('<td align="left"><p><input type="submit" value="' .. current_dictionary("refresh") .. '"></td>\n')
        put('</tr>')
    else 
        -- login
        put('<tr></tr>')
        put('<tr>')
        put('<td align="left"><p>'..current_dictionary("enter sim lock code")..'</p></td>')
        put('<td align="left"><p><input type="text" name="code" maxlength="32" size="42"></p>')
        put('</td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p><INPUT type="submit" name="validate" value="' .. current_dictionary("apply") .. '">')
            put('&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
        put('</tr>')
    end
else
    imsi_str = ""
    dp_str = ""
    isp_str1 = ""
    isp_str2 = ""
    if cur_lock == 3 then
        imsi_str = string.upper(cur_val1)
    elseif cur_lock == 4 then
        dp_str =  string.upper(cur_val1)
    elseif cur_lock == 5 then
        isp_str1 =  string.upper(cur_val1)
        isp_str2 =  string.upper(cur_val2)
    end

    put('<tr>')
        put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("sim lock").. '</p>')
        put('</th>')
    put('</tr>')
    
    if usim_string == "USIM_STATUS_OK" then
        put('<tr>')
            put('<td align="left"><p><input type="radio" name="lock" value="0"' .. checked_text(cur_lock == 0) .. ' >&nbsp;' ..current_dictionary("lock to sim inserted")..'</p></td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p><input type="radio" name="lock" value="1"' .. checked_text(cur_lock == 1) .. ' >&nbsp;' ..current_dictionary("lock to dp code of sim inserted")..'</p></td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p><input type="radio" name="lock" value="2"' .. checked_text(cur_lock == 2) .. ' >&nbsp;' ..current_dictionary("lock to isp code of sim inserted")..'</p></td>')
        put('</tr>')
    end
    put('<tr>')
        put('<td align="left"><p><input type="radio" name="lock" value="3"' .. checked_text(cur_lock == 3) .. ' >&nbsp;' ..current_dictionary("lock to sim")..'</p></td>')
        put('<td align="left"><p>'..current_dictionary("imsi")..'&nbsp;<input type="text" name="imsi_val" maxlength="15" size="20" value="'..imsi_str..'"></p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input type="radio" name="lock" value="4"' .. checked_text(cur_lock == 4) .. ' >&nbsp;' ..current_dictionary("lock to dp")..'</p></td>')
        put('<td align="left"><p>'..current_dictionary("dp code")..'&nbsp;<input type="text" name="dp_val" maxlength="4" size="4" value="'..dp_str..'"></p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input type="radio" name="lock" value="5"' .. checked_text(cur_lock == 5) .. ' >&nbsp;' ..current_dictionary("lock to isp")..'</p></td>')
        put('<td align="left"><p>'..current_dictionary("dp code")..'&nbsp;<input type="text" name="isp_val1" maxlength="4" size="4" value="'..isp_str1..'">&nbsp;&nbsp;'..current_dictionary("isp code")..'&nbsp;<input type="text" name="isp_val2" maxlength="4" size="4" value="'..isp_str2..'"></p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input type="radio" name="lock" value="6"' .. checked_text(cur_lock == 6) .. ' >&nbsp;' ..current_dictionary("unlock")..'</p></td>')
    put('</tr>')
            
    put('<tr>\n')
        put('<td align="left">')
--        put('<input type="hidden" name="acc" value="1">')
        put('<p><INPUT type="submit" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>')
end
put('</form>\n') 
put('</table></p>\n')
put(end_of_content)

