url = require("socket.url")

sms_used_slots, sms_max_slots, sc_addr = msg_if.lua_max_info()
--sms_max_slots = 25

sms_entries = {}
inbox_entries = {}
outbox_entries = {}
new_entries = {}

function html_escape(str)
    str1 = string.gsub(str,"&","&amp;")
    str2 = string.gsub(str1,"<","&lt;")
    str3 = string.gsub(str2,">","&gt;")
    str4 = string.gsub(str3,"\r\n","<br>")
    str5 = string.gsub(str4,"\r","<br>")
    str6 = string.gsub(str5,"\n","<br>")
    return str6
end 

function sms_report_text(val)
    if val == 1 then
        return current_dictionary('sms status failed')
    elseif val == 2 then
        return current_dictionary('sms status delivered')
    elseif val == 3 then
        return current_dictionary('sms status attempting')
    else
        return current_dictionary('unknown')
    end
end

error_msg = "";
sms_ok = "true"

--Parse URL 
if cgilua.cgi["smsOP"] ~= nil then
    if cgilua.cgi["smsOP"] == "delete" then
        --Delete entry at "entryNU"
        --print('delete')
        if cgilua.cgi["entryNU"] ~= nil then
            trace(0, 1, string.format("Delete arg: %d", cgilua.cgi["entryNU"]))
            --print('arg: ' .. cgilua.cgi["entryNU"])
            --Checking for multipart
            for i = 0,(sms_max_slots-1) do
                sms_index, sms_status, sms_time, sms_date, sms_number, sms, sms_total_number, sms_sequence_number, sms_reference_number, sms_primary, sms_report = msg_if.lua_read_sms(i,0)
                --if i < 10 then
                --    trace(0, 1, string.format("Index(%d): %d",i , sms_index))
                --end
                --print('sms (total,sequence,reference,primary): (' .. sms_total_number .. ',' .. sms_sequence_number .. ',' .. sms_reference_number .. ',' .. sms_primary .. ')')
                table.insert(sms_entries,{sms_index = sms_index, sms_number = sms_number,sms_time = sms_time,sms_date = sms_date,sms = sms,sms_total_number = sms_total_number,sms_sequence_number = sms_sequence_number,sms_reference_number = sms_reference_number,sms_primary = sms_primary})
            end
            --print('loaded sms table: ' .. sms_max_slots)
            reference_number = 0
            --trace(0, 1, string.format("Index(1): %d", sms_entries[1].sms_index))
            --trace(0, 1, string.format("Index(4): %d", sms_entries[4].sms_index))
            for i = 1,table.getn(sms_entries) do                
                if sms_entries[i].sms_index == tonumber(cgilua.cgi["entryNU"]) then
                    trace(0, 1, string.format("Found main entry: %d", cgilua.cgi["entryNU"]))
                    --print('found main entry: ' .. cgilua.cgi["entryNU"])
                    if  sms_entries[i].sms_total_number >= 2 then
                        --multipart
                        print('multipart, deleting entry: ' .. tonumber(cgilua.cgi["entryNU"]))
                        reference_number = sms_entries[i].sms_reference_number
                        --print('reference number: ' .. reference_number)
                        trace(0, 1, string.format("multipart, reference number:  %d", reference_number))
                        msg_if.lua_delete_sms(tonumber(cgilua.cgi["entryNU"]))
                        for j = 1,table.getn(sms_entries) do
                            --print('i: ' .. i .. ', j: ' .. j .. ',sms_entries[j].sms_reference_number: ' .. sms_entries[j].sms_reference_number )
                            if i ~= j and sms_entries[j].sms_reference_number == reference_number then
                                print('deleting non primary sms') 
                                msg_if.lua_delete_sms(sms_entries[j].sms_index)    
                            end
                        end
                      else
                        --not multipart
                        trace(0, 1, string.format("Not multipart, deleting entry: %d", cgilua.cgi["entryNU"]))
                        --print('not multipart, deleting entry: ' .. cgilua.cgi["entryNU"])
                        msg_if.lua_delete_sms(tonumber(cgilua.cgi["entryNU"]))
                    end
                end
            end
        end
        --print('end of delete')
    elseif cgilua.cgi["smsOP"] == "move" then
        if cgilua.cgi["entryNU"] ~= nil then
            msg_if.lua_clear_unread_sms(cgilua.cgi["entryNU"])
        end
    elseif cgilua.cgi["smsOP"] == "reset" then
        --Set content of inbox/outbox/sent to default
        if page_title == "Messages" then
            msg_if.lua_delete_all_sms(2)
        elseif page_title == "Inbox" then
            msg_if.lua_delete_all_sms(1)
        elseif page_title == "Outbox" then
            msg_if.lua_delete_all_sms(8)
        elseif page_title == "Sent" then
            msg_if.lua_delete_all_sms(4)
        end
    elseif cgilua.cgi["smsOP"] == "moveall" then
        --mark all sms as read
        for i = 0,(sms_max_slots-1) do
            msg_if.lua_read_sms(i,1)
        end
    elseif cgilua.cgi["smsOP"] == "send" then
        sms_ok = "false"
        if not check_simple_number(cgilua.cgi["smsrec"]) then
            error_msg = current_dictionary("only 0-9, + and spaces are allowed in phone numbers");
        else
            sms_ok = "true" 
        end
        if cgilua.cgi["newsms"] == "" then
            error_msg = current_dictionary("no message to send");
            sms_ok = "false"
        end        
        if cgilua.cgi["smsrec"] == "" or string.gsub(cgilua.cgi["smsrec"],"[+*# ]","") == "" then
            error_msg = current_dictionary("please enter a phone number");
            sms_ok = "false"
        end
        if sms_ok == "true" then
            notification = "false"
            if cgilua.cgi["del_not"] == "a" then
                notification = "true"
            end
            if cgilua.cgi["newsms"] ~= nil and cgilua.cgi["smsrec"] ~= nil then
                msg_if.lua_send_sms(cgilua.cgi["newsms"],strip_spaces(cgilua.cgi["smsrec"]),notification) 
            end        
       
        end
    end
end

sms_entries = {}

if page_title ~= "Write message" then
    --print('Debug print of sms entries before any operations:')
    for i = 0,(sms_max_slots-1) do
        sms_index, sms_status, sms_time, sms_date, sms_number, sms, sms_total_number, sms_sequence_number, sms_reference_number, sms_primary, sms_report = msg_if.lua_read_sms(i,0)
        --print('i: ' .. i .. ', index: ' ..sms_index .. ',primary: ' .. sms_primary .. ',text: ' .. sms )
        --print('sms (total,sequence,reference,primary): (' .. sms_total_number .. ',' .. sms_sequence_number .. ',' .. sms_reference_number .. ',' .. sms_primary .. ')')
        if page_title == "Messages" and sms_status == "unread" then
            table.insert(sms_entries,{sms_index = sms_index, sms_number = sms_number,sms_time = sms_time,sms_date = sms_date,sms = sms,sms_total_number = sms_total_number,sms_sequence_number = sms_sequence_number,sms_reference_number = sms_reference_number,sms_primary = sms_primary, sms_report = sms_report})
        elseif page_title == "Inbox" and sms_status == "read" then
            table.insert(sms_entries,{sms_index = sms_index, sms_number = sms_number,sms_time = sms_time,sms_date = sms_date,sms = sms,sms_total_number = sms_total_number,sms_sequence_number = sms_sequence_number,sms_reference_number = sms_reference_number,sms_primary = sms_primary, sms_report = sms_report})
        elseif page_title == "Outbox" and sms_status == "unsent" then
            table.insert(sms_entries,{sms_index = sms_index, sms_number = sms_number,sms_time = sms_time,sms_date = sms_date,sms = sms,sms_total_number = sms_total_number,sms_sequence_number = sms_sequence_number,sms_reference_number = sms_reference_number,sms_primary = sms_primary, sms_report = sms_report})
        elseif page_title == "Sent" and sms_status == "sent" then
            table.insert(sms_entries,{sms_index = sms_index, sms_number = sms_number,sms_time = sms_time,sms_date = sms_date,sms = sms,sms_total_number = sms_total_number,sms_sequence_number = sms_sequence_number,sms_reference_number = sms_reference_number,sms_primary = sms_primary, sms_report = sms_report})
        end
    end
    --print('Debug print of sms entries before any operations:')
    --for i = 1,table.getn(sms_entries) do
    --    print('i: ' .. i .. ', index: ' ..sms_entries[i].sms_index .. ',primary: ' .. sms_entries[i].sms_primary .. ',text: ' .. sms_entries[i].sms )
    --end

    large_sms = ""
    for i = 1,table.getn(sms_entries) do
        --print('i: ' .. i .. ',total: ' .. sms_entries[i].sms_total_number .. ',primary: ' .. sms_entries[i].sms_primary)
        if sms_entries[i].sms_total_number >= 2 and sms_entries[i].sms_primary == "primary" then
            for j = 2, sms_entries[i].sms_total_number do
                --print('j: ' .. j)           
                for m = 1,table.getn(sms_entries) do
                    --print('m: '.. m)
                    if sms_entries[m].sms_sequence_number == j and  sms_entries[m].sms_reference_number == sms_entries[i].sms_reference_number then
                        large_sms = sms_entries[i].sms .. sms_entries[m].sms
                        sms_entries[i].sms = large_sms
                    end
                end
            end 
         end
    end
end

if debug == "yes" then 
    print('Debug print of sms entries:')
    for i = 1,table.getn(sms_entries) do
        print('i: ' .. i .. ', index: ' ..sms_entries[i].sms_index .. ',primary: ' .. sms_entries[i].sms_primary .. ',text: ' .. sms_entries[i].sms )
    end
end

msgreply = msg_if.lua_get_msg_in_reply()
                                           
--Generate html code
put(start_of_content)
if page_title ~= "Write message" then
    put('<table align=left border="'..border_on..'" width=90%>')
    --Print any error message
    put('<tr><td><p id="errortext">')
    put(error_msg .. '</p></td></tr>')

    put('<tr><td><p class="menutext">')
    if page_title == "Messages" then
        put(current_dictionary("new messages"))
    elseif page_title == "Inbox" then
        put(current_dictionary("inbox"))
    elseif page_title == "Outbox" then
        put(current_dictionary("outbox"))
    elseif page_title == "Sent" then
        put(current_dictionary("sent messages"))
    end

    if page_title == "Sent" then
        put('<p></td><td><p class="menutext">')
        put(current_dictionary("status"))
        put('<p></td>')
    end

    put('<p></td><td><p class="menutext">')
    put(current_dictionary("actions"))
    put('<p></td></tr>')

    --Main table of inbox
    for i = 1,table.getn(sms_entries) do
        --print normal entries
        if sms_entries[i].sms_primary == "primary" then
            put('<tr><td><p>' .. sms_entries[i].sms_number .. ' '.. translate_month_and_1970(sms_entries[i].sms_time) ..'</p></td></tr>') 
            put('<tr>')
            put('<td><p>' .. html_escape(sms_entries[i].sms) .. '</p></td>')
            if page_title == "Messages" then
                put('<td><p>')
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang ..'&amp;smsOP=move&amp;entryNU=' .. sms_entries[i].sms_index .. '">' .. current_dictionary("read") .. '</A>') 
                put('/')
                if msgreply == 0 then
                    put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang ..'&amp;smsOP=reply&amp;smsrec='.. sms_entries[i].sms_number ..'">' .. current_dictionary("reply") .. '</A>')
                else
                    put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang ..'&amp;smsOP=reply&amp;smsrec='.. sms_entries[i].sms_number ..'&amp;newsms=' .. url.escape(sms_entries[i].sms) .. '">' .. current_dictionary("reply") .. '</A>')
                end
                put('/')
                put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang .. '&amp;smsOP=forward&amp;newsms=' .. url.escape(sms_entries[i].sms) .. '">' .. current_dictionary("forward") .. '</A>')
                put('</p></td></tr>')
            elseif page_title == "Sent" then
                put('<td><p>')
                put(sms_report_text(sms_entries[i].sms_report))
                put('</p></td>')
                put('<td><p>')
                put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang ..'&amp;smsOP=resend&amp;smsrec=' .. sms_entries[i].sms_number .. '&amp;newsms=' .. url.escape(sms_entries[i].sms) .. '">' .. current_dictionary("resend") .. '</A>')
                put('/')
                put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang .. '&amp;smsOP=forward&amp;newsms=' .. url.escape(sms_entries[i].sms) .. '">' .. current_dictionary("forward") .. '</A>')
                put('/')
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang ..'&amp;smsOP=delete&amp;entryNU=' .. sms_entries[i].sms_index .. '">' .. current_dictionary("delete") .. '</A>') 
                put('</p></td></tr>')
            elseif page_title == "Inbox" then
                put('<td><p>')
                if msgreply == 0 then
                    put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang ..'&amp;smsOP=reply&amp;smsrec='.. sms_entries[i].sms_number ..'">' .. current_dictionary("reply") .. '</A>')            
                else
                    put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang ..'&amp;smsOP=reply&amp;smsrec='.. sms_entries[i].sms_number ..'&amp;newsms=' .. url.escape(sms_entries[i].sms) .. '">' .. current_dictionary("reply") .. '</A>')            
                end
                put('/')
                put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang .. '&amp;smsOP=forward&amp;newsms=' .. url.escape(sms_entries[i].sms) .. '">' .. current_dictionary("forward") .. '</A>')
                put('/')
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang ..'&amp;smsOP=delete&amp;entryNU=' .. sms_entries[i].sms_index .. '">' .. current_dictionary("delete") .. '</A>') 
                put('</p></td></tr>')
            elseif page_title == "Outbox" then
                put('<td><p>')
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang ..'&amp;smsOP=delete&amp;entryNU=' .. sms_entries[i].sms_index .. '">' .. current_dictionary("delete") .. '</A>') 
                put('/')                
                put('<A HREF="index.lua?pageID=Write message&amp;langID=' .. lang ..'&amp;smsOP=resend&amp;smsrec=' .. sms_entries[i].sms_number .. '&amp;newsms=' .. url.escape(sms_entries[i].sms) .. '">' .. current_dictionary("resend") .. '</A>')
                --put(sms_entries[i][1])
                put('</p></td></tr>')
            end
        end
    end
    --If the inbox/outbox/sent is empty
    if table.getn(sms_entries) == 0 then
        if page_title == "Messages" then
            put('<tr><td><p>(' .. current_dictionary("no messages to read") ..')</p></td><tr>')
        elseif page_title == "Outbox" then
            put('<tr><td><p>(' .. current_dictionary("the outbox is empty") ..')</p></td><tr>')
        elseif page_title == "Inbox" then
            put('<tr><td><p>(' .. current_dictionary("the inbox is empty") ..')</p></td><tr>')
        elseif page_title == "Sent" then
            put('<tr><td><p>(' .. current_dictionary("no sent messages stored") ..')</p></td><tr>')
        end
    end
    put('<tr><td><p>')
    --Reset link
    if page_title == "Messages" then
        link_generate (page_title, "&amp;smsOP=moveall", "mark all messages as read", "norm")
    elseif page_title == "Inbox" then
        link_generate (page_title, "&amp;smsOP=reset", "delete all entries in inbox", "norm")
    elseif page_title == "Outbox" then
        link_generate (page_title, "&amp;smsOP=reset", "delete all entries in outbox", "norm")
    elseif page_title == "Sent" then
        link_generate (page_title, "&amp;smsOP=reset", "delete all sent messages", "norm")
    end
    put('</p>')
    put('</td></tr></table>')
else
    put('<table align=left>')
    put('<form name="smsinput" method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;smsOP=send">') 
    --Print any error message
    put('<tr><td><p id="errortext">')
    put(error_msg .. '</p></td></tr>')

    put('<tr><td><p class="menutext">' .. current_dictionary("write new message") .. ':</p></td></tr>')
    put('<tr><td><p>')
    put('<!--' .. sms_ok .. '-->')
    if cgilua.cgi["smsOP"] ~= nil then
        put('<!--' .. cgilua.cgi["smsOP"] .. '-->')
    end
    if cgilua.cgi["newsms"] ~= nil then
        put('<!--' .. cgilua.cgi["newsms"] .. '-->')
    end
    if cgilua.cgi["smsrec"] ~= nil then
        put('<!--' .. cgilua.cgi["smsrec"] .. '-->')
    end  
    if sms_ok == "false" or cgilua.cgi["smsOP"] == "forward" or cgilua.cgi["smsOP"] == "resend" or cgilua.cgi["smsOP"] == "reply" then
        if cgilua.cgi["newsms"] ~= nil then
            put('<textarea name="newsms" cols=50 rows=6 onKeyUp="checkLength()">' .. cgilua.cgi["newsms"] ..'</textarea>')
        else
            put('<textarea name="newsms" cols=50 rows=6 onKeyUp="checkLength()"></textarea>')
        end
    else
        put('<textarea name="newsms" cols=50 rows=6 onKeyUp="checkLength()"></textarea>')
    end
    put('<td><p>')
    put('</p></td>')
    put('</p></td></tr>')
    put('<tr><td><p>')
    put(current_dictionary("please note that text over 160 characters will be sent "))
    put(current_dictionary("as multiple messages."))
    put('</p></td></tr>')
    put('<tr><td><p>')
    --put('<input type="text" name="test" value="default">')
    put(current_dictionary("this will be sent as") .. ' ')
    put('<input type="text" name="test" value="1" maxlength="3" size="3" READONLY>')
    --put('<input type="text" name="smslength" value="default">')
    put(' ' .. current_dictionary("message(s)"))
    put('</p></td></tr>')
    put('<tr><td>')
    if msg_if.lua_get_delivery_notification() == 0 then
        put_radio_button("std_vert", "del_not", "delivery notification", "yes", "no", "b")
    else
        put_radio_button("std_vert", "del_not", "delivery notification", "yes", "no", "a")
    end 
    --put(' ' ..current_dictionary("delivery notification") .. ': <input type="radio" name="del_not" value="yes">' .. current_dictionary("yes") .. '&nbsp;&nbsp;<input type="radio" name="del_not" value="no">' .. current_dictionary("no"))
    put('</td></tr>')
    --put('<tr><td><p>')
    --put("Please start international numbers with '+'")
    --put('</p></td></tr>')
    put('<tr><td><p>')
    put(current_dictionary("recipient") .. ': ')
    if sms_ok == "false" or cgilua.cgi["smsOP"] == "reply" or cgilua.cgi["smsOP"] == "resend" then
        if cgilua.cgi["smsrec"] ~= nil then
            put('<input name="smsrec" maxlength="30" size="30" value="' .. string.gsub(cgilua.cgi["smsrec"], " ", "+", 1) .. '">')
        end
    else
        put('<input name="smsrec" maxlength="30" size="30" value="">')-- .. current_dictionary("type or pick from below") .. '">')
    end
    put('     <input type=submit value="' .. current_dictionary("send") .. '">')
    put('</p></td></tr>')
    put('</form>')
    put('</table>')
    --Insert phone book here
    put('</table>')
end

put(end_of_content)
