--Get PABX data
pabx_data = {}
pabx_data['range_min'], pabx_data['range_max'], pabx_data['span'], pabx_data['align'] = msg_if.lua_get_sip_pabx_data()

-- check access permission
disabled_string = ''
allowed = true
if admin_status < 0 then
    allowed = msg_if.lua_get_user_permissions("change_sip")
    if not allowed then 
        disabled_string = ' disabled '
        error_msg = current_dictionary("admin_locked")
    end
end

--Make the IP Handset page
if cgilua.cgi['pageID'] == 'IP Handsets' then
    
    put(start_of_content)
    put('<p id="errortext">' .. error_msg .. '</p>\n')
    
    edit = false
    
    --Get Terminal vitals, we need the serial for use as SIP realm
    vitals = {}
    vitals['mac'], vitals['serial'], vitals['pcb'], vitals['imei'], vitals['mac_wlan'] = msg_if.lua_read_config_db_sysconf_info()
    
    --Get list of registered handsets and their IP
    sip_registered_users = msg_if.lua_get_sip_registered_users()
    
    --Parse URL
    if cgilua.cgi['voipOP'] ~= nil then
        if cgilua.cgi['voipOP'] == 'new' then
            --New Entry
            edit = 'new'
        elseif cgilua.cgi['voipOP'] == 'delete' then
            --Delete entry
            msg_if.lua_delete_sip_user(cgilua.cgi['number'])
        elseif cgilua.cgi['voipOP'] == 'edit' then
            --Edit Entry
            edit = 'edit'
        elseif cgilua.cgi['voipOP'] == 'update' then
            if cgilua.cgi['password'] ~= nil then
                --Update/Create Entry
                msg_if.lua_update_sip_user(cgilua.cgi['number'], cgilua.cgi['password'], vitals['serial'])
            end
        end
    end
    
    --Get SIP user data (number, realm (currently not used), password)
    count, sip_user_data_rsp = msg_if.lua_get_sip_user_data()
    sip_user_data = {}
    for i=0,count-1 do
        number = sip_user_data_rsp[i*3 + 1]
        sip_user_data[number] = {}
        sip_user_data[number]['realm'] = sip_user_data_rsp[i*3 + 2]
        sip_user_data[number]['password'] = sip_user_data_rsp[i*3 + 3]
    end
    
    --Generate HTML for start of table for handset numbers/passwords
    put('<p><table align="left" border="' .. border_on ..'" cellpadding="0">')
    put('<th align="center" width="7%"><p>' .. current_dictionary('entry') .. '</p></th>\n')
    put('<th align="center" width="20%"><p>' .. current_dictionary('number') .. '</p></th>\n')
    put('<th align="left" width="20%"><p>' .. current_dictionary('handset password') .. '</p></th>\n')
    put('<th align="center" width="20%"><p>' .. current_dictionary('actions') .. '</p></th>\n')
    put('<th align="center" width="20%"><p>' .. current_dictionary('configure handset') .. '</p></th>\n')
    
    --Generate a line for each number assigned to SIP
    --Skipping the first number, as this is the broadcast number
    j = 1;
    for i=pabx_data['range_min'] + 1,pabx_data['range_max'] do
        index = '0' .. string.format('%03d', i)
        put('<tr>')
        --Output the index
        put('<td align="center"><p>' .. j .. '</p></td>')
        j = j + 1;
        --If the current index has an entry
        if sip_user_data[index] then
            --If we are editing the current entry
            if (edit == 'edit' and cgilua.cgi['number'] == index) then
                put('<td align="center"><p>' .. index .. '</p></td>')
                put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;voipOP=update&amp;number=' .. index .. '">')
                put('<td align="center"><input type="text" name="password" maxlength="32" size="32" value="' .. sip_user_data[index]["password"] .. '"></td>')
                put('<td align="center"><input type="submit" value="' .. current_dictionary("save entry") .. '"></td>')
                put('</form>')
            else
                put('<td align="center"><p>' .. index .. '</p></td>')
                put('<td><p>' .. sip_user_data[index]['password'] .. '</p></td>')
                put('<td align="center"><p>')
                if allowed then
                    link_generate(page_title, '&amp;voipOP=edit&amp;number=' ..index, current_dictionary('edit'), 'direct')
                    put('/')
                    link_generate(page_title, '&amp;voipOP=delete&amp;number=' ..index, current_dictionary('delete'), 'direct')
                end
                put('</p></td>')
            end
        else --Allow for the creation of a new entry, or print nothing
            if (edit == 'new'  and cgilua.cgi['number'] == index) then
                put('<td align="center"><p>' .. index .. '</p></td>')
                put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;voipOP=update&amp;number=' .. index .. '">')
                put('<td align="center"><input type="text" name="password" maxlength="32" size="32"></td>')
                put('<td align="center"><input type="submit" value="' .. current_dictionary("save entry") .. '"></td>')
                put('</form>')
            else
                put('<td align="center"><p>' .. index .. '</p></td>')
                put('<td><p></p></td>')
                put('<td align="center"><p>')
                if allowed then
                    link_generate(page_title, '&amp;voipOP=new&amp;number=' ..index, current_dictionary('new'), 'direct')
                end
                put('</p></td>\n')
            end
        end
	
        --Make a link to the handset if there is one active with the current number
        if (sip_registered_users[index]) then
            put('<td align="center"><p><a href="http://' ..sip_registered_users[index].. '/" target="_blank">' ..current_dictionary('configure').. '</a></p></td>\n')
        else
            put('<td align="center"><p>' .. current_dictionary('not active') .. '</p></td>')
        end
        put('</tr>\n')
    end
    
    put('</table></p>\n')
    put(end_of_content)
    
    --Make the "call routing" page (might not be the right name)
elseif cgilua.cgi['pageID'] == 'Call Settings' then
    
    --Update settings
    if cgilua.cgi['voipOP'] == 'update' then
        for i=pabx_data['range_min'] + 1,pabx_data['range_max'] do
	    
            index = '0' .. string.format('%03d', i)
	        
			--if radio button is nil, it's because we've disabled it.
	        if (cgilua.cgi['radio' .. index]) ~= nil then
			
	            if (cgilua.cgi['checkbox_standard' .. index] == 'ON') then
	                set_in_standard = 1;
	            else
	                set_in_standard = 0;
	            end
	
	            if (cgilua.cgi['checkbox_3p1khzaudio' .. index] == 'ON') then
	                set_in_3p1khzaudio = 1;
	            else
	                set_in_3p1khzaudio = 0;
	            end
	
	            if (cgilua.cgi['radio' .. index] == '3p1khzaudio_ON') then
	                set_outgoing_call_type = 1;
	            elseif (cgilua.cgi['radio' .. index] == 'standard_ON') then
	                set_outgoing_call_type = 0;
	            end
	
	            msg_if.lua_set_sip_handset_status(i - pabx_data['range_min'], set_outgoing_call_type, set_in_standard, set_in_3p1khzaudio)

	        end
        end
    end
    
    --Generate HTML for call settings
    
    put(start_of_content)
    put('<p id="errortext">' .. error_msg .. '</p>')
    
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;voipOP=update">\n')
    put('<p><table align="left" border="' .. border_on .. '" cellpadding="0">\n')
    put('<th align="center"><p>' .. current_dictionary('number') .. '</p></th>\n')
    put('<th width="20"></th>\n')
    put('<th align="center" colspan=2><p>' .. current_dictionary('incoming calls') .. '</p></th>\n')
    put('<th width="20"></th>\n')
    put('<th align="center" colspan=2><p>' .. current_dictionary('outgoing calls') .. '</p></th>\n')
    
    for i=pabx_data['range_min'] + 1,pabx_data['range_max'] do
	
        --Get current values...
        outgoing_call_type, in_standard, in_3p1khz, in_not_specified = msg_if.lua_get_sip_handset_status(i - pabx_data['range_min'])
        
        if (in_not_specified) then
            disabled_not_created_str = ' disabled '
		else
            disabled_not_created_str = disabled_string
		end

        index = '0' .. string.format('%03d', i)
        
        --...and display them
        put('<tr>')
        put('<td align="center"><p>' .. index .. '</p></td>')
   	    put('<td></td>')

        put('<td align="right"><p><input ' .. disabled_not_created_str .. ' type="checkbox" name="checkbox_standard' .. index .. '" value="ON"')
        put(checked_text(in_standard).. '>' .. current_dictionary('standard') .. '</p></td>')

        put('<td align="left"><p><input ' .. disabled_not_created_str .. ' type="checkbox" name="checkbox_3p1khzaudio' .. index .. '" value="ON"')
	    put(checked_text(in_3p1khz) .. '>' .. current_dictionary('3.1kHz audio') .. '</p></td>')

	    put('<td></td>')

        put('<td align="right"><p><input ' .. disabled_not_created_str .. ' type="radio" name="radio' .. index .. '" value="3p1khzaudio_ON"')
        put(checked_text(not outgoing_call_type) .. '>' .. current_dictionary('standard') .. '</p></td>')
        
        put('<td align="left"><p><input ' .. disabled_not_created_str .. ' type="radio" name="radio' .. index .. '" value="standard_ON"')
        put(checked_text(outgoing_call_type) .. '>' .. current_dictionary('3.1kHz audio') .. '</p></td>')
        put('</tr>\n')
	
    end
    
    --Submit/cancel buttons
    put('<tr>')
    put('<td align="left" colspan="3"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
    put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>')
    put('</tr>\n')
    
    put('</table></p>\n')
    put('</form>\n')
    put(end_of_content)
    
end
