put(start_of_content)

local wlan_status_error_code = msg_if.lua_aero_wlan_get_wlan_ready_status()

if (wlan_status_error_code == 1) then
   	local error_msg = dict("wlan not ready")
	put('<p id="errortext">' .. error_msg .. '</p>')
   	put(end_of_content)
   	return
end

local region_codes = {}
local region_channels = {}

local ssid, broadcast_ssid, superag, autochannel, channel, encryption, wep_key_length, wep_key, region, wpa_mode, wpa_key, region_codes, region_channels, actual_channel = msg_if.lua_aero_wlan_get_wlan_setup()

trace(0, 1, string.format("lua - ssid = %s", ssid))
trace(0, 1, string.format("lua - broadcast_ssid = %d", broadcast_ssid))
trace(0, 1, string.format("lua - superag = %d", superag))
trace(0, 1, string.format("lua - autochannel = %d", autochannel))
trace(0, 1, string.format("lua - channel = %d", channel))
trace(0, 1, string.format("lua - encryption = %d", encryption))
trace(0, 1, string.format("lua - wep_key_length = %d", wep_key_length))
trace(0, 1, string.format("lua - wep_key = %s", wep_key))
trace(0, 1, string.format("lua - region = %d", region))
trace(0, 1, string.format("lua - wpa_mode = %d", wpa_mode))
trace(0, 1, string.format("lua - wpa_key = %s", wpa_key))
trace(0, 1, string.format("lua - actual_channel = %d", actual_channel))

local mac_filtering, mac1, mac2, mac3, mac4, mac5, mac6, mac7, mac8, mac9, mac10, mac11, mac12, mac13, mac14, mac15, mac16 = msg_if.lua_aero_wlan_get_mac_filters()

local function split(str)

	local t = {}

	local function helper(word)
  		table.insert(t, tonumber(word))
		return ""
	end

    local temp = string.gsub(str, "%w+", helper)
	if not string.find(temp, "%S") then 
		return t
	end
	
end

local security_list = {dict("none"), "WEP-40/64", "WEP-104/128", "WPA-AES", "WPA-2-AES"}

local region_channels_table = {}
local k, v
for k,v in pairs(region_channels) do
   	region_channels_table[k] = split(region_channels[k])
end

-- Kept here for reference only
--region_codes = {}
--region_codes[2] = "israel"
--region_codes[4] = "usa"
--region_codes[5] = "hong-kong"
--region_codes[6] = "canada"
--region_codes[7] = "australia"
----region_codes[10] = "france_outdoor"
--region_codes[14] = "europe"
--region_codes[17] = "japan"
--region_codes[18] = "singapore"
--region_codes[20] = "korea"

--region_channels = {}
--region_channels[2] = { 5, 6, 7, 8, 9, 10, 11, 12, 13 }
--region_channels[4] = { 1,2,3,4,5,6,7,8,9,10,11 }
--region_channels[5] = { 1,2,3,4,5,6,7,8,9,10,11,12,13 }
--region_channels[6] = { 1,2,3,4,5,6,7,8,9,10,11,12,13 }
--region_channels[7] = { 1,2,3,4,5,6,7,8,9,10,11,12,13 }
----region_channels[10] = {}
--region_channels[14] = { 1,2,3,4,5,6,7,8,9,10,11,12,13 } 
--region_channels[17] = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14 } 
--region_channels[18] = { 1,2,3,4,5,6,7,8,9,10,11,12,13 } 
--region_channels[20] = { 1,2,3,4,5,6,7,8,9,10,11,12,13 }

--Anything submitted/are we in write mode?
if cgilua.cgi['submit'] ~= nil then

	if cgilua.cgi["text_ssid"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[text_ssid] = %s", cgilua.cgi["text_ssid"]))
        trace(0, 1, string.format("lua - ssid (old) = %s, type (old) = %s", ssid, type(ssid)))
        ssid = cgilua.cgi["text_ssid"]
        trace(0, 1, string.format("lua - ssid (new) = %s, type (new) = %s", ssid, type(ssid)))
    end
    
    if cgilua.cgi["radio_ssid"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[radio_ssid] = %s", cgilua.cgi["radio_ssid"]))
        trace(0, 1, string.format("lua - broadcast_ssid (old) = %s, type (old) = %s", broadcast_ssid, type(broadcast_ssid)))
        if cgilua.cgi["radio_ssid"] == "enabled" then
            broadcast_ssid = 1
        else
            broadcast_ssid = 0
        end
        trace(0, 1, string.format("lua - broadcast_ssid (new) = %s, type (new) = %s", broadcast_ssid, type(broadcast_ssid)))
    end
    
    if cgilua.cgi["country_code"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[country_code] = %d", cgilua.cgi["country_code"]))
        trace(0, 1, string.format("lua - region (old) = %s, type (old) = %s", region, type(region)))
        region = tonumber(cgilua.cgi["country_code"])
        trace(0, 1, string.format("lua - region (new) = %s, type (new) = %s", region, type(region)))
	end
    
    if cgilua.cgi["radio_autochannel"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[radio_autochannel] = %d", cgilua.cgi["radio_autochannel"]))
        trace(0, 1, string.format("lua - autochannel (old) = %s, type (old) = %s", autochannel, type(autochannel)))
        autochannel = tonumber(cgilua.cgi["radio_autochannel"])
        trace(0, 1, string.format("lua - autochannel (new) = %s, type (new) = %s", autochannel, type(autochannel)))
	end

    if cgilua.cgi["channel_list"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[channel_list] = %d", cgilua.cgi["channel_list"]))
        trace(0, 1, string.format("lua - channel (old) = %s, type (old) = %s", channel, type(channel)))
        channel = tonumber(cgilua.cgi["channel_list"])
        trace(0, 1, string.format("lua - channel (new) = %s, type (new) = %s", channel, type(channel)))
	end

    if cgilua.cgi["security_code"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[security_code] = %d", cgilua.cgi["security_code"]))
        trace(0, 1, string.format("lua - encryption (old) = %s, type (old) = %s", encryption, type(encryption)))
        local temp = tonumber(cgilua.cgi["security_code"])
        if (temp == 0) then
			encryption = 1
		end
        if (temp == 1) then
			encryption = 2
			wep_key_length = 64
		end
        if (temp == 2) then
			encryption = 2
			wep_key_length = 128 
		end
        if (temp == 3) then
			encryption = 3
			wpa_mode = 1
		end
        if (temp == 4) then
			encryption = 3
			wpa_mode = 2
		end
        trace(0, 1, string.format("lua - encryption (new) = %s, type (new) = %s", encryption, type(encryption)))
	end

    if cgilua.cgi["text_key"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[text_key] = %s", cgilua.cgi["text_key"]))
        trace(0, 1, string.format("lua - wep_key (old) = %s, type (old) = %s", wep_key, type(wep_key)))
        trace(0, 1, string.format("lua - wpa_key (old) = %s, type (old) = %s", wpa_key, type(wpa_key)))
        trace(0, 1, string.format("lua - cgilua.cgi[security_code] = %d", cgilua.cgi["security_code"]))
		if (tonumber(cgilua.cgi["security_code"]) == 1) then
			wep_key = tostring(cgilua.cgi["text_key"])
		end
		if (tonumber(cgilua.cgi["security_code"]) == 2) then
			wep_key = tostring(cgilua.cgi["text_key"])
		end
		if (tonumber(cgilua.cgi["security_code"]) == 3) then
			wpa_key = tostring(cgilua.cgi["text_key"])
		end
		if (tonumber(cgilua.cgi["security_code"]) == 4) then
			wpa_key = tostring(cgilua.cgi["text_key"])
		end
        trace(0, 1, string.format("lua - wep_key (new) = %s, type (new) = %s", wep_key, type(wep_key)))
        trace(0, 1, string.format("lua - wpa_key (new) = %s, type (new) = %s", wpa_key, type(wpa_key)))
	end

	if cgilua.cgi["radio_filter"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[radio_filter] = %s", cgilua.cgi["radio_filter"]))
        trace(0, 1, string.format("lua - mac_filtering (old) = %s, type (old) = %s", mac_filtering, type(mac_filtering)))
        if (cgilua.cgi["radio_filter"] == "enabled") then
            mac_filtering = 1
		else
		    mac_filtering = 0
		end
        trace(0, 1, string.format("lua - mac_filtering (new) = %s, type (new) = %s", mac_filtering, type(mac_filtering)))
	end

	--Apply submitted changes
    msg_if.lua_aero_wlan_set_wlan_setup(ssid, broadcast_ssid, region, autochannel, channel, encryption, wep_key_length, wpa_mode, wep_key, wpa_key, mac_filtering)

	if (mac_filtering == 1) then
	   	mac1 = string.upper(cgilua.cgi["text_mac1"]);
	   	mac2 = string.upper(cgilua.cgi["text_mac2"]);
	   	mac3 = string.upper(cgilua.cgi["text_mac3"]);
	   	mac4 = string.upper(cgilua.cgi["text_mac4"]);
	   	mac5 = string.upper(cgilua.cgi["text_mac5"]);
	   	mac6 = string.upper(cgilua.cgi["text_mac6"]);
	   	mac7 = string.upper(cgilua.cgi["text_mac7"]);
	   	mac8 = string.upper(cgilua.cgi["text_mac8"]);
	   	mac9 = string.upper(cgilua.cgi["text_mac9"]);
	   	mac10 = string.upper(cgilua.cgi["text_mac10"]);
	   	mac11 = string.upper(cgilua.cgi["text_mac11"]);
	   	mac12 = string.upper(cgilua.cgi["text_mac12"]);
	   	mac13 = string.upper(cgilua.cgi["text_mac13"]);
	   	mac14 = string.upper(cgilua.cgi["text_mac14"]);
	   	mac15 = string.upper(cgilua.cgi["text_mac15"]);
	   	mac16 = string.upper(cgilua.cgi["text_mac16"]);
	   	
	   	msg_if.lua_aero_wlan_set_mac_filters(mac1, mac2, mac3, mac4, mac5, mac6, mac7, mac8, mac9, mac10, mac11, mac12, mac13, mac14, mac15, mac16);
	end

end

if (encryption == 1) then security_mode = 0 end --none
if ((encryption == 2) and (wep_key_length == 64)) then security_mode = 1 end
if ((encryption == 2) and (wep_key_length == 128)) then security_mode = 2 end
if ((encryption == 3) and (wpa_mode == 1)) then security_mode = 3 end
if ((encryption == 3) and (wpa_mode == 2)) then security_mode = 4 end
if (security_mode ~= nil) then
	trace(0, 1, string.format("lua - security_mode = %s", security_mode))
end

if (security_mode == 0) then key = ''
elseif (security_mode == 1) then key = wep_key 
elseif (security_mode == 2) then key = wep_key
elseif (security_mode == 3) then key = wpa_key
elseif (security_mode == 4) then key = wpa_key end

put(start_of_content)

--Make dynamically generated javascript
local js_fs1 = '<script type="text/javascript">\n\n' ..
	'var hexadecimalText = "' .. dict('hexadecimal') .. '"\n' ..
	'var textText = "' .. dict('text') .. '"\n' ..
	'var encryptionKeyText = "' .. dict('encryption key') .. '"\n' ..
	'var actualChannel = ' .. actual_channel .. '\n\n' ..
	'var Regions = new Array();\n' ..
	'var Channels = new Array();\n\n' ..
	'Regions = ['
for k, v in pairs(region_codes) do
	js_fs1 = js_fs1 .. k .. ', '
end
js_fs1 = string.sub(js_fs1, 1, -3) -- trim surplus ', '
js_fs1 = js_fs1 .. '];\n\n'
for k1, v1 in pairs(region_codes) do
   	js_fs1 = js_fs1 .. 'Channels[' .. k1 .. '] = ['
	for k2, v2 in pairs(region_channels_table[k1]) do
		js_fs1 = js_fs1 .. '"' .. v2 .. '", '
	end
	js_fs1 = string.sub(js_fs1, 1, -3) -- trim surplus ', '
   	js_fs1 = js_fs1 .. '];\n'
end

--Static javascript
local js_fs2 = [[

    function disableChannelSelection(visible)
    {
    	document.settings_interfaces.channel_list.disabled=visible;
	}

	function updateChannelsOnRegionChange(selectedRegion)
	{
	    if (selectedRegion >= 0)
	    document.settings_interfaces.channel_list.length = 0;
	    {
			for (i = 0; i < Channels[Regions[selectedRegion] ].length; i++)
			{
			    document.settings_interfaces.channel_list.options[i] =
				new Option(Channels[Regions[selectedRegion] ][i],
				Channels[Regions[selectedRegion] ][i], false, false);
			}
			//First one is selected as default...
			document.settings_interfaces.channel_list[0].selected = true;
	    }
	}

	function updateKeyParametersOnEncryptionChange(selectedEncryption)
	{
	 	if (selectedEncryption >= 0)
	 	{
	 		var text1 = document.getElementById("encryption_encoding");
	 	 	switch(selectedEncryption)
	 	 	{
	 	 	 	case 0:
	 	 	 		document.settings_interfaces.text_key.disabled = true;
   					text1.firstChild.nodeValue = encryptionKeyText;
					break;
	 	 	 	case 1:
	 	 	 		document.settings_interfaces.text_key.disabled = false;
	 	 	 		document.settings_interfaces.text_key.size = 10;
	 	 	 		document.settings_interfaces.text_key.maxLength = 10;
   					text1.firstChild.nodeValue = encryptionKeyText + " (" + hexadecimalText + ")";
					break;
	 	 	 	case 2:
	 	 	 		document.settings_interfaces.text_key.disabled = false;
	 	 	 		document.settings_interfaces.text_key.size = 26;
	 	 	 		document.settings_interfaces.text_key.maxLength = 26;
   					text1.firstChild.nodeValue = encryptionKeyText + " (" + hexadecimalText + ")";
					break;
	 	 	 	case 3:
	 	 	 	case 4:
	 	 	 		document.settings_interfaces.text_key.disabled = false;
	 	 	 		document.settings_interfaces.text_key.size = 64;
	 	 	 		document.settings_interfaces.text_key.maxLength = 64;
   					text1.firstChild.nodeValue = encryptionKeyText + " (" + textText + ")";
				break;
	 	 	}
	 	}
	}
	
	function disableMacFields(visible)
	{
	 	document.settings_interfaces.text_mac1.disabled = visible;
	 	document.settings_interfaces.text_mac2.disabled = visible;
	 	document.settings_interfaces.text_mac3.disabled = visible;
	 	document.settings_interfaces.text_mac4.disabled = visible;
	 	document.settings_interfaces.text_mac5.disabled = visible;
	 	document.settings_interfaces.text_mac6.disabled = visible;
	 	document.settings_interfaces.text_mac7.disabled = visible;
	 	document.settings_interfaces.text_mac8.disabled = visible;
	 	document.settings_interfaces.text_mac9.disabled = visible;
	 	document.settings_interfaces.text_mac10.disabled = visible;
	 	document.settings_interfaces.text_mac11.disabled = visible;
	 	document.settings_interfaces.text_mac12.disabled = visible;
	 	document.settings_interfaces.text_mac13.disabled = visible;
	 	document.settings_interfaces.text_mac14.disabled = visible;
	 	document.settings_interfaces.text_mac15.disabled = visible;
	 	document.settings_interfaces.text_mac16.disabled = visible;
	}

	function checkEncryptionKeyAndSSIDAndMacs(form, to_short, to_long, correct, not_hex, not_supported, invalid_ssid, invalid_mac)
	{
    	if (form.text_ssid.value.length < 1 || form.text_ssid.value.length > 32)
    	{
    		alert(invalid_ssid);
    	 	return false;
    	}

		switch (form.security_code.selectedIndex)
		{
		case 0: //No encryption
		    if (form.text_key.value != "")
		    {
		        alert(not_supported);
                form.text_key.focus();
                return false;
		    }
		break;
		case 1: //WEP40/64
			if (form.text_key.value.length > 10)
			{
			    alert(to_long+correct+"10.");
                form.text_key.focus();
                return false;
			}
			if (form.text_key.value.length < 10)
			{
			    alert(to_short+correct+"10.");
                form.text_key.focus();
                return false;
			}
            for (var i = 0;i < form.text_key.value.length; i++)
            {
            	switch (form.text_key.value.charAt(i)) {
                case "0":
                case "1":
                case "2":
                case "3":
                case "4":
                case "5":
                case "6":
                case "7":
                case "8":
                case "9":
                case "a":
                case "b":
                case "c":
                case "d":
                case "e":
                case "f":
                case "A":
                case "B":
                case "C":
                case "D":
                case "E":
                case "F":
                    break;
                default:
                    alert(not_hex);
                    form.text_key.focus();
                    return false;
                }
            }
		break;
		case 2: //WEP104/128
			if (form.text_key.value.length > 26)
			{
			    alert(to_long+correct+"26.");
                form.text_key.focus();
                return false;
			}
			if (form.text_key.value.length < 26)
			{
			    alert(to_short+correct+"26.");
                form.text_key.focus();
                return false;
			}
            for (var i = 0;i < form.text_key.value.length; i++)
            {
            	switch (form.text_key.value.charAt(i)) {
                case "0":
                case "1":
                case "2":
                case "3":
                case "4":
                case "5":
                case "6":
                case "7":
                case "8":
                case "9":
                case "a":
                case "b":
                case "c":
                case "d":
                case "e":
                case "f":
                case "A":
                case "B":
                case "C":
                case "D":
                case "E":
                case "F":
                    break;
                default:
                    alert(not_hex);
                    form.text_key.focus();
                    return false;
                }
            }
		break;
		case 3: //WPA
		case 4: //WPA2
			if (form.text_key.value.length > 64)
			{
			    alert(to_long+correct+"64.");
                form.text_key.focus();
                return false;
			}
			if (form.text_key.value.length < 8)
			{
			    alert(to_short+correct+"8.");
                form.text_key.focus();
                return false;
			}
		break;
		}
		
		if (form.radio_filter.value == "enabled")
		{
			alert("radio filter enabled");
		}
		
		var macPat = new RegExp("^[0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}$");
		
		if (form.radio_filter[0].checked == true)
		{
			if (! (form.text_mac1.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac1.focus();
			 	return false;
			}
			if (! (form.text_mac2.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac2.focus();
			 	return false;
			}
			if (! (form.text_mac3.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac3.focus();
			 	return false;
			}
			if (! (form.text_mac4.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac4.focus();
			 	return false;
			}
			if (! (form.text_mac5.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac5.focus();
			 	return false;
			}
			if (! (form.text_mac6.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac6.focus();
			 	return false;
			}
			if (! (form.text_mac7.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac7.focus();
			 	return false;
			}
			if (! (form.text_mac8.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac8.focus();
			 	return false;
			}
			if (! (form.text_mac9.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac9.focus();
			 	return false;
			}
			if (! (form.text_mac10.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac10.focus();
			 	return false;
			}
			if (! (form.text_mac11.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac11.focus();
			 	return false;
			}
			if (! (form.text_mac12.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac12.focus();
			 	return false;
			}
			if (! (form.text_mac13.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac13.focus();
			 	return false;
			}
			if (! (form.text_mac14.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac14.focus();
			 	return false;
			}
			if (! (form.text_mac15.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac15.focus();
			 	return false;
			}
			if (! (form.text_mac16.value.match(macPat)))
			{
				alert(invalid_mac);
				form.text_mac16.focus();
			 	return false;
			}
		}

		return true;
	}

    </script>
]]

put(js_fs1)
put(js_fs2)

local to_long = dict("to long")
local to_short = dict("to short")
local correct_length = dict("correct")
local not_hex = dict("not hex")
local not_supported = dict("not supported")
local invalid_ssid = dict("invalid ssid")
local invalid_mac = dict("invalid mac")
local submit_text = 'onsubmit="return checkEncryptionKeyAndSSIDAndMacs(this,\''..to_short..'\',\''..to_long..'\',\''..correct_length..'\',\''..not_hex..'\',\''..not_supported..'\',\''..invalid_ssid..'\', \'' .. invalid_mac .. '\');"'

local disabled_string = ''

put('<p><table border="'..border_on..'" cellpadding="0" align="left" valign="top">\n')
    put('<form name="settings_interfaces" method="post" ' .. submit_text .. ' action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')

    put('<tr>\n')
        put('<th align="left"><p class="menutext">' ..dict("interface status").. '</p></th>\n')
    put('</tr>\n')
    
    put('<tr>\n')
        put('<td align="left"><p>' ..dict("broadcast ssid") .. '</p></td>\n')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_ssid" value="enabled" ' ..checked_text(broadcast_ssid == 1).. '>' .. dict("enabled") .. '\n')
        put('<input ' .. disabled_string .. ' type="radio" name="radio_ssid" value="disabled" ' ..checked_text(broadcast_ssid == 0).. '>' .. dict("disabled") .. '</p></td>\n')
    put('</tr>\n')

    put('<tr>\n')
        put('<td align="left"><p>' ..dict("ssid") .. '</p></td>\n')
        put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="32" name="text_ssid" value="' .. ssid .. '" size="32"></p></td>\n')
    put('</tr>\n')

    put('<tr>\n')
        put('<td align="left"><p>' ..dict("country") .. '</p></td>\n')
        put('<td align="left" colspan="2"><select onchange="updateChannelsOnRegionChange(this.selectedIndex)" onclick="updateChannelsOnRegionChange(this.selectedIndex)" ' .. disabled_string .. '  size="5" name="country_code">\n')
        for k,v in pairs(region_codes) do
            put('<option ' ..selected_text(k == region).. ' value="' .. k .. '">' .. dict(region_codes[k]) .. '</option>\n')
        end
    put('</tr>\n')

    put('<tr>\n')
        put('<td align="left"><p>' ..dict("autochannel") .. '&nbsp&nbsp&nbsp&nbsp</p></td>\n')
        put('<td align="left"><p><input type="radio" name="radio_autochannel" value="1" ' ..checked_text(autochannel == 1).. ' onclick="disableChannelSelection(true)"' .. '>' .. dict("enabled") .. '\n')
        put('<input type="radio" name="radio_autochannel" value="0" ' ..checked_text(autochannel == 0).. ' onclick="disableChannelSelection(false)"' .. '>' .. dict("disabled") .. '</p></td>\n')
    put('</tr>\n')

    put('<tr>\n')
        put('<td align="left"><p>' ..dict("channel") .. '</p></td>\n')
        if (autochannel == 1) then
	        put('<td align="left" colspan="2"><select disabled="disabled" size="5" name="channel_list">\n')
	    else
	        put('<td align="left" colspan="2"><select size="5" name="channel_list">\n')
	    end
	    for k, v in pairs(region_channels_table[region]) do
	        put('<option'.. selected_text(v == channel) .. '>' .. v .. '</option>\n')
		end
    put('</tr>')

    put('<tr>')
        put('<td align="left"><p>' ..dict("security") .. '</p></td>')
        put('<td align="left" colspan="2"><select ' .. disabled_string .. '  size="5" name="security_code" onchange="updateKeyParametersOnEncryptionChange(this.selectedIndex)" onclick="updateKeyParametersOnEncryptionChange(this.selectedIndex)">')
        for i = 1,table.getn(security_list) do
            put('<option value="'.. i-1 ..'" ' ..selected_text((security_mode) == i-1).. '>' .. security_list[i] .. '</option>\n')
        end
    put('</tr>')

    put('<tr>')
    	if (security_mode == 0) then encoding = '' end
    	if ((security_mode == 1) or (security_mode == 2)) then encoding = '(' .. dict("hexadecimal") .. ')' end
    	if ((security_mode == 3) or (security_mode == 4)) then encoding = '(' .. dict("text") .. ')' end
        put('<td align="left"><p ID="encryption_encoding">' ..dict("encryption key") .. ' ' .. encoding .. '</p></td>')
        local key_field_size
        local key
		if (security_mode == 0) then
			disabled_string = 'disabled="true"'
			key_field_size = 10
			key = ''
		end 
        if (security_mode == 1) then
			key_field_size = 10
			key = wep_key
		end
        if (security_mode == 2) then
			key_field_size = 26
			key = wep_key
		end
        if ((security_mode == 3) or (security_mode == 4)) then
			key_field_size = 64
			key = wpa_key
		end 
        put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="' .. key_field_size .. '" name="text_key" size="' .. key_field_size .. '" value="' .. key .. '"></p></td>\n')
        disabled_string = ''
    put('</tr>')

    put('<tr>')
        put('<td align="left"><p>' ..dict("mac address filter") .. '</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_filter" value="enabled"' .. checked_text(mac_filtering == 1).. 'onclick="disableMacFields(false)" ' ..checked_text(filter_mode == 1).. '>' .. dict("enabled") .. '\n')
        put('<input ' .. disabled_string .. ' type="radio" name="radio_filter" value="disabled" ' .. checked_text(mac_filtering == 0).. ' onclick="disableMacFields(true)" ' ..checked_text(filter_mode == 0).. '>' .. dict("disabled") .. '</p></td>\n')
    put('</tr>')
    if (mac_filtering == 0) then disabled_string = 'disabled="true"' end
    put('<tr>')
        put('<td align="left"><p>' ..dict("allowed mac address") ..'</p></td>')
        put('<td align="left" width="400"><p>')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac1 ..'" maxlength="17" name="text_mac1" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac2 ..'" maxlength="17" name="text_mac2" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac3 ..'" maxlength="17" name="text_mac3" size="21">')
        put('</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p></p></td>')
        put('<td align="left" width="400"><p>')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac4 ..'" maxlength="17" name="text_mac4" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac5 ..'" maxlength="17" name="text_mac5" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac6 ..'" maxlength="17" name="text_mac6" size="21">')
        put('</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p></p></td>')
        put('<td align="left" width="400"><p>')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac7 ..'" maxlength="17" name="text_mac7" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac8 ..'" maxlength="17" name="text_mac8" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac9 ..'" maxlength="17" name="text_mac9" size="21">')
        put('</p></td>\n')
    put('</tr>')
    put('<tr>')
	    put('<td align="left"><p></p></td>')
    	put('<td align="left" width="400"><p>')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac10 ..'" maxlength="17" name="text_mac10" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac11 ..'" maxlength="17" name="text_mac11" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac12 ..'" maxlength="17" name="text_mac12" size="21">')
        put('</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p></p></td>')
        put('<td align="left" width="400"><p>')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac13 ..'" maxlength="17" name="text_mac13" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac14 ..'" maxlength="17" name="text_mac14" size="21">&nbsp;')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac15 ..'" maxlength="17" name="text_mac15" size="21">')
        put('</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p></p></td>')
        put('<td align="left" width="400"><p>')
        put('<input ' .. disabled_string .. ' type="text" value="'.. mac16 ..'" maxlength="17" name="text_mac16" size="21">')
        put('</p></td>\n')
    put('</tr>')

	disabled_string = ''

    --submit button
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. dict("apply") .. '">')
        put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. dict("cancel") .. '"></p></td>\n')
    put('</tr>')

	put('</form></table></p>\n')

put(end_of_content)